#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_f0gp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (f0|gp) integrals */

void d12hrr_order_f0gp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][5][11] = int_stack + 0;
 Libderiv->deriv_classes[3][5][10] = int_stack + 210;
 Libderiv->deriv_classes[3][5][9] = int_stack + 420;
 Libderiv->deriv_classes[3][5][8] = int_stack + 630;
 Libderiv->deriv_classes[3][5][7] = int_stack + 840;
 Libderiv->dvrr_classes[3][4] = int_stack + 1050;
 Libderiv->deriv_classes[3][5][6] = int_stack + 1200;
 Libderiv->deriv_classes[3][5][2] = int_stack + 1410;
 Libderiv->deriv_classes[3][5][1] = int_stack + 1620;
 Libderiv->deriv_classes[3][5][0] = int_stack + 1830;
 Libderiv->deriv2_classes[3][4][143] = int_stack + 2040;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 2190;
 Libderiv->deriv2_classes[3][4][131] = int_stack + 2400;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 2550;
 Libderiv->deriv2_classes[3][4][130] = int_stack + 2760;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 2910;
 Libderiv->deriv2_classes[3][4][119] = int_stack + 3120;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 3270;
 Libderiv->deriv2_classes[3][4][118] = int_stack + 3480;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 3630;
 Libderiv->deriv2_classes[3][4][117] = int_stack + 3840;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 3990;
 Libderiv->deriv2_classes[3][4][107] = int_stack + 4200;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 4350;
 Libderiv->deriv2_classes[3][4][106] = int_stack + 4560;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 4710;
 Libderiv->deriv2_classes[3][4][105] = int_stack + 4920;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 5070;
 Libderiv->deriv2_classes[3][4][104] = int_stack + 5280;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 5430;
 Libderiv->deriv2_classes[3][4][95] = int_stack + 5640;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 5790;
 Libderiv->deriv2_classes[3][4][94] = int_stack + 6000;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 6150;
 Libderiv->deriv2_classes[3][4][93] = int_stack + 6360;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 6510;
 Libderiv->deriv2_classes[3][4][92] = int_stack + 6720;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 6870;
 Libderiv->deriv2_classes[3][4][91] = int_stack + 7080;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 7230;
 Libderiv->deriv_classes[3][4][11] = int_stack + 7440;
 Libderiv->deriv2_classes[3][4][83] = int_stack + 7590;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 7740;
 Libderiv->deriv_classes[3][4][10] = int_stack + 7950;
 Libderiv->deriv2_classes[3][4][82] = int_stack + 8100;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 8250;
 Libderiv->deriv_classes[3][4][9] = int_stack + 8460;
 Libderiv->deriv2_classes[3][4][81] = int_stack + 8610;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 8760;
 Libderiv->deriv_classes[3][4][8] = int_stack + 8970;
 Libderiv->deriv2_classes[3][4][80] = int_stack + 9120;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 9270;
 Libderiv->deriv_classes[3][4][7] = int_stack + 9480;
 Libderiv->deriv2_classes[3][4][79] = int_stack + 9630;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 9780;
 Libderiv->deriv_classes[3][4][6] = int_stack + 9990;
 Libderiv->deriv2_classes[3][4][78] = int_stack + 10140;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 10290;
 Libderiv->deriv2_classes[3][4][35] = int_stack + 10500;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 10650;
 Libderiv->deriv2_classes[3][4][34] = int_stack + 10860;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 11010;
 Libderiv->deriv2_classes[3][4][33] = int_stack + 11220;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 11370;
 Libderiv->deriv2_classes[3][4][32] = int_stack + 11580;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 11730;
 Libderiv->deriv2_classes[3][4][31] = int_stack + 11940;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 12090;
 Libderiv->deriv_classes[3][4][2] = int_stack + 12300;
 Libderiv->deriv2_classes[3][4][30] = int_stack + 12450;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 12600;
 Libderiv->deriv2_classes[3][4][26] = int_stack + 12810;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 12960;
 Libderiv->deriv2_classes[3][4][23] = int_stack + 13170;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 13320;
 Libderiv->deriv2_classes[3][4][22] = int_stack + 13530;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 13680;
 Libderiv->deriv2_classes[3][4][21] = int_stack + 13890;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 14040;
 Libderiv->deriv2_classes[3][4][20] = int_stack + 14250;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 14400;
 Libderiv->deriv2_classes[3][4][19] = int_stack + 14610;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 14760;
 Libderiv->deriv_classes[3][4][1] = int_stack + 14970;
 Libderiv->deriv2_classes[3][4][18] = int_stack + 15120;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 15270;
 Libderiv->deriv2_classes[3][4][14] = int_stack + 15480;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 15630;
 Libderiv->deriv2_classes[3][4][13] = int_stack + 15840;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 15990;
 Libderiv->deriv2_classes[3][4][11] = int_stack + 16200;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 16350;
 Libderiv->deriv2_classes[3][4][10] = int_stack + 16560;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 16710;
 Libderiv->deriv2_classes[3][4][9] = int_stack + 16920;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 17070;
 Libderiv->deriv2_classes[3][4][8] = int_stack + 17280;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 17430;
 Libderiv->deriv2_classes[3][4][7] = int_stack + 17640;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 17790;
 Libderiv->deriv_classes[3][4][0] = int_stack + 18000;
 Libderiv->deriv2_classes[3][4][6] = int_stack + 18150;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 18300;
 Libderiv->deriv2_classes[3][4][2] = int_stack + 18510;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 18660;
 Libderiv->deriv2_classes[3][4][1] = int_stack + 18870;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 19020;
 Libderiv->deriv2_classes[3][4][0] = int_stack + 19230;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 19380;
 memset(int_stack,0,156720);

 Libderiv->dvrr_stack = int_stack + 24990;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_f0gp(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+19590,int_stack+0,int_stack+7440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1050,10);
     Libderiv->ABCD[11] = int_stack + 19590;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20040,int_stack+210,int_stack+7950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1050, 0.0, zero_stack,10);
     Libderiv->ABCD[10] = int_stack + 20040;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20490,int_stack+420,int_stack+8460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1050, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[9] = int_stack + 20490;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+630,int_stack+8970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20940,int_stack+840,int_stack+9480, 0.0, zero_stack, 1.0, int_stack+1050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[7] = int_stack + 20940;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+450,int_stack+1200,int_stack+9990, 1.0, int_stack+1050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[6] = int_stack + 450;
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+900,int_stack+1410,int_stack+12300,10);
     Libderiv->ABCD[2] = int_stack + 900;
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+21390,int_stack+1620,int_stack+14970,10);
     Libderiv->ABCD[1] = int_stack + 21390;
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+1830,int_stack+18000,10);
     Libderiv->ABCD[0] = int_stack + 1350;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21840,int_stack+2190,int_stack+2040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7440,10);
     Libderiv->ABCD[155] = int_stack + 21840;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1800,int_stack+2550,int_stack+2400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7440, 1.0, int_stack+7950,10);
     Libderiv->ABCD[143] = int_stack + 1800;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2250,int_stack+2910,int_stack+2760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7950, 0.0, zero_stack,10);
     Libderiv->ABCD[142] = int_stack + 2250;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22290,int_stack+3270,int_stack+3120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7440, 0.0, zero_stack, 1.0, int_stack+8460,10);
     Libderiv->ABCD[131] = int_stack + 22290;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2700,int_stack+3630,int_stack+3480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7950, 1.0, int_stack+8460, 0.0, zero_stack,10);
     Libderiv->ABCD[130] = int_stack + 2700;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3150,int_stack+3990,int_stack+3840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8460, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[129] = int_stack + 3150;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3600,int_stack+4350,int_stack+4200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8970,10);
     Libderiv->ABCD[119] = int_stack + 3600;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4050,int_stack+4710,int_stack+4560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7950, 0.0, zero_stack, 1.0, int_stack+8970, 0.0, zero_stack,10);
     Libderiv->ABCD[118] = int_stack + 4050;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22740,int_stack+5070,int_stack+4920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8460, 1.0, int_stack+8970, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[117] = int_stack + 22740;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4500,int_stack+5430,int_stack+5280, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[116] = int_stack + 4500;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4950,int_stack+5790,int_stack+5640, 0.0, zero_stack, 1.0, int_stack+7440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9480,10);
     Libderiv->ABCD[107] = int_stack + 4950;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5400,int_stack+6150,int_stack+6000, 0.0, zero_stack, 1.0, int_stack+7950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9480, 0.0, zero_stack,10);
     Libderiv->ABCD[106] = int_stack + 5400;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5850,int_stack+6510,int_stack+6360, 0.0, zero_stack, 1.0, int_stack+8460, 0.0, zero_stack, 1.0, int_stack+9480, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[105] = int_stack + 5850;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+23190,int_stack+6870,int_stack+6720, 0.0, zero_stack, 1.0, int_stack+8970, 1.0, int_stack+9480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[104] = int_stack + 23190;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6300,int_stack+7230,int_stack+7080, 0.0, zero_stack, 2.0, int_stack+9480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[103] = int_stack + 6300;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6750,int_stack+7740,int_stack+7590, 1.0, int_stack+7440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9990,10);
     Libderiv->ABCD[95] = int_stack + 6750;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7200,int_stack+8250,int_stack+8100, 1.0, int_stack+7950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9990, 0.0, zero_stack,10);
     Libderiv->ABCD[94] = int_stack + 7200;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7650,int_stack+8760,int_stack+8610, 1.0, int_stack+8460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9990, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[93] = int_stack + 7650;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8100,int_stack+9270,int_stack+9120, 1.0, int_stack+8970, 0.0, zero_stack, 1.0, int_stack+9990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[92] = int_stack + 8100;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8550,int_stack+9780,int_stack+9630, 1.0, int_stack+9480, 1.0, int_stack+9990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[91] = int_stack + 8550;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9000,int_stack+10290,int_stack+10140, 2.0, int_stack+9990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[90] = int_stack + 9000;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9450,int_stack+10650,int_stack+10500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12300,10);
     Libderiv->ABCD[47] = int_stack + 9450;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9900,int_stack+11010,int_stack+10860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12300, 0.0, zero_stack,10);
     Libderiv->ABCD[46] = int_stack + 9900;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+10350,int_stack+11370,int_stack+11220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12300, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[45] = int_stack + 10350;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+10800,int_stack+11730,int_stack+11580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[44] = int_stack + 10800;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11250,int_stack+12090,int_stack+11940, 0.0, zero_stack, 1.0, int_stack+12300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[43] = int_stack + 11250;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11700,int_stack+12600,int_stack+12450, 1.0, int_stack+12300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[42] = int_stack + 11700;
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+12150,int_stack+12960,int_stack+12810,10);
     Libderiv->ABCD[38] = int_stack + 12150;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12600,int_stack+13320,int_stack+13170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14970,10);
     Libderiv->ABCD[35] = int_stack + 12600;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13050,int_stack+13680,int_stack+13530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14970, 0.0, zero_stack,10);
     Libderiv->ABCD[34] = int_stack + 13050;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+23640,int_stack+14040,int_stack+13890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14970, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[33] = int_stack + 23640;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13500,int_stack+14400,int_stack+14250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[32] = int_stack + 13500;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13950,int_stack+14760,int_stack+14610, 0.0, zero_stack, 1.0, int_stack+14970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[31] = int_stack + 13950;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14400,int_stack+15270,int_stack+15120, 1.0, int_stack+14970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[30] = int_stack + 14400;
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+14850,int_stack+15630,int_stack+15480,10);
     Libderiv->ABCD[26] = int_stack + 14850;
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+15300,int_stack+15990,int_stack+15840,10);
     Libderiv->ABCD[25] = int_stack + 15300;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15750,int_stack+16350,int_stack+16200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18000,10);
     Libderiv->ABCD[23] = int_stack + 15750;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+24090,int_stack+16710,int_stack+16560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18000, 0.0, zero_stack,10);
     Libderiv->ABCD[22] = int_stack + 24090;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16200,int_stack+17070,int_stack+16920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18000, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[21] = int_stack + 16200;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16650,int_stack+17430,int_stack+17280, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[20] = int_stack + 16650;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17100,int_stack+17790,int_stack+17640, 0.0, zero_stack, 1.0, int_stack+18000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[19] = int_stack + 17100;
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17550,int_stack+18300,int_stack+18150, 1.0, int_stack+18000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[18] = int_stack + 17550;
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+18000,int_stack+18660,int_stack+18510,10);
     Libderiv->ABCD[14] = int_stack + 18000;
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+24540,int_stack+19020,int_stack+18870,10);
     Libderiv->ABCD[13] = int_stack + 24540;
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+18450,int_stack+19380,int_stack+19230,10);
     Libderiv->ABCD[12] = int_stack + 18450;

}
