#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_pphf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (pp|hf) integrals */

void d1hrr_order_pphf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[1][5][11] = int_stack + 0;
 Libderiv->deriv_classes[1][6][11] = int_stack + 63;
 Libderiv->deriv_classes[1][7][11] = int_stack + 147;
 Libderiv->deriv_classes[1][8][11] = int_stack + 255;
 Libderiv->deriv_classes[2][5][11] = int_stack + 390;
 Libderiv->deriv_classes[2][6][11] = int_stack + 516;
 Libderiv->deriv_classes[2][7][11] = int_stack + 684;
 Libderiv->deriv_classes[2][8][11] = int_stack + 900;
 Libderiv->deriv_classes[1][5][10] = int_stack + 1170;
 Libderiv->deriv_classes[1][6][10] = int_stack + 1233;
 Libderiv->deriv_classes[1][7][10] = int_stack + 1317;
 Libderiv->deriv_classes[1][8][10] = int_stack + 1425;
 Libderiv->deriv_classes[2][5][10] = int_stack + 1560;
 Libderiv->deriv_classes[2][6][10] = int_stack + 1686;
 Libderiv->deriv_classes[2][7][10] = int_stack + 1854;
 Libderiv->deriv_classes[2][8][10] = int_stack + 2070;
 Libderiv->deriv_classes[1][5][9] = int_stack + 2340;
 Libderiv->deriv_classes[1][6][9] = int_stack + 2403;
 Libderiv->deriv_classes[1][7][9] = int_stack + 2487;
 Libderiv->deriv_classes[1][8][9] = int_stack + 2595;
 Libderiv->deriv_classes[2][5][9] = int_stack + 2730;
 Libderiv->deriv_classes[2][6][9] = int_stack + 2856;
 Libderiv->deriv_classes[2][7][9] = int_stack + 3024;
 Libderiv->deriv_classes[2][8][9] = int_stack + 3240;
 Libderiv->deriv_classes[1][5][8] = int_stack + 3510;
 Libderiv->deriv_classes[1][6][8] = int_stack + 3573;
 Libderiv->deriv_classes[1][7][8] = int_stack + 3657;
 Libderiv->deriv_classes[1][8][8] = int_stack + 3765;
 Libderiv->deriv_classes[2][5][8] = int_stack + 3900;
 Libderiv->deriv_classes[2][6][8] = int_stack + 4026;
 Libderiv->deriv_classes[2][7][8] = int_stack + 4194;
 Libderiv->deriv_classes[2][8][8] = int_stack + 4410;
 Libderiv->deriv_classes[1][5][7] = int_stack + 4680;
 Libderiv->deriv_classes[1][6][7] = int_stack + 4743;
 Libderiv->deriv_classes[1][7][7] = int_stack + 4827;
 Libderiv->deriv_classes[1][8][7] = int_stack + 4935;
 Libderiv->deriv_classes[2][5][7] = int_stack + 5070;
 Libderiv->deriv_classes[2][6][7] = int_stack + 5196;
 Libderiv->deriv_classes[2][7][7] = int_stack + 5364;
 Libderiv->deriv_classes[2][8][7] = int_stack + 5580;
 Libderiv->deriv_classes[1][5][6] = int_stack + 5850;
 Libderiv->deriv_classes[1][6][6] = int_stack + 5913;
 Libderiv->deriv_classes[1][7][6] = int_stack + 5997;
 Libderiv->deriv_classes[1][8][6] = int_stack + 6105;
 Libderiv->dvrr_classes[2][5] = int_stack + 6240;
 Libderiv->deriv_classes[2][5][6] = int_stack + 6366;
 Libderiv->dvrr_classes[2][6] = int_stack + 6492;
 Libderiv->deriv_classes[2][6][6] = int_stack + 6660;
 Libderiv->dvrr_classes[2][7] = int_stack + 6828;
 Libderiv->deriv_classes[2][7][6] = int_stack + 7044;
 Libderiv->deriv_classes[2][8][6] = int_stack + 7260;
 Libderiv->deriv_classes[1][5][2] = int_stack + 7530;
 Libderiv->deriv_classes[1][6][2] = int_stack + 7593;
 Libderiv->deriv_classes[1][7][2] = int_stack + 7677;
 Libderiv->deriv_classes[1][8][2] = int_stack + 7785;
 Libderiv->deriv_classes[2][5][2] = int_stack + 7920;
 Libderiv->deriv_classes[2][6][2] = int_stack + 8046;
 Libderiv->deriv_classes[2][7][2] = int_stack + 8214;
 Libderiv->deriv_classes[2][8][2] = int_stack + 8430;
 Libderiv->deriv_classes[1][5][1] = int_stack + 8700;
 Libderiv->deriv_classes[1][6][1] = int_stack + 8763;
 Libderiv->deriv_classes[1][7][1] = int_stack + 8847;
 Libderiv->deriv_classes[1][8][1] = int_stack + 8955;
 Libderiv->deriv_classes[2][5][1] = int_stack + 9090;
 Libderiv->deriv_classes[2][6][1] = int_stack + 9216;
 Libderiv->deriv_classes[2][7][1] = int_stack + 9384;
 Libderiv->deriv_classes[2][8][1] = int_stack + 9600;
 Libderiv->dvrr_classes[1][5] = int_stack + 9870;
 Libderiv->dvrr_classes[1][6] = int_stack + 9933;
 Libderiv->dvrr_classes[1][7] = int_stack + 10017;
 Libderiv->dvrr_classes[1][8] = int_stack + 10125;
 Libderiv->deriv_classes[1][5][0] = int_stack + 10260;
 Libderiv->deriv_classes[1][6][0] = int_stack + 10323;
 Libderiv->deriv_classes[1][7][0] = int_stack + 10407;
 Libderiv->deriv_classes[1][8][0] = int_stack + 10515;
 Libderiv->deriv_classes[2][5][0] = int_stack + 10650;
 Libderiv->deriv_classes[2][6][0] = int_stack + 10776;
 Libderiv->deriv_classes[2][7][0] = int_stack + 10944;
 Libderiv->deriv_classes[2][8][0] = int_stack + 11160;
 memset(int_stack,0,91440);

 Libderiv->dvrr_stack = int_stack + 28134;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_pphf(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+11430,int_stack+9933,int_stack+9870,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+11619,int_stack+10017,int_stack+9933,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+11871,int_stack+11619,int_stack+11430,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12249,int_stack+63,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9870,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+12438,int_stack+147,int_stack+63, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9933,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12690,int_stack+12438,int_stack+12249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11430,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+13068,int_stack+255,int_stack+147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10017,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+13392,int_stack+13068,int_stack+12438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11619,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+13896,int_stack+13392,int_stack+12690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11871,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+12249,int_stack+6492,int_stack+6240,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12627,int_stack+6828,int_stack+6492,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+13131,int_stack+12627,int_stack+12249,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+516,int_stack+390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6240,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14526,int_stack+684,int_stack+516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6492,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15030,int_stack+14526,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12249,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+900,int_stack+684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6828,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15786,int_stack+0,int_stack+14526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12627,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+16794,int_stack+15786,int_stack+15030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13131,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14526,int_stack+1233,int_stack+1170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9870, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14715,int_stack+1317,int_stack+1233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9933, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14967,int_stack+14715,int_stack+14526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11430, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15345,int_stack+1425,int_stack+1317, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10017, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15669,int_stack+15345,int_stack+14715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11619, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+15669,int_stack+14967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11871, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14526,int_stack+1686,int_stack+1560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6240, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14904,int_stack+1854,int_stack+1686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6492, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15408,int_stack+14904,int_stack+14526, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12249, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+630,int_stack+2070,int_stack+1854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6828, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1278,int_stack+630,int_stack+14904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12627, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+18054,int_stack+1278,int_stack+15408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13131, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+630,int_stack+2403,int_stack+2340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9870, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+819,int_stack+2487,int_stack+2403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9933, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1071,int_stack+819,int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11430, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1449,int_stack+2595,int_stack+2487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10017, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1773,int_stack+1449,int_stack+819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11619, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+14526,int_stack+1773,int_stack+1071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11871, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+630,int_stack+2856,int_stack+2730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6240, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1008,int_stack+3024,int_stack+2856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6492, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1512,int_stack+1008,int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12249, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2268,int_stack+3240,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6828, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15156,int_stack+2268,int_stack+1008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12627, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+19314,int_stack+15156,int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13131, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15156,int_stack+3573,int_stack+3510, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+15345,int_stack+3657,int_stack+3573, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15597,int_stack+15345,int_stack+15156, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+15975,int_stack+3765,int_stack+3657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+630,int_stack+15975,int_stack+15345, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+15975,int_stack+630,int_stack+15597, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+630,int_stack+4026,int_stack+3900, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1008,int_stack+4194,int_stack+4026, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1512,int_stack+1008,int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2268,int_stack+4410,int_stack+4194, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2916,int_stack+2268,int_stack+1008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+20574,int_stack+2916,int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16605,int_stack+4743,int_stack+4680, 0.0, zero_stack, 1.0, int_stack+9870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+630,int_stack+4827,int_stack+4743, 0.0, zero_stack, 1.0, int_stack+9933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+882,int_stack+630,int_stack+16605, 0.0, zero_stack, 1.0, int_stack+11430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1260,int_stack+4935,int_stack+4827, 0.0, zero_stack, 1.0, int_stack+10017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1584,int_stack+1260,int_stack+630, 0.0, zero_stack, 1.0, int_stack+11619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2088,int_stack+1584,int_stack+882, 0.0, zero_stack, 1.0, int_stack+11871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+630,int_stack+5196,int_stack+5070, 0.0, zero_stack, 1.0, int_stack+6240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1008,int_stack+5364,int_stack+5196, 0.0, zero_stack, 1.0, int_stack+6492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2718,int_stack+1008,int_stack+630, 0.0, zero_stack, 1.0, int_stack+12249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3474,int_stack+5580,int_stack+5364, 0.0, zero_stack, 1.0, int_stack+6828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4122,int_stack+3474,int_stack+1008, 0.0, zero_stack, 1.0, int_stack+12627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+630,int_stack+4122,int_stack+2718, 0.0, zero_stack, 1.0, int_stack+13131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16605,int_stack+5913,int_stack+5850, 1.0, int_stack+9870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2718,int_stack+5997,int_stack+5913, 1.0, int_stack+9933, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2970,int_stack+2718,int_stack+16605, 1.0, int_stack+11430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3348,int_stack+6105,int_stack+5997, 1.0, int_stack+10017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3672,int_stack+3348,int_stack+2718, 1.0, int_stack+11619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4176,int_stack+3672,int_stack+2970, 1.0, int_stack+11871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2718,int_stack+6660,int_stack+6366, 1.0, int_stack+6240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3096,int_stack+7044,int_stack+6660, 1.0, int_stack+6492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4806,int_stack+3096,int_stack+2718, 1.0, int_stack+12249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5562,int_stack+7260,int_stack+7044, 1.0, int_stack+6828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6210,int_stack+5562,int_stack+3096, 1.0, int_stack+12627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2718,int_stack+6210,int_stack+4806, 1.0, int_stack+13131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4806,int_stack+10125,int_stack+10017,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5130,int_stack+4806,int_stack+11619,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5634,int_stack+5130,int_stack+11871,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16605,int_stack+7593,int_stack+7530,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4806,int_stack+7677,int_stack+7593,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5058,int_stack+4806,int_stack+16605,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6264,int_stack+7785,int_stack+7677,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6588,int_stack+6264,int_stack+4806,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+7092,int_stack+6588,int_stack+5058,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4806,int_stack+8046,int_stack+7920,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6264,int_stack+8214,int_stack+8046,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+11430,int_stack+6264,int_stack+4806,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+4806,int_stack+8430,int_stack+8214,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12186,int_stack+4806,int_stack+6264,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+21834,int_stack+12186,int_stack+11430,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16605,int_stack+8763,int_stack+8700,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+11430,int_stack+8847,int_stack+8763,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+11682,int_stack+11430,int_stack+16605,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12060,int_stack+8955,int_stack+8847,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12384,int_stack+12060,int_stack+11430,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+12888,int_stack+12384,int_stack+11682,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+13518,int_stack+9216,int_stack+9090,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+11430,int_stack+9384,int_stack+9216,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+11934,int_stack+11430,int_stack+13518,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6264,int_stack+9600,int_stack+9384,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+7722,int_stack+6264,int_stack+11430,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+8730,int_stack+7722,int_stack+11934,6);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16605,int_stack+10323,int_stack+10260,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7722,int_stack+10407,int_stack+10323,3);
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+13518,int_stack+7722,int_stack+16605,3);
 /*--- compute (p0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+7974,int_stack+10515,int_stack+10407,3);
 /*--- compute (p0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+11430,int_stack+7974,int_stack+7722,3);
 /*--- compute (p0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+7722,int_stack+11430,int_stack+13518,3);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+13518,int_stack+10776,int_stack+10650,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+11430,int_stack+10944,int_stack+10776,6);
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+11934,int_stack+11430,int_stack+13518,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+6264,int_stack+11160,int_stack+10944,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+9990,int_stack+6264,int_stack+11430,6);
 /*--- compute (d0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+23094,int_stack+9990,int_stack+11934,6);
 /*--- compute (pp|hf) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+9990,int_stack+16794,int_stack+13896,210);
     Libderiv->ABCD[11] = int_stack + 9990;
 /*--- compute (pp|hf) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+24354,int_stack+18054,int_stack+0,210);
     Libderiv->ABCD[10] = int_stack + 24354;
 /*--- compute (pp|hf) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+16605,int_stack+19314,int_stack+14526,210);
     Libderiv->ABCD[9] = int_stack + 16605;
 /*--- compute (pp|hf) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+13518,int_stack+20574,int_stack+15975,210);
     Libderiv->ABCD[8] = int_stack + 13518;
 /*--- compute (pp|hf) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+18495,int_stack+630,int_stack+2088,210);
     Libderiv->ABCD[7] = int_stack + 18495;
 /*--- compute (pp|hf) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+0,int_stack+2718,int_stack+4176,210);
     Libderiv->ABCD[6] = int_stack + 0;
 /*--- compute (pp|hf) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+1890,int_stack+21834,int_stack+7092, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[2] = int_stack + 1890;
 /*--- compute (pp|hf) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+20385,int_stack+8730,int_stack+12888, 0.0, zero_stack, 1.0, int_stack+5634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[1] = int_stack + 20385;
 /*--- compute (pp|hf) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+26244,int_stack+23094,int_stack+7722, 1.0, int_stack+5634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[0] = int_stack + 26244;

}
