#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdi0(Libint_t*, prim_data*);

  /* Computes quartets of (fd|i0) integrals */

REALTYPE *hrr_order_fdi0(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][6] = int_stack + 0;
 Libint->vrr_classes[4][6] = int_stack + 280;
 Libint->vrr_classes[5][6] = int_stack + 700;
 memset(int_stack,0,1288*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1288;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdi0(Libint, Data);
   Data++;
 }
 /*--- compute (fp|i0) ---*/
 hrr1_build_fp(Libint->AB,int_stack+1288,int_stack+280,int_stack+0,28);
 /*--- compute (gp|i0) ---*/
 hrr1_build_gp(Libint->AB,int_stack+2128,int_stack+700,int_stack+280,28);
 /*--- compute (fd|i0) ---*/
 hrr1_build_fd(Libint->AB,int_stack+3388,int_stack+2128,int_stack+1288,28);
 return int_stack+3388;}
