#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdif(Libint_t*, prim_data*);

  /* Computes quartets of (fd|if) integrals */

REALTYPE *hrr_order_fdif(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][6] = int_stack + 0;
 Libint->vrr_classes[3][7] = int_stack + 280;
 Libint->vrr_classes[3][8] = int_stack + 640;
 Libint->vrr_classes[3][9] = int_stack + 1090;
 Libint->vrr_classes[4][6] = int_stack + 1640;
 Libint->vrr_classes[4][7] = int_stack + 2060;
 Libint->vrr_classes[4][8] = int_stack + 2600;
 Libint->vrr_classes[4][9] = int_stack + 3275;
 Libint->vrr_classes[5][6] = int_stack + 4100;
 Libint->vrr_classes[5][7] = int_stack + 4688;
 Libint->vrr_classes[5][8] = int_stack + 5444;
 Libint->vrr_classes[5][9] = int_stack + 6389;
 memset(int_stack,0,7544*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7544;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdif(Libint, Data);
   Data++;
 }
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+7544,int_stack+280,int_stack+0,10);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8384,int_stack+640,int_stack+280,10);
 /*--- compute (f0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+9464,int_stack+8384,int_stack+7544,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11144,int_stack+1090,int_stack+640,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+12494,int_stack+11144,int_stack+8384,10);
 /*--- compute (f0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+14654,int_stack+12494,int_stack+9464,10);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+7544,int_stack+2060,int_stack+1640,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8804,int_stack+2600,int_stack+2060,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10424,int_stack+8804,int_stack+7544,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+3275,int_stack+2600,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+17454,int_stack+0,int_stack+8804,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+20694,int_stack+17454,int_stack+10424,15);
 /*--- compute (fp|if) ---*/
 hrr1_build_fp(Libint->AB,int_stack+24894,int_stack+20694,int_stack+14654,280);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+4688,int_stack+4100,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+1764,int_stack+5444,int_stack+4688,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+7544,int_stack+1764,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11072,int_stack+6389,int_stack+5444,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+13907,int_stack+11072,int_stack+1764,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+13907,int_stack+7544,21);
 /*--- compute (gp|if) ---*/
 hrr1_build_gp(Libint->AB,int_stack+5880,int_stack+0,int_stack+20694,280);
 /*--- compute (fd|if) ---*/
 hrr1_build_fd(Libint->AB,int_stack+33294,int_stack+5880,int_stack+24894,280);
 return int_stack+33294;}
