#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffip(Libint_t*, prim_data*);

  /* Computes quartets of (ff|ip) integrals */

REALTYPE *hrr_order_ffip(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][6] = int_stack + 0;
 Libint->vrr_classes[3][7] = int_stack + 280;
 Libint->vrr_classes[4][6] = int_stack + 640;
 Libint->vrr_classes[4][7] = int_stack + 1060;
 Libint->vrr_classes[5][6] = int_stack + 1600;
 Libint->vrr_classes[5][7] = int_stack + 2188;
 Libint->vrr_classes[6][6] = int_stack + 2944;
 Libint->vrr_classes[6][7] = int_stack + 3728;
 memset(int_stack,0,4736*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 4736;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffip(Libint, Data);
   Data++;
 }
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+4736,int_stack+280,int_stack+0,10);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+5576,int_stack+1060,int_stack+640,15);
 /*--- compute (fp|ip) ---*/
 hrr1_build_fp(Libint->AB,int_stack+6836,int_stack+5576,int_stack+4736,84);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+9356,int_stack+2188,int_stack+1600,21);
 /*--- compute (gp|ip) ---*/
 hrr1_build_gp(Libint->AB,int_stack+11120,int_stack+9356,int_stack+5576,84);
 /*--- compute (fd|ip) ---*/
 hrr1_build_fd(Libint->AB,int_stack+14900,int_stack+11120,int_stack+6836,84);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+4736,int_stack+3728,int_stack+2944,28);
 /*--- compute (hp|ip) ---*/
 hrr1_build_hp(Libint->AB,int_stack+19940,int_stack+4736,int_stack+9356,84);
 /*--- compute (gd|ip) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+19940,int_stack+11120,84);
 /*--- compute (ff|ip) ---*/
 hrr1_build_ff(Libint->AB,int_stack+19940,int_stack+0,int_stack+14900,84);
 return int_stack+19940;}
