#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggih(Libint_t*, prim_data*);

  /* Computes quartets of (gg|ih) integrals */

REALTYPE *hrr_order_ggih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][6] = int_stack + 0;
 Libint->vrr_classes[4][7] = int_stack + 420;
 Libint->vrr_classes[4][8] = int_stack + 960;
 Libint->vrr_classes[4][9] = int_stack + 1635;
 Libint->vrr_classes[4][10] = int_stack + 2460;
 Libint->vrr_classes[4][11] = int_stack + 3450;
 Libint->vrr_classes[5][6] = int_stack + 4620;
 Libint->vrr_classes[5][7] = int_stack + 5208;
 Libint->vrr_classes[5][8] = int_stack + 5964;
 Libint->vrr_classes[5][9] = int_stack + 6909;
 Libint->vrr_classes[5][10] = int_stack + 8064;
 Libint->vrr_classes[5][11] = int_stack + 9450;
 Libint->vrr_classes[6][6] = int_stack + 11088;
 Libint->vrr_classes[6][7] = int_stack + 11872;
 Libint->vrr_classes[6][8] = int_stack + 12880;
 Libint->vrr_classes[6][9] = int_stack + 14140;
 Libint->vrr_classes[6][10] = int_stack + 15680;
 Libint->vrr_classes[6][11] = int_stack + 17528;
 Libint->vrr_classes[7][6] = int_stack + 19712;
 Libint->vrr_classes[7][7] = int_stack + 20720;
 Libint->vrr_classes[7][8] = int_stack + 22016;
 Libint->vrr_classes[7][9] = int_stack + 23636;
 Libint->vrr_classes[7][10] = int_stack + 25616;
 Libint->vrr_classes[7][11] = int_stack + 27992;
 Libint->vrr_classes[8][6] = int_stack + 30800;
 Libint->vrr_classes[8][7] = int_stack + 32060;
 Libint->vrr_classes[8][8] = int_stack + 33680;
 Libint->vrr_classes[8][9] = int_stack + 35705;
 Libint->vrr_classes[8][10] = int_stack + 38180;
 Libint->vrr_classes[8][11] = int_stack + 41150;
 memset(int_stack,0,44660*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 44660;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggih(Libint, Data);
   Data++;
 }
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+44660,int_stack+420,int_stack+0,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+45920,int_stack+960,int_stack+420,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+47540,int_stack+45920,int_stack+44660,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+50060,int_stack+1635,int_stack+960,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+52085,int_stack+50060,int_stack+45920,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+55325,int_stack+52085,int_stack+47540,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44660,int_stack+2460,int_stack+1635,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+59525,int_stack+44660,int_stack+50060,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+63575,int_stack+59525,int_stack+52085,15);
 /*--- compute (g0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+47135,int_stack+63575,int_stack+55325,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+53435,int_stack+3450,int_stack+2460,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+68975,int_stack+53435,int_stack+44660,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+73925,int_stack+68975,int_stack+59525,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+53435,int_stack+73925,int_stack+63575,15);
 /*--- compute (g0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+61535,int_stack+53435,int_stack+47135,15);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+44660,int_stack+5208,int_stack+4620,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+46424,int_stack+5964,int_stack+5208,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+48692,int_stack+46424,int_stack+44660,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+52220,int_stack+6909,int_stack+5964,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+55055,int_stack+52220,int_stack+46424,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+70355,int_stack+55055,int_stack+48692,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44660,int_stack+8064,int_stack+6909,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+44660,int_stack+52220,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+76235,int_stack+0,int_stack+55055,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+48125,int_stack+76235,int_stack+70355,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+70355,int_stack+9450,int_stack+8064,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+83795,int_stack+70355,int_stack+44660,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+90725,int_stack+83795,int_stack+0,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+100175,int_stack+90725,int_stack+76235,21);
 /*--- compute (h0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+70355,int_stack+100175,int_stack+48125,21);
 /*--- compute (gp|ih) ---*/
 hrr1_build_gp(Libint->AB,int_stack+82703,int_stack+70355,int_stack+61535,588);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+11872,int_stack+11088,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+2352,int_stack+12880,int_stack+11872,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+5376,int_stack+2352,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+44660,int_stack+14140,int_stack+12880,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+48440,int_stack+44660,int_stack+2352,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+54488,int_stack+48440,int_stack+5376,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+15680,int_stack+14140,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+4620,int_stack+0,int_stack+44660,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+109163,int_stack+4620,int_stack+48440,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+119243,int_stack+109163,int_stack+54488,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+44660,int_stack+17528,int_stack+15680,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50204,int_stack+44660,int_stack+0,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+131003,int_stack+50204,int_stack+4620,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+131003,int_stack+109163,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+44660,int_stack+0,int_stack+119243,28);
 /*--- compute (hp|ih) ---*/
 hrr1_build_hp(Libint->AB,int_stack+109163,int_stack+44660,int_stack+70355,588);
 /*--- compute (gd|ih) ---*/
 hrr1_build_gd(Libint->AB,int_stack+146207,int_stack+109163,int_stack+82703,588);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+20720,int_stack+19712,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3024,int_stack+22016,int_stack+20720,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+6912,int_stack+3024,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+12960,int_stack+23636,int_stack+22016,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+61124,int_stack+12960,int_stack+3024,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+68900,int_stack+61124,int_stack+6912,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+25616,int_stack+23636,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+78980,int_stack+0,int_stack+12960,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+5940,int_stack+78980,int_stack+61124,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+88700,int_stack+5940,int_stack+68900,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+61124,int_stack+27992,int_stack+25616,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+18900,int_stack+61124,int_stack+0,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+61124,int_stack+18900,int_stack+78980,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+199127,int_stack+61124,int_stack+5940,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+61124,int_stack+199127,int_stack+88700,36);
 /*--- compute (ip|ih) ---*/
 hrr1_build_ip(Libint->AB,int_stack+199127,int_stack+61124,int_stack+44660,588);
 /*--- compute (hd|ih) ---*/
 hrr1_build_hd(Libint->AB,int_stack+248519,int_stack+199127,int_stack+109163,588);
 /*--- compute (gf|ih) ---*/
 hrr1_build_gf(Libint->AB,int_stack+322607,int_stack+248519,int_stack+146207,588);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+44660,int_stack+32060,int_stack+30800,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+48440,int_stack+33680,int_stack+32060,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+53300,int_stack+48440,int_stack+44660,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+82292,int_stack+35705,int_stack+33680,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+88367,int_stack+82292,int_stack+48440,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+98087,int_stack+88367,int_stack+53300,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+44660,int_stack+38180,int_stack+35705,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+110687,int_stack+44660,int_stack+82292,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+122837,int_stack+110687,int_stack+88367,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+139037,int_stack+122837,int_stack+98087,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+82292,int_stack+41150,int_stack+38180,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+91202,int_stack+82292,int_stack+44660,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+157937,int_stack+91202,int_stack+110687,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+82292,int_stack+157937,int_stack+122837,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+157937,int_stack+82292,int_stack+139037,45);
 /*--- compute (kp|ih) ---*/
 hrr1_build_kp(Libint->AB,int_stack+82292,int_stack+157937,int_stack+61124,588);
 /*--- compute (id|ih) ---*/
 hrr1_build_id(Libint->AB,int_stack+410807,int_stack+82292,int_stack+199127,588);
 /*--- compute (hf|ih) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+410807,int_stack+248519,588);
 /*--- compute (gg|ih) ---*/
 hrr1_build_gg(Libint->AB,int_stack+123480,int_stack+0,int_stack+322607,588);
 return int_stack+123480;}
