#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hpip(Libint_t*, prim_data*);

  /* Computes quartets of (hp|ip) integrals */

REALTYPE *hrr_order_hpip(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][6] = int_stack + 0;
 Libint->vrr_classes[5][7] = int_stack + 588;
 Libint->vrr_classes[6][6] = int_stack + 1344;
 Libint->vrr_classes[6][7] = int_stack + 2128;
 memset(int_stack,0,3136*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 3136;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hpip(Libint, Data);
   Data++;
 }
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+3136,int_stack+588,int_stack+0,21);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+4900,int_stack+2128,int_stack+1344,28);
 /*--- compute (hp|ip) ---*/
 hrr1_build_hp(Libint->AB,int_stack+7252,int_stack+4900,int_stack+3136,84);
 return int_stack+7252;}
