#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idid(Libint_t*, prim_data*);

  /* Computes quartets of (id|id) integrals */

REALTYPE *hrr_order_idid(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[7][6] = int_stack + 3052;
 Libint->vrr_classes[7][7] = int_stack + 4060;
 Libint->vrr_classes[7][8] = int_stack + 5356;
 Libint->vrr_classes[8][6] = int_stack + 6976;
 Libint->vrr_classes[8][7] = int_stack + 8236;
 Libint->vrr_classes[8][8] = int_stack + 9856;
 memset(int_stack,0,11881*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 11881;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idid(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+11881,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+14233,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+17257,int_stack+14233,int_stack+11881,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+11881,int_stack+4060,int_stack+3052,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+5356,int_stack+4060,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+21961,int_stack+0,int_stack+11881,36);
 /*--- compute (ip|id) ---*/
 hrr1_build_ip(Libint->AB,int_stack+28009,int_stack+21961,int_stack+17257,168);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+11881,int_stack+8236,int_stack+6976,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+15661,int_stack+9856,int_stack+8236,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+0,int_stack+15661,int_stack+11881,45);
 /*--- compute (kp|id) ---*/
 hrr1_build_kp(Libint->AB,int_stack+42121,int_stack+0,int_stack+21961,168);
 /*--- compute (id|id) ---*/
 hrr1_build_id(Libint->AB,int_stack+60265,int_stack+42121,int_stack+28009,168);
 return int_stack+60265;}
