#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_00gf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (00|gf) integrals */

void d12hrr_order_00gf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[0][7][11] = int_stack + 0;
 Libderiv->deriv_classes[0][7][10] = int_stack + 36;
 Libderiv->deriv_classes[0][7][9] = int_stack + 72;
 Libderiv->deriv_classes[0][7][8] = int_stack + 108;
 Libderiv->deriv_classes[0][7][7] = int_stack + 144;
 Libderiv->dvrr_classes[0][6] = int_stack + 180;
 Libderiv->deriv_classes[0][7][6] = int_stack + 208;
 Libderiv->deriv_classes[0][7][2] = int_stack + 244;
 Libderiv->deriv_classes[0][7][1] = int_stack + 280;
 Libderiv->deriv_classes[0][7][0] = int_stack + 316;
 Libderiv->deriv2_classes[0][4][143] = int_stack + 352;
 Libderiv->deriv2_classes[0][5][143] = int_stack + 367;
 Libderiv->deriv2_classes[0][6][143] = int_stack + 388;
 Libderiv->deriv2_classes[0][7][143] = int_stack + 416;
 Libderiv->deriv2_classes[0][4][131] = int_stack + 452;
 Libderiv->deriv2_classes[0][5][131] = int_stack + 467;
 Libderiv->deriv2_classes[0][6][131] = int_stack + 488;
 Libderiv->deriv2_classes[0][7][131] = int_stack + 516;
 Libderiv->deriv2_classes[0][4][130] = int_stack + 552;
 Libderiv->deriv2_classes[0][5][130] = int_stack + 567;
 Libderiv->deriv2_classes[0][6][130] = int_stack + 588;
 Libderiv->deriv2_classes[0][7][130] = int_stack + 616;
 Libderiv->deriv2_classes[0][4][119] = int_stack + 652;
 Libderiv->deriv2_classes[0][5][119] = int_stack + 667;
 Libderiv->deriv2_classes[0][6][119] = int_stack + 688;
 Libderiv->deriv2_classes[0][7][119] = int_stack + 716;
 Libderiv->deriv2_classes[0][4][118] = int_stack + 752;
 Libderiv->deriv2_classes[0][5][118] = int_stack + 767;
 Libderiv->deriv2_classes[0][6][118] = int_stack + 788;
 Libderiv->deriv2_classes[0][7][118] = int_stack + 816;
 Libderiv->deriv2_classes[0][4][117] = int_stack + 852;
 Libderiv->deriv2_classes[0][5][117] = int_stack + 867;
 Libderiv->deriv2_classes[0][6][117] = int_stack + 888;
 Libderiv->deriv2_classes[0][7][117] = int_stack + 916;
 Libderiv->deriv2_classes[0][4][107] = int_stack + 952;
 Libderiv->deriv2_classes[0][5][107] = int_stack + 967;
 Libderiv->deriv2_classes[0][6][107] = int_stack + 988;
 Libderiv->deriv2_classes[0][7][107] = int_stack + 1016;
 Libderiv->deriv2_classes[0][4][106] = int_stack + 1052;
 Libderiv->deriv2_classes[0][5][106] = int_stack + 1067;
 Libderiv->deriv2_classes[0][6][106] = int_stack + 1088;
 Libderiv->deriv2_classes[0][7][106] = int_stack + 1116;
 Libderiv->deriv2_classes[0][4][105] = int_stack + 1152;
 Libderiv->deriv2_classes[0][5][105] = int_stack + 1167;
 Libderiv->deriv2_classes[0][6][105] = int_stack + 1188;
 Libderiv->deriv2_classes[0][7][105] = int_stack + 1216;
 Libderiv->deriv2_classes[0][4][104] = int_stack + 1252;
 Libderiv->deriv2_classes[0][5][104] = int_stack + 1267;
 Libderiv->deriv2_classes[0][6][104] = int_stack + 1288;
 Libderiv->deriv2_classes[0][7][104] = int_stack + 1316;
 Libderiv->deriv2_classes[0][4][95] = int_stack + 1352;
 Libderiv->deriv2_classes[0][5][95] = int_stack + 1367;
 Libderiv->deriv2_classes[0][6][95] = int_stack + 1388;
 Libderiv->deriv2_classes[0][7][95] = int_stack + 1416;
 Libderiv->deriv2_classes[0][4][94] = int_stack + 1452;
 Libderiv->deriv2_classes[0][5][94] = int_stack + 1467;
 Libderiv->deriv2_classes[0][6][94] = int_stack + 1488;
 Libderiv->deriv2_classes[0][7][94] = int_stack + 1516;
 Libderiv->deriv2_classes[0][4][93] = int_stack + 1552;
 Libderiv->deriv2_classes[0][5][93] = int_stack + 1567;
 Libderiv->deriv2_classes[0][6][93] = int_stack + 1588;
 Libderiv->deriv2_classes[0][7][93] = int_stack + 1616;
 Libderiv->deriv2_classes[0][4][92] = int_stack + 1652;
 Libderiv->deriv2_classes[0][5][92] = int_stack + 1667;
 Libderiv->deriv2_classes[0][6][92] = int_stack + 1688;
 Libderiv->deriv2_classes[0][7][92] = int_stack + 1716;
 Libderiv->deriv2_classes[0][4][91] = int_stack + 1752;
 Libderiv->deriv2_classes[0][5][91] = int_stack + 1767;
 Libderiv->deriv2_classes[0][6][91] = int_stack + 1788;
 Libderiv->deriv2_classes[0][7][91] = int_stack + 1816;
 Libderiv->deriv_classes[0][4][11] = int_stack + 1852;
 Libderiv->deriv2_classes[0][4][83] = int_stack + 1867;
 Libderiv->deriv_classes[0][5][11] = int_stack + 1882;
 Libderiv->deriv2_classes[0][5][83] = int_stack + 1903;
 Libderiv->deriv_classes[0][6][11] = int_stack + 1924;
 Libderiv->deriv2_classes[0][6][83] = int_stack + 1952;
 Libderiv->deriv2_classes[0][7][83] = int_stack + 1980;
 Libderiv->deriv_classes[0][4][10] = int_stack + 2016;
 Libderiv->deriv2_classes[0][4][82] = int_stack + 2031;
 Libderiv->deriv_classes[0][5][10] = int_stack + 2046;
 Libderiv->deriv2_classes[0][5][82] = int_stack + 2067;
 Libderiv->deriv_classes[0][6][10] = int_stack + 2088;
 Libderiv->deriv2_classes[0][6][82] = int_stack + 2116;
 Libderiv->deriv2_classes[0][7][82] = int_stack + 2144;
 Libderiv->deriv_classes[0][4][9] = int_stack + 2180;
 Libderiv->deriv2_classes[0][4][81] = int_stack + 2195;
 Libderiv->deriv_classes[0][5][9] = int_stack + 2210;
 Libderiv->deriv2_classes[0][5][81] = int_stack + 2231;
 Libderiv->deriv_classes[0][6][9] = int_stack + 2252;
 Libderiv->deriv2_classes[0][6][81] = int_stack + 2280;
 Libderiv->deriv2_classes[0][7][81] = int_stack + 2308;
 Libderiv->deriv_classes[0][4][8] = int_stack + 2344;
 Libderiv->deriv2_classes[0][4][80] = int_stack + 2359;
 Libderiv->deriv_classes[0][5][8] = int_stack + 2374;
 Libderiv->deriv2_classes[0][5][80] = int_stack + 2395;
 Libderiv->deriv_classes[0][6][8] = int_stack + 2416;
 Libderiv->deriv2_classes[0][6][80] = int_stack + 2444;
 Libderiv->deriv2_classes[0][7][80] = int_stack + 2472;
 Libderiv->deriv_classes[0][4][7] = int_stack + 2508;
 Libderiv->deriv2_classes[0][4][79] = int_stack + 2523;
 Libderiv->deriv_classes[0][5][7] = int_stack + 2538;
 Libderiv->deriv2_classes[0][5][79] = int_stack + 2559;
 Libderiv->deriv_classes[0][6][7] = int_stack + 2580;
 Libderiv->deriv2_classes[0][6][79] = int_stack + 2608;
 Libderiv->deriv2_classes[0][7][79] = int_stack + 2636;
 Libderiv->dvrr_classes[0][4] = int_stack + 2672;
 Libderiv->deriv_classes[0][4][6] = int_stack + 2687;
 Libderiv->deriv2_classes[0][4][78] = int_stack + 2702;
 Libderiv->dvrr_classes[0][5] = int_stack + 2717;
 Libderiv->deriv_classes[0][5][6] = int_stack + 2738;
 Libderiv->deriv2_classes[0][5][78] = int_stack + 2759;
 Libderiv->deriv_classes[0][6][6] = int_stack + 2780;
 Libderiv->deriv2_classes[0][6][78] = int_stack + 2808;
 Libderiv->deriv2_classes[0][7][78] = int_stack + 2836;
 Libderiv->deriv2_classes[0][4][35] = int_stack + 2872;
 Libderiv->deriv2_classes[0][5][35] = int_stack + 2887;
 Libderiv->deriv2_classes[0][6][35] = int_stack + 2908;
 Libderiv->deriv2_classes[0][7][35] = int_stack + 2936;
 Libderiv->deriv2_classes[0][4][34] = int_stack + 2972;
 Libderiv->deriv2_classes[0][5][34] = int_stack + 2987;
 Libderiv->deriv2_classes[0][6][34] = int_stack + 3008;
 Libderiv->deriv2_classes[0][7][34] = int_stack + 3036;
 Libderiv->deriv2_classes[0][4][33] = int_stack + 3072;
 Libderiv->deriv2_classes[0][5][33] = int_stack + 3087;
 Libderiv->deriv2_classes[0][6][33] = int_stack + 3108;
 Libderiv->deriv2_classes[0][7][33] = int_stack + 3136;
 Libderiv->deriv2_classes[0][4][32] = int_stack + 3172;
 Libderiv->deriv2_classes[0][5][32] = int_stack + 3187;
 Libderiv->deriv2_classes[0][6][32] = int_stack + 3208;
 Libderiv->deriv2_classes[0][7][32] = int_stack + 3236;
 Libderiv->deriv2_classes[0][4][31] = int_stack + 3272;
 Libderiv->deriv2_classes[0][5][31] = int_stack + 3287;
 Libderiv->deriv2_classes[0][6][31] = int_stack + 3308;
 Libderiv->deriv2_classes[0][7][31] = int_stack + 3336;
 Libderiv->deriv_classes[0][4][2] = int_stack + 3372;
 Libderiv->deriv2_classes[0][4][30] = int_stack + 3387;
 Libderiv->deriv_classes[0][5][2] = int_stack + 3402;
 Libderiv->deriv2_classes[0][5][30] = int_stack + 3423;
 Libderiv->deriv_classes[0][6][2] = int_stack + 3444;
 Libderiv->deriv2_classes[0][6][30] = int_stack + 3472;
 Libderiv->deriv2_classes[0][7][30] = int_stack + 3500;
 Libderiv->deriv2_classes[0][4][26] = int_stack + 3536;
 Libderiv->deriv2_classes[0][5][26] = int_stack + 3551;
 Libderiv->deriv2_classes[0][6][26] = int_stack + 3572;
 Libderiv->deriv2_classes[0][7][26] = int_stack + 3600;
 Libderiv->deriv2_classes[0][4][23] = int_stack + 3636;
 Libderiv->deriv2_classes[0][5][23] = int_stack + 3651;
 Libderiv->deriv2_classes[0][6][23] = int_stack + 3672;
 Libderiv->deriv2_classes[0][7][23] = int_stack + 3700;
 Libderiv->deriv2_classes[0][4][22] = int_stack + 3736;
 Libderiv->deriv2_classes[0][5][22] = int_stack + 3751;
 Libderiv->deriv2_classes[0][6][22] = int_stack + 3772;
 Libderiv->deriv2_classes[0][7][22] = int_stack + 3800;
 Libderiv->deriv2_classes[0][4][21] = int_stack + 3836;
 Libderiv->deriv2_classes[0][5][21] = int_stack + 3851;
 Libderiv->deriv2_classes[0][6][21] = int_stack + 3872;
 Libderiv->deriv2_classes[0][7][21] = int_stack + 3900;
 Libderiv->deriv2_classes[0][4][20] = int_stack + 3936;
 Libderiv->deriv2_classes[0][5][20] = int_stack + 3951;
 Libderiv->deriv2_classes[0][6][20] = int_stack + 3972;
 Libderiv->deriv2_classes[0][7][20] = int_stack + 4000;
 Libderiv->deriv2_classes[0][4][19] = int_stack + 4036;
 Libderiv->deriv2_classes[0][5][19] = int_stack + 4051;
 Libderiv->deriv2_classes[0][6][19] = int_stack + 4072;
 Libderiv->deriv2_classes[0][7][19] = int_stack + 4100;
 Libderiv->deriv_classes[0][4][1] = int_stack + 4136;
 Libderiv->deriv2_classes[0][4][18] = int_stack + 4151;
 Libderiv->deriv_classes[0][5][1] = int_stack + 4166;
 Libderiv->deriv2_classes[0][5][18] = int_stack + 4187;
 Libderiv->deriv_classes[0][6][1] = int_stack + 4208;
 Libderiv->deriv2_classes[0][6][18] = int_stack + 4236;
 Libderiv->deriv2_classes[0][7][18] = int_stack + 4264;
 Libderiv->deriv2_classes[0][4][14] = int_stack + 4300;
 Libderiv->deriv2_classes[0][5][14] = int_stack + 4315;
 Libderiv->deriv2_classes[0][6][14] = int_stack + 4336;
 Libderiv->deriv2_classes[0][7][14] = int_stack + 4364;
 Libderiv->deriv2_classes[0][4][13] = int_stack + 4400;
 Libderiv->deriv2_classes[0][5][13] = int_stack + 4415;
 Libderiv->deriv2_classes[0][6][13] = int_stack + 4436;
 Libderiv->deriv2_classes[0][7][13] = int_stack + 4464;
 Libderiv->deriv2_classes[0][4][11] = int_stack + 4500;
 Libderiv->deriv2_classes[0][5][11] = int_stack + 4515;
 Libderiv->deriv2_classes[0][6][11] = int_stack + 4536;
 Libderiv->deriv2_classes[0][7][11] = int_stack + 4564;
 Libderiv->deriv2_classes[0][4][10] = int_stack + 4600;
 Libderiv->deriv2_classes[0][5][10] = int_stack + 4615;
 Libderiv->deriv2_classes[0][6][10] = int_stack + 4636;
 Libderiv->deriv2_classes[0][7][10] = int_stack + 4664;
 Libderiv->deriv2_classes[0][4][9] = int_stack + 4700;
 Libderiv->deriv2_classes[0][5][9] = int_stack + 4715;
 Libderiv->deriv2_classes[0][6][9] = int_stack + 4736;
 Libderiv->deriv2_classes[0][7][9] = int_stack + 4764;
 Libderiv->deriv2_classes[0][4][8] = int_stack + 4800;
 Libderiv->deriv2_classes[0][5][8] = int_stack + 4815;
 Libderiv->deriv2_classes[0][6][8] = int_stack + 4836;
 Libderiv->deriv2_classes[0][7][8] = int_stack + 4864;
 Libderiv->deriv2_classes[0][4][7] = int_stack + 4900;
 Libderiv->deriv2_classes[0][5][7] = int_stack + 4915;
 Libderiv->deriv2_classes[0][6][7] = int_stack + 4936;
 Libderiv->deriv2_classes[0][7][7] = int_stack + 4964;
 Libderiv->deriv_classes[0][4][0] = int_stack + 5000;
 Libderiv->deriv2_classes[0][4][6] = int_stack + 5015;
 Libderiv->deriv_classes[0][5][0] = int_stack + 5030;
 Libderiv->deriv2_classes[0][5][6] = int_stack + 5051;
 Libderiv->deriv_classes[0][6][0] = int_stack + 5072;
 Libderiv->deriv2_classes[0][6][6] = int_stack + 5100;
 Libderiv->deriv2_classes[0][7][6] = int_stack + 5128;
 Libderiv->deriv2_classes[0][4][2] = int_stack + 5164;
 Libderiv->deriv2_classes[0][5][2] = int_stack + 5179;
 Libderiv->deriv2_classes[0][6][2] = int_stack + 5200;
 Libderiv->deriv2_classes[0][7][2] = int_stack + 5228;
 Libderiv->deriv2_classes[0][4][1] = int_stack + 5264;
 Libderiv->deriv2_classes[0][5][1] = int_stack + 5279;
 Libderiv->deriv2_classes[0][6][1] = int_stack + 5300;
 Libderiv->deriv2_classes[0][7][1] = int_stack + 5328;
 Libderiv->deriv2_classes[0][4][0] = int_stack + 5364;
 Libderiv->deriv2_classes[0][5][0] = int_stack + 5379;
 Libderiv->deriv2_classes[0][6][0] = int_stack + 5400;
 Libderiv->deriv2_classes[0][7][0] = int_stack + 5428;
 memset(int_stack,0,43712);

 Libderiv->dvrr_stack = int_stack + 13213;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_00gf(Libderiv, Data);
   Data++;
 }

 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+5464,int_stack+2717,int_stack+2672,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5509,int_stack+180,int_stack+2717,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+5572,int_stack+5509,int_stack+5464,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5662,int_stack+1882,int_stack+1852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2672,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5707,int_stack+1924,int_stack+1882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2717,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5770,int_stack+5707,int_stack+5662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5464,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5860,int_stack+0,int_stack+1924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5944,int_stack+5860,int_stack+5707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5509,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5860,int_stack+2046,int_stack+2016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2672, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6070,int_stack+2088,int_stack+2046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2717, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6133,int_stack+6070,int_stack+5860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5464, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6223,int_stack+36,int_stack+2088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6307,int_stack+6223,int_stack+6070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5509, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6223,int_stack+2210,int_stack+2180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2672, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+2252,int_stack+2210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2717, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6433,int_stack+0,int_stack+6223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5464, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6523,int_stack+72,int_stack+2252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6607,int_stack+6523,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5509, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+63,int_stack+2374,int_stack+2344, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6523,int_stack+2416,int_stack+2374, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6733,int_stack+6523,int_stack+63, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6823,int_stack+108,int_stack+2416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6907,int_stack+6823,int_stack+6523, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6823,int_stack+2538,int_stack+2508, 0.0, zero_stack, 1.0, int_stack+2672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7033,int_stack+2580,int_stack+2538, 0.0, zero_stack, 1.0, int_stack+2717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+7096,int_stack+7033,int_stack+6823, 0.0, zero_stack, 1.0, int_stack+5464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7186,int_stack+144,int_stack+2580, 0.0, zero_stack, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7270,int_stack+7186,int_stack+7033, 0.0, zero_stack, 1.0, int_stack+5509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7186,int_stack+2738,int_stack+2687, 1.0, int_stack+2672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+108,int_stack+2780,int_stack+2738, 1.0, int_stack+2717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+7396,int_stack+108,int_stack+7186, 1.0, int_stack+5464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7486,int_stack+208,int_stack+2780, 1.0, int_stack+180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7570,int_stack+7486,int_stack+108, 1.0, int_stack+5509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+7486,int_stack+3402,int_stack+3372,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5464,int_stack+3444,int_stack+3402,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+7696,int_stack+5464,int_stack+7486,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7786,int_stack+244,int_stack+3444,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+7870,int_stack+7786,int_stack+5464,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+5527,int_stack+4166,int_stack+4136,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7786,int_stack+4208,int_stack+4166,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+171,int_stack+7786,int_stack+5527,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7996,int_stack+280,int_stack+4208,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+8080,int_stack+7996,int_stack+7786,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+7996,int_stack+5030,int_stack+5000,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+8206,int_stack+5072,int_stack+5030,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+8269,int_stack+8206,int_stack+7996,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8359,int_stack+316,int_stack+5072,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+8443,int_stack+8359,int_stack+8206,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8359,int_stack+367,int_stack+352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1852,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+388,int_stack+367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1882,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8569,int_stack+261,int_stack+8359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5662,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8359,int_stack+416,int_stack+388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1924,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+324,int_stack+8359,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5707,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+467,int_stack+452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1852, 1.0, int_stack+2016,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8359,int_stack+488,int_stack+467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1882, 1.0, int_stack+2046,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8659,int_stack+8359,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5662, 1.0, int_stack+5860,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8749,int_stack+516,int_stack+488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1924, 1.0, int_stack+2088,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8833,int_stack+8749,int_stack+8359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5707, 1.0, int_stack+6070,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8359,int_stack+567,int_stack+552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2016, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+588,int_stack+567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2046, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+450,int_stack+261,int_stack+8359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5860, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8359,int_stack+616,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2088, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8959,int_stack+8359,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6070, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+667,int_stack+652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1852, 0.0, zero_stack, 1.0, int_stack+2180,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8359,int_stack+688,int_stack+667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1882, 0.0, zero_stack, 1.0, int_stack+2210,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+540,int_stack+8359,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5662, 0.0, zero_stack, 1.0, int_stack+6223,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8749,int_stack+716,int_stack+688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1924, 0.0, zero_stack, 1.0, int_stack+2252,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9085,int_stack+8749,int_stack+8359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5707, 0.0, zero_stack, 1.0, int_stack+0,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8359,int_stack+767,int_stack+752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2016, 1.0, int_stack+2180, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+788,int_stack+767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2046, 1.0, int_stack+2210, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+630,int_stack+261,int_stack+8359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5860, 1.0, int_stack+6223, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8359,int_stack+816,int_stack+788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2088, 1.0, int_stack+2252, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+720,int_stack+8359,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6070, 1.0, int_stack+0, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+867,int_stack+852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2180, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8359,int_stack+888,int_stack+867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2210, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9211,int_stack+8359,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6223, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8749,int_stack+916,int_stack+888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2252, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9301,int_stack+8749,int_stack+8359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8359,int_stack+967,int_stack+952, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1852, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2344,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+988,int_stack+967, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1882, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2374,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+846,int_stack+261,int_stack+8359, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5662, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+63,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8359,int_stack+1016,int_stack+988, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1924, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2416,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9427,int_stack+8359,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5707, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6523,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+1067,int_stack+1052, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2016, 0.0, zero_stack, 1.0, int_stack+2344, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8359,int_stack+1088,int_stack+1067, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2046, 0.0, zero_stack, 1.0, int_stack+2374, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+936,int_stack+8359,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5860, 0.0, zero_stack, 1.0, int_stack+63, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8749,int_stack+1116,int_stack+1088, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2088, 0.0, zero_stack, 1.0, int_stack+2416, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1026,int_stack+8749,int_stack+8359, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6070, 0.0, zero_stack, 1.0, int_stack+6523, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8359,int_stack+1167,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2180, 1.0, int_stack+2344, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+1188,int_stack+1167, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2210, 1.0, int_stack+2374, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9553,int_stack+261,int_stack+8359, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6223, 1.0, int_stack+63, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8359,int_stack+1216,int_stack+1188, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2252, 1.0, int_stack+2416, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9643,int_stack+8359,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+6523, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+1267,int_stack+1252, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8359,int_stack+1288,int_stack+1267, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1152,int_stack+8359,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+63, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8749,int_stack+1316,int_stack+1288, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+2416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9769,int_stack+8749,int_stack+8359, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8359,int_stack+1367,int_stack+1352, 0.0, zero_stack, 1.0, int_stack+1852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2508,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+1388,int_stack+1367, 0.0, zero_stack, 1.0, int_stack+1882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2538,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1242,int_stack+261,int_stack+8359, 0.0, zero_stack, 1.0, int_stack+5662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6823,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8359,int_stack+1416,int_stack+1388, 0.0, zero_stack, 1.0, int_stack+1924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2580,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9895,int_stack+8359,int_stack+261, 0.0, zero_stack, 1.0, int_stack+5707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7033,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+1467,int_stack+1452, 0.0, zero_stack, 1.0, int_stack+2016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2508, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8359,int_stack+1488,int_stack+1467, 0.0, zero_stack, 1.0, int_stack+2046, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2538, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1332,int_stack+8359,int_stack+261, 0.0, zero_stack, 1.0, int_stack+5860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6823, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8749,int_stack+1516,int_stack+1488, 0.0, zero_stack, 1.0, int_stack+2088, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2580, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1422,int_stack+8749,int_stack+8359, 0.0, zero_stack, 1.0, int_stack+6070, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7033, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8359,int_stack+1567,int_stack+1552, 0.0, zero_stack, 1.0, int_stack+2180, 0.0, zero_stack, 1.0, int_stack+2508, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+1588,int_stack+1567, 0.0, zero_stack, 1.0, int_stack+2210, 0.0, zero_stack, 1.0, int_stack+2538, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+10021,int_stack+261,int_stack+8359, 0.0, zero_stack, 1.0, int_stack+6223, 0.0, zero_stack, 1.0, int_stack+6823, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8359,int_stack+1616,int_stack+1588, 0.0, zero_stack, 1.0, int_stack+2252, 0.0, zero_stack, 1.0, int_stack+2580, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10111,int_stack+8359,int_stack+261, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+7033, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+1667,int_stack+1652, 0.0, zero_stack, 1.0, int_stack+2344, 1.0, int_stack+2508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8359,int_stack+1688,int_stack+1667, 0.0, zero_stack, 1.0, int_stack+2374, 1.0, int_stack+2538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1548,int_stack+8359,int_stack+261, 0.0, zero_stack, 1.0, int_stack+63, 1.0, int_stack+6823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8749,int_stack+1716,int_stack+1688, 0.0, zero_stack, 1.0, int_stack+2416, 1.0, int_stack+2580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10237,int_stack+8749,int_stack+8359, 0.0, zero_stack, 1.0, int_stack+6523, 1.0, int_stack+7033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8359,int_stack+1767,int_stack+1752, 0.0, zero_stack, 2.0, int_stack+2508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+1788,int_stack+1767, 0.0, zero_stack, 2.0, int_stack+2538, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1638,int_stack+261,int_stack+8359, 0.0, zero_stack, 2.0, int_stack+6823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8359,int_stack+1816,int_stack+1788, 0.0, zero_stack, 2.0, int_stack+2580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10363,int_stack+8359,int_stack+261, 0.0, zero_stack, 2.0, int_stack+7033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+1903,int_stack+1867, 1.0, int_stack+1852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2687,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8359,int_stack+1952,int_stack+1903, 1.0, int_stack+1882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2738,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1728,int_stack+8359,int_stack+261, 1.0, int_stack+5662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7186,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+8749,int_stack+1980,int_stack+1952, 1.0, int_stack+1924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2780,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1818,int_stack+8749,int_stack+8359, 1.0, int_stack+5707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8359,int_stack+2067,int_stack+2031, 1.0, int_stack+2016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2687, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+2116,int_stack+2067, 1.0, int_stack+2046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2738, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5662,int_stack+261,int_stack+8359, 1.0, int_stack+5860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7186, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5860,int_stack+2144,int_stack+2116, 1.0, int_stack+2088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2780, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1944,int_stack+5860,int_stack+261, 1.0, int_stack+6070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6070,int_stack+2231,int_stack+2195, 1.0, int_stack+2180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2687, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+2280,int_stack+2231, 1.0, int_stack+2210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2738, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2070,int_stack+261,int_stack+6070, 1.0, int_stack+6223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7186, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6223,int_stack+2308,int_stack+2280, 1.0, int_stack+2252, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2780, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2160,int_stack+6223,int_stack+261, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+2395,int_stack+2359, 1.0, int_stack+2344, 0.0, zero_stack, 1.0, int_stack+2687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+2444,int_stack+2395, 1.0, int_stack+2374, 0.0, zero_stack, 1.0, int_stack+2738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2286,int_stack+261,int_stack+0, 1.0, int_stack+63, 0.0, zero_stack, 1.0, int_stack+7186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6223,int_stack+2472,int_stack+2444, 1.0, int_stack+2416, 0.0, zero_stack, 1.0, int_stack+2780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2376,int_stack+6223,int_stack+261, 1.0, int_stack+6523, 0.0, zero_stack, 1.0, int_stack+108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6523,int_stack+2559,int_stack+2523, 1.0, int_stack+2508, 1.0, int_stack+2687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+2608,int_stack+2559, 1.0, int_stack+2538, 1.0, int_stack+2738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+261,int_stack+6523, 1.0, int_stack+6823, 1.0, int_stack+7186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6823,int_stack+2636,int_stack+2608, 1.0, int_stack+2580, 1.0, int_stack+2780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2502,int_stack+6823,int_stack+261, 1.0, int_stack+7033, 1.0, int_stack+108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7033,int_stack+2759,int_stack+2702, 2.0, int_stack+2687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+2808,int_stack+2759, 2.0, int_stack+2738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2628,int_stack+261,int_stack+7033, 2.0, int_stack+7186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7186,int_stack+2836,int_stack+2808, 2.0, int_stack+2780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2718,int_stack+7186,int_stack+261, 2.0, int_stack+108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+2887,int_stack+2872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3372,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7033,int_stack+2908,int_stack+2887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3402,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+10489,int_stack+7033,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7486,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7186,int_stack+2936,int_stack+2908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3444,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2844,int_stack+7186,int_stack+7033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5464,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7033,int_stack+2987,int_stack+2972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3372, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+3008,int_stack+2987, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3402, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+10579,int_stack+261,int_stack+7033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7486, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7186,int_stack+3036,int_stack+3008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3444, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10669,int_stack+7186,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5464, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+3087,int_stack+3072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3372, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7033,int_stack+3108,int_stack+3087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3402, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2970,int_stack+7033,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7486, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7186,int_stack+3136,int_stack+3108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3444, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10795,int_stack+7186,int_stack+7033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5464, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7033,int_stack+3187,int_stack+3172, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+3208,int_stack+3187, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3060,int_stack+261,int_stack+7033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7186,int_stack+3236,int_stack+3208, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+10921,int_stack+7186,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+3287,int_stack+3272, 0.0, zero_stack, 1.0, int_stack+3372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7033,int_stack+3308,int_stack+3287, 0.0, zero_stack, 1.0, int_stack+3402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3150,int_stack+7033,int_stack+261, 0.0, zero_stack, 1.0, int_stack+7486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7186,int_stack+3336,int_stack+3308, 0.0, zero_stack, 1.0, int_stack+3444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3240,int_stack+7186,int_stack+7033, 0.0, zero_stack, 1.0, int_stack+5464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7033,int_stack+3423,int_stack+3387, 1.0, int_stack+3372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+3472,int_stack+3423, 1.0, int_stack+3402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11047,int_stack+261,int_stack+7033, 1.0, int_stack+7486, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7486,int_stack+3500,int_stack+3472, 1.0, int_stack+3444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3366,int_stack+7486,int_stack+261, 1.0, int_stack+5464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+5464,int_stack+3551,int_stack+3536,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+3572,int_stack+3551,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+11137,int_stack+261,int_stack+5464,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7486,int_stack+3600,int_stack+3572,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3492,int_stack+7486,int_stack+261,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+3651,int_stack+3636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4136,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5464,int_stack+3672,int_stack+3651, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4166,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11227,int_stack+5464,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5527,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7486,int_stack+3700,int_stack+3672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4208,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11317,int_stack+7486,int_stack+5464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7786,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5464,int_stack+3751,int_stack+3736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4136, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+3772,int_stack+3751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4166, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3618,int_stack+261,int_stack+5464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5527, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7486,int_stack+3800,int_stack+3772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4208, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3708,int_stack+7486,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7786, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+3851,int_stack+3836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4136, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5464,int_stack+3872,int_stack+3851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4166, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11443,int_stack+5464,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5527, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7486,int_stack+3900,int_stack+3872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4208, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11533,int_stack+7486,int_stack+5464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7786, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5464,int_stack+3951,int_stack+3936, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+3972,int_stack+3951, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3834,int_stack+261,int_stack+5464, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7486,int_stack+4000,int_stack+3972, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11659,int_stack+7486,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+4051,int_stack+4036, 0.0, zero_stack, 1.0, int_stack+4136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5464,int_stack+4072,int_stack+4051, 0.0, zero_stack, 1.0, int_stack+4166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3924,int_stack+5464,int_stack+261, 0.0, zero_stack, 1.0, int_stack+5527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7486,int_stack+4100,int_stack+4072, 0.0, zero_stack, 1.0, int_stack+4208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11785,int_stack+7486,int_stack+5464, 0.0, zero_stack, 1.0, int_stack+7786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5464,int_stack+4187,int_stack+4151, 1.0, int_stack+4136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+4236,int_stack+4187, 1.0, int_stack+4166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11911,int_stack+261,int_stack+5464, 1.0, int_stack+5527, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7486,int_stack+4264,int_stack+4236, 1.0, int_stack+4208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4014,int_stack+7486,int_stack+261, 1.0, int_stack+7786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+7786,int_stack+4315,int_stack+4300,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+4336,int_stack+4315,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+5464,int_stack+261,int_stack+7786,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7786,int_stack+4364,int_stack+4336,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4140,int_stack+7786,int_stack+261,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+4415,int_stack+4400,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7033,int_stack+4436,int_stack+4415,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+4266,int_stack+7033,int_stack+261,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7786,int_stack+4464,int_stack+4436,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+4356,int_stack+7786,int_stack+7033,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7033,int_stack+4515,int_stack+4500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5000,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+4536,int_stack+4515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5030,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12001,int_stack+261,int_stack+7033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7996,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7786,int_stack+4564,int_stack+4536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5072,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12091,int_stack+7786,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8206,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+4615,int_stack+4600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5000, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7033,int_stack+4636,int_stack+4615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5030, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4482,int_stack+7033,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7996, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7786,int_stack+4664,int_stack+4636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5072, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4572,int_stack+7786,int_stack+7033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8206, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7033,int_stack+4715,int_stack+4700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5000, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+4736,int_stack+4715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5030, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12217,int_stack+261,int_stack+7033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7996, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7786,int_stack+4764,int_stack+4736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5072, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12307,int_stack+7786,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8206, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+4815,int_stack+4800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7033,int_stack+4836,int_stack+4815, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4698,int_stack+7033,int_stack+261, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7786,int_stack+4864,int_stack+4836, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12433,int_stack+7786,int_stack+7033, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7033,int_stack+4915,int_stack+4900, 0.0, zero_stack, 1.0, int_stack+5000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+261,int_stack+4936,int_stack+4915, 0.0, zero_stack, 1.0, int_stack+5030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4788,int_stack+261,int_stack+7033, 0.0, zero_stack, 1.0, int_stack+7996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7786,int_stack+4964,int_stack+4936, 0.0, zero_stack, 1.0, int_stack+5072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+12559,int_stack+7786,int_stack+261, 0.0, zero_stack, 1.0, int_stack+8206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+261,int_stack+5051,int_stack+5015, 1.0, int_stack+5000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7033,int_stack+5100,int_stack+5051, 1.0, int_stack+5030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4878,int_stack+7033,int_stack+261, 1.0, int_stack+7996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7996,int_stack+5128,int_stack+5100, 1.0, int_stack+5072, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4968,int_stack+7996,int_stack+7033, 1.0, int_stack+8206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+8206,int_stack+5179,int_stack+5164,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7033,int_stack+5200,int_stack+5179,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+5094,int_stack+7033,int_stack+8206,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7996,int_stack+5228,int_stack+5200,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+12685,int_stack+7996,int_stack+7033,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+7033,int_stack+5279,int_stack+5264,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+8206,int_stack+5300,int_stack+5279,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+5184,int_stack+8206,int_stack+7033,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7996,int_stack+5328,int_stack+5300,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+12811,int_stack+7996,int_stack+8206,1);
 /*--- compute (00|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+8206,int_stack+5379,int_stack+5364,1);
 /*--- compute (00|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7033,int_stack+5400,int_stack+5379,1);
 /*--- compute (00|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+5274,int_stack+7033,int_stack+8206,1);
 /*--- compute (00|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7996,int_stack+5428,int_stack+5400,1);
 /*--- compute (00|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+12937,int_stack+7996,int_stack+7033,1);
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+13063,int_stack+5944,int_stack+5770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5572,1);
     Libderiv->ABCD[11] = int_stack + 13063;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+5860,int_stack+6307,int_stack+6133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5572, 0.0, zero_stack,1);
     Libderiv->ABCD[10] = int_stack + 5860;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6223,int_stack+6607,int_stack+6433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5572, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[9] = int_stack + 6223;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6523,int_stack+6907,int_stack+6733, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[8] = int_stack + 6523;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6823,int_stack+7270,int_stack+7096, 0.0, zero_stack, 1.0, int_stack+5572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[7] = int_stack + 6823;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+7186,int_stack+7570,int_stack+7396, 1.0, int_stack+5572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[6] = int_stack + 7186;
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+7486,int_stack+7870,int_stack+7696,1);
     Libderiv->ABCD[2] = int_stack + 7486;
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+7786,int_stack+8080,int_stack+171,1);
     Libderiv->ABCD[1] = int_stack + 7786;
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+7936,int_stack+8443,int_stack+8269,1);
     Libderiv->ABCD[0] = int_stack + 7936;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8086,int_stack+324,int_stack+8569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+5770,1);
     Libderiv->ABCD[155] = int_stack + 8086;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+261,int_stack+8833,int_stack+8659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5770, 1.0, int_stack+6133,1);
     Libderiv->ABCD[143] = int_stack + 261;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8359,int_stack+8959,int_stack+450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6133, 0.0, zero_stack,1);
     Libderiv->ABCD[142] = int_stack + 8359;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8509,int_stack+9085,int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5770, 0.0, zero_stack, 1.0, int_stack+6433,1);
     Libderiv->ABCD[131] = int_stack + 8509;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+411,int_stack+720,int_stack+630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6133, 1.0, int_stack+6433, 0.0, zero_stack,1);
     Libderiv->ABCD[130] = int_stack + 411;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+561,int_stack+9301,int_stack+9211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6433, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[129] = int_stack + 561;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8659,int_stack+9427,int_stack+846, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6733,1);
     Libderiv->ABCD[119] = int_stack + 8659;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+711,int_stack+1026,int_stack+936, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6133, 0.0, zero_stack, 1.0, int_stack+6733, 0.0, zero_stack,1);
     Libderiv->ABCD[118] = int_stack + 711;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+861,int_stack+9643,int_stack+9553, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6433, 1.0, int_stack+6733, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[117] = int_stack + 861;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8809,int_stack+9769,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+6733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[116] = int_stack + 8809;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1011,int_stack+9895,int_stack+1242, 0.0, zero_stack, 1.0, int_stack+5770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7096,1);
     Libderiv->ABCD[107] = int_stack + 1011;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1161,int_stack+1422,int_stack+1332, 0.0, zero_stack, 1.0, int_stack+6133, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7096, 0.0, zero_stack,1);
     Libderiv->ABCD[106] = int_stack + 1161;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1311,int_stack+10111,int_stack+10021, 0.0, zero_stack, 1.0, int_stack+6433, 0.0, zero_stack, 1.0, int_stack+7096, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[105] = int_stack + 1311;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+8959,int_stack+10237,int_stack+1548, 0.0, zero_stack, 1.0, int_stack+6733, 1.0, int_stack+7096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[104] = int_stack + 8959;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1461,int_stack+10363,int_stack+1638, 0.0, zero_stack, 2.0, int_stack+7096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[103] = int_stack + 1461;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+9109,int_stack+1818,int_stack+1728, 1.0, int_stack+5770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7396,1);
     Libderiv->ABCD[95] = int_stack + 9109;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1611,int_stack+1944,int_stack+5662, 1.0, int_stack+6133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7396, 0.0, zero_stack,1);
     Libderiv->ABCD[94] = int_stack + 1611;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1761,int_stack+2160,int_stack+2070, 1.0, int_stack+6433, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7396, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[93] = int_stack + 1761;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6373,int_stack+2376,int_stack+2286, 1.0, int_stack+6733, 0.0, zero_stack, 1.0, int_stack+7396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[92] = int_stack + 6373;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+6673,int_stack+2502,int_stack+0, 1.0, int_stack+7096, 1.0, int_stack+7396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[91] = int_stack + 6673;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+0,int_stack+2718,int_stack+2628, 2.0, int_stack+7396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[90] = int_stack + 0;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+7336,int_stack+2844,int_stack+10489, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7696,1);
     Libderiv->ABCD[47] = int_stack + 7336;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1911,int_stack+10669,int_stack+10579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7696, 0.0, zero_stack,1);
     Libderiv->ABCD[46] = int_stack + 1911;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2061,int_stack+10795,int_stack+2970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7696, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[45] = int_stack + 2061;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2211,int_stack+10921,int_stack+3060, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[44] = int_stack + 2211;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2361,int_stack+3240,int_stack+3150, 0.0, zero_stack, 1.0, int_stack+7696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[43] = int_stack + 2361;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2511,int_stack+3366,int_stack+11047, 1.0, int_stack+7696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[42] = int_stack + 2511;
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+7636,int_stack+3492,int_stack+11137,1);
     Libderiv->ABCD[38] = int_stack + 7636;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2661,int_stack+11317,int_stack+11227, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171,1);
     Libderiv->ABCD[35] = int_stack + 2661;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2811,int_stack+3708,int_stack+3618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171, 0.0, zero_stack,1);
     Libderiv->ABCD[34] = int_stack + 2811;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2961,int_stack+11533,int_stack+11443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[33] = int_stack + 2961;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3111,int_stack+11659,int_stack+3834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[32] = int_stack + 3111;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3261,int_stack+11785,int_stack+3924, 0.0, zero_stack, 1.0, int_stack+171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[31] = int_stack + 3261;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3411,int_stack+4014,int_stack+11911, 1.0, int_stack+171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[30] = int_stack + 3411;
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+3561,int_stack+4140,int_stack+5464,1);
     Libderiv->ABCD[26] = int_stack + 3561;
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+3711,int_stack+4356,int_stack+4266,1);
     Libderiv->ABCD[25] = int_stack + 3711;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+3861,int_stack+12091,int_stack+12001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8269,1);
     Libderiv->ABCD[23] = int_stack + 3861;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+4011,int_stack+4572,int_stack+4482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8269, 0.0, zero_stack,1);
     Libderiv->ABCD[22] = int_stack + 4011;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+4161,int_stack+12307,int_stack+12217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8269, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[21] = int_stack + 4161;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+4311,int_stack+12433,int_stack+4698, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[20] = int_stack + 4311;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+4461,int_stack+12559,int_stack+4788, 0.0, zero_stack, 1.0, int_stack+8269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[19] = int_stack + 4461;
 /*--- compute (00|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+4611,int_stack+4968,int_stack+4878, 1.0, int_stack+8269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,1);
     Libderiv->ABCD[18] = int_stack + 4611;
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+4761,int_stack+12685,int_stack+5094,1);
     Libderiv->ABCD[14] = int_stack + 4761;
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+4911,int_stack+12811,int_stack+5184,1);
     Libderiv->ABCD[13] = int_stack + 4911;
 /*--- compute (00|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+5061,int_stack+12937,int_stack+5274,1);
     Libderiv->ABCD[12] = int_stack + 5061;

}
