#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_d0hd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (d0|hd) integrals */

void d1hrr_order_d0hd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][5][11] = int_stack + 0;
 Libderiv->deriv_classes[2][6][11] = int_stack + 126;
 Libderiv->deriv_classes[2][7][11] = int_stack + 294;
 Libderiv->deriv_classes[2][5][10] = int_stack + 510;
 Libderiv->deriv_classes[2][6][10] = int_stack + 636;
 Libderiv->deriv_classes[2][7][10] = int_stack + 804;
 Libderiv->deriv_classes[2][5][9] = int_stack + 1020;
 Libderiv->deriv_classes[2][6][9] = int_stack + 1146;
 Libderiv->deriv_classes[2][7][9] = int_stack + 1314;
 Libderiv->deriv_classes[2][5][8] = int_stack + 1530;
 Libderiv->deriv_classes[2][6][8] = int_stack + 1656;
 Libderiv->deriv_classes[2][7][8] = int_stack + 1824;
 Libderiv->deriv_classes[2][5][7] = int_stack + 2040;
 Libderiv->deriv_classes[2][6][7] = int_stack + 2166;
 Libderiv->deriv_classes[2][7][7] = int_stack + 2334;
 Libderiv->dvrr_classes[2][5] = int_stack + 2550;
 Libderiv->deriv_classes[2][5][6] = int_stack + 2676;
 Libderiv->dvrr_classes[2][6] = int_stack + 2802;
 Libderiv->deriv_classes[2][6][6] = int_stack + 2970;
 Libderiv->deriv_classes[2][7][6] = int_stack + 3138;
 Libderiv->deriv_classes[2][5][2] = int_stack + 3354;
 Libderiv->deriv_classes[2][6][2] = int_stack + 3480;
 Libderiv->deriv_classes[2][7][2] = int_stack + 3648;
 Libderiv->deriv_classes[2][5][1] = int_stack + 3864;
 Libderiv->deriv_classes[2][6][1] = int_stack + 3990;
 Libderiv->deriv_classes[2][7][1] = int_stack + 4158;
 Libderiv->deriv_classes[2][5][0] = int_stack + 4374;
 Libderiv->deriv_classes[2][6][0] = int_stack + 4500;
 Libderiv->deriv_classes[2][7][0] = int_stack + 4668;
 memset(int_stack,0,39072);

 Libderiv->dvrr_stack = int_stack + 9924;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_d0hd(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4884,int_stack+2802,int_stack+2550,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5262,int_stack+126,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2550,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5640,int_stack+294,int_stack+126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2802,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+636,int_stack+510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2550, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6144,int_stack+804,int_stack+636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2802, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+1146,int_stack+1020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2550, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6648,int_stack+1314,int_stack+1146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2802, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+756,int_stack+1656,int_stack+1530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1134,int_stack+1824,int_stack+1656, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1638,int_stack+2166,int_stack+2040, 0.0, zero_stack, 1.0, int_stack+2550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7152,int_stack+2334,int_stack+2166, 0.0, zero_stack, 1.0, int_stack+2802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2016,int_stack+2970,int_stack+2676, 1.0, int_stack+2550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7656,int_stack+3138,int_stack+2970, 1.0, int_stack+2802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2394,int_stack+3480,int_stack+3354,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2772,int_stack+3648,int_stack+3480,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3276,int_stack+3990,int_stack+3864,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8160,int_stack+4158,int_stack+3990,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3654,int_stack+4500,int_stack+4374,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+8664,int_stack+4668,int_stack+4500,6);
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4032,int_stack+5640,int_stack+5262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4884,6);
     Libderiv->ABCD[11] = int_stack + 4032;
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+5262,int_stack+6144,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4884, 0.0, zero_stack,6);
     Libderiv->ABCD[10] = int_stack + 5262;
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+9168,int_stack+6648,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4884, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[9] = int_stack + 9168;
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+1134,int_stack+756, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+756,int_stack+7152,int_stack+1638, 0.0, zero_stack, 1.0, int_stack+4884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[7] = int_stack + 756;
 /*--- compute (d0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6018,int_stack+7656,int_stack+2016, 1.0, int_stack+4884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[6] = int_stack + 6018;
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1512,int_stack+2772,int_stack+2394,6);
     Libderiv->ABCD[2] = int_stack + 1512;
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2268,int_stack+8160,int_stack+3276,6);
     Libderiv->ABCD[1] = int_stack + 2268;
 /*--- compute (d0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6774,int_stack+8664,int_stack+3654,6);
     Libderiv->ABCD[0] = int_stack + 6774;

}
