#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_i0ff(Libint_t*, prim_data*);

  /* Computes quartets of (i0|ff) integrals */

REALTYPE *hrr_order_i0ff(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][3] = int_stack + 0;
 Libint->vrr_classes[6][4] = int_stack + 280;
 Libint->vrr_classes[6][5] = int_stack + 700;
 Libint->vrr_classes[6][6] = int_stack + 1288;
 memset(int_stack,0,2072*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 2072;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_i0ff(Libint, Data);
   Data++;
 }
 /*--- compute (i0|fp) ---*/
 hrr3_build_fp(Libint->CD,int_stack+2072,int_stack+280,int_stack+0,28);
 /*--- compute (i0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+2912,int_stack+700,int_stack+280,28);
 /*--- compute (i0|fd) ---*/
 hrr3_build_fd(Libint->CD,int_stack+4172,int_stack+2912,int_stack+2072,28);
 /*--- compute (i0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+5852,int_stack+1288,int_stack+700,28);
 /*--- compute (i0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+0,int_stack+5852,int_stack+2912,28);
 /*--- compute (i0|ff) ---*/
 hrr3_build_ff(Libint->CD,int_stack+5852,int_stack+0,int_stack+4172,28);
 return int_stack+5852;}
