#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipgf(Libint_t*, prim_data*);

  /* Computes quartets of (ip|gf) integrals */

REALTYPE *hrr_order_ipgf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][4] = int_stack + 0;
 Libint->vrr_classes[6][5] = int_stack + 420;
 Libint->vrr_classes[6][6] = int_stack + 1008;
 Libint->vrr_classes[6][7] = int_stack + 1792;
 Libint->vrr_classes[7][4] = int_stack + 2800;
 Libint->vrr_classes[7][5] = int_stack + 3340;
 Libint->vrr_classes[7][6] = int_stack + 4096;
 Libint->vrr_classes[7][7] = int_stack + 5104;
 memset(int_stack,0,6400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 6400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipgf(Libint, Data);
   Data++;
 }
 /*--- compute (i0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+6400,int_stack+420,int_stack+0,28);
 /*--- compute (i0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+7660,int_stack+1008,int_stack+420,28);
 /*--- compute (i0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+9424,int_stack+7660,int_stack+6400,28);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+11944,int_stack+1792,int_stack+1008,28);
 /*--- compute (i0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+14296,int_stack+11944,int_stack+7660,28);
 /*--- compute (i0|gf) ---*/
 hrr3_build_gf(Libint->CD,int_stack+17824,int_stack+14296,int_stack+9424,28);
 /*--- compute (k0|gp) ---*/
 hrr3_build_gp(Libint->CD,int_stack+6400,int_stack+3340,int_stack+2800,36);
 /*--- compute (k0|hp) ---*/
 hrr3_build_hp(Libint->CD,int_stack+8020,int_stack+4096,int_stack+3340,36);
 /*--- compute (k0|gd) ---*/
 hrr3_build_gd(Libint->CD,int_stack+10288,int_stack+8020,int_stack+6400,36);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+13528,int_stack+5104,int_stack+4096,36);
 /*--- compute (k0|hd) ---*/
 hrr3_build_hd(Libint->CD,int_stack+0,int_stack+13528,int_stack+8020,36);
 /*--- compute (k0|gf) ---*/
 hrr3_build_gf(Libint->CD,int_stack+4536,int_stack+0,int_stack+10288,36);
 /*--- compute (ip|gf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+22024,int_stack+4536,int_stack+17824,150);
 return int_stack+22024;}
