#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/hrr_header.h>

#include "r12_hrr_header.h"

extern void vrr_grt_order_hghh(Libr12_t *, prim_data *);

  /* Computes (hg|hh) integrals for linear R12-methods */

void hrr_grt_order_hghh(Libr12_t *Libr12, int num_prim_comb)
{
 prim_data *Data = Libr12->PrimQuartet;
 REALTYPE *int_stack = Libr12->int_stack;
 int i,j;
 REALTYPE tmp, *target;

 Libr12->t2vrr_classes[5][5] = int_stack + 0;
 Libr12->t2vrr_classes[5][6] = int_stack + 441;
 Libr12->t2vrr_classes[5][7] = int_stack + 1029;
 Libr12->t2vrr_classes[5][8] = int_stack + 1785;
 Libr12->t2vrr_classes[5][9] = int_stack + 2730;
 Libr12->t2vrr_classes[5][10] = int_stack + 3885;
 Libr12->t2vrr_classes[6][5] = int_stack + 5271;
 Libr12->t2vrr_classes[6][6] = int_stack + 5859;
 Libr12->t2vrr_classes[6][7] = int_stack + 6643;
 Libr12->t2vrr_classes[6][8] = int_stack + 7651;
 Libr12->t2vrr_classes[6][9] = int_stack + 8911;
 Libr12->t2vrr_classes[6][10] = int_stack + 10451;
 Libr12->t2vrr_classes[7][5] = int_stack + 12299;
 Libr12->t2vrr_classes[7][6] = int_stack + 13055;
 Libr12->t2vrr_classes[7][7] = int_stack + 14063;
 Libr12->t2vrr_classes[7][8] = int_stack + 15359;
 Libr12->t2vrr_classes[7][9] = int_stack + 16979;
 Libr12->t2vrr_classes[7][10] = int_stack + 18959;
 Libr12->t2vrr_classes[8][5] = int_stack + 21335;
 Libr12->t2vrr_classes[8][6] = int_stack + 22280;
 Libr12->t2vrr_classes[8][7] = int_stack + 23540;
 Libr12->t2vrr_classes[8][8] = int_stack + 25160;
 Libr12->t2vrr_classes[8][9] = int_stack + 27185;
 Libr12->t2vrr_classes[8][10] = int_stack + 29660;
 Libr12->gvrr_classes[10][5] = int_stack + 32630;
 Libr12->t2vrr_classes[9][5] = int_stack + 34016;
 Libr12->gvrr_classes[10][6] = int_stack + 35171;
 Libr12->t2vrr_classes[9][6] = int_stack + 37019;
 Libr12->gvrr_classes[10][7] = int_stack + 38559;
 Libr12->t2vrr_classes[9][7] = int_stack + 40935;
 Libr12->gvrr_classes[10][8] = int_stack + 42915;
 Libr12->t2vrr_classes[9][8] = int_stack + 45885;
 Libr12->gvrr_classes[10][9] = int_stack + 48360;
 Libr12->t2vrr_classes[9][9] = int_stack + 51990;
 Libr12->t2vrr_classes[9][10] = int_stack + 55015;
 Libr12->gvrr_classes[5][11] = int_stack + 58645;
 Libr12->t1vrr_classes[5][5] = int_stack + 60283;
 Libr12->t1vrr_classes[5][6] = int_stack + 60724;
 Libr12->t1vrr_classes[5][7] = int_stack + 61312;
 Libr12->t1vrr_classes[5][8] = int_stack + 62068;
 Libr12->t1vrr_classes[5][9] = int_stack + 63013;
 Libr12->t1vrr_classes[5][10] = int_stack + 64168;
 Libr12->gvrr_classes[6][11] = int_stack + 65554;
 Libr12->t1vrr_classes[6][5] = int_stack + 67738;
 Libr12->t1vrr_classes[6][6] = int_stack + 68326;
 Libr12->t1vrr_classes[6][7] = int_stack + 69110;
 Libr12->t1vrr_classes[6][8] = int_stack + 70118;
 Libr12->t1vrr_classes[6][9] = int_stack + 71378;
 Libr12->t1vrr_classes[6][10] = int_stack + 72918;
 Libr12->gvrr_classes[7][11] = int_stack + 74766;
 Libr12->t1vrr_classes[7][5] = int_stack + 77574;
 Libr12->t1vrr_classes[7][6] = int_stack + 78330;
 Libr12->t1vrr_classes[7][7] = int_stack + 79338;
 Libr12->t1vrr_classes[7][8] = int_stack + 80634;
 Libr12->t1vrr_classes[7][9] = int_stack + 82254;
 Libr12->t1vrr_classes[7][10] = int_stack + 84234;
 Libr12->gvrr_classes[8][11] = int_stack + 86610;
 Libr12->t1vrr_classes[8][5] = int_stack + 90120;
 Libr12->t1vrr_classes[8][6] = int_stack + 91065;
 Libr12->t1vrr_classes[8][7] = int_stack + 92325;
 Libr12->t1vrr_classes[8][8] = int_stack + 93945;
 Libr12->t1vrr_classes[8][9] = int_stack + 95970;
 Libr12->t1vrr_classes[8][10] = int_stack + 98445;
 Libr12->t1vrr_classes[9][5] = int_stack + 101415;
 Libr12->t1vrr_classes[9][6] = int_stack + 102570;
 Libr12->t1vrr_classes[9][7] = int_stack + 104110;
 Libr12->t1vrr_classes[9][8] = int_stack + 106090;
 Libr12->t1vrr_classes[9][9] = int_stack + 108565;
 Libr12->t1vrr_classes[9][10] = int_stack + 111590;
 Libr12->rvrr_classes[5][5] = int_stack + 115220;
 Libr12->rvrr_classes[5][6] = int_stack + 115661;
 Libr12->rvrr_classes[5][7] = int_stack + 116249;
 Libr12->rvrr_classes[5][8] = int_stack + 117005;
 Libr12->rvrr_classes[5][9] = int_stack + 117950;
 Libr12->rvrr_classes[5][10] = int_stack + 119105;
 Libr12->rvrr_classes[6][5] = int_stack + 120491;
 Libr12->rvrr_classes[6][6] = int_stack + 121079;
 Libr12->rvrr_classes[6][7] = int_stack + 121863;
 Libr12->rvrr_classes[6][8] = int_stack + 122871;
 Libr12->rvrr_classes[6][9] = int_stack + 124131;
 Libr12->rvrr_classes[6][10] = int_stack + 125671;
 Libr12->rvrr_classes[7][5] = int_stack + 127519;
 Libr12->rvrr_classes[7][6] = int_stack + 128275;
 Libr12->rvrr_classes[7][7] = int_stack + 129283;
 Libr12->rvrr_classes[7][8] = int_stack + 130579;
 Libr12->rvrr_classes[7][9] = int_stack + 132199;
 Libr12->rvrr_classes[7][10] = int_stack + 134179;
 Libr12->rvrr_classes[8][5] = int_stack + 136555;
 Libr12->rvrr_classes[8][6] = int_stack + 137500;
 Libr12->rvrr_classes[8][7] = int_stack + 138760;
 Libr12->rvrr_classes[8][8] = int_stack + 140380;
 Libr12->rvrr_classes[8][9] = int_stack + 142405;
 Libr12->rvrr_classes[8][10] = int_stack + 144880;
 Libr12->rvrr_classes[9][5] = int_stack + 147850;
 Libr12->rvrr_classes[9][6] = int_stack + 149005;
 Libr12->rvrr_classes[9][7] = int_stack + 150545;
 Libr12->rvrr_classes[9][8] = int_stack + 152525;
 Libr12->rvrr_classes[9][9] = int_stack + 155000;
 Libr12->rvrr_classes[9][10] = int_stack + 158025;
 Libr12->gvrr_classes[5][5] = int_stack + 161655;
 Libr12->gvrr_classes[5][6] = int_stack + 162096;
 Libr12->gvrr_classes[5][7] = int_stack + 162684;
 Libr12->gvrr_classes[5][8] = int_stack + 163440;
 Libr12->gvrr_classes[5][9] = int_stack + 164385;
 Libr12->gvrr_classes[5][10] = int_stack + 165540;
 Libr12->gvrr_classes[6][5] = int_stack + 166926;
 Libr12->gvrr_classes[6][6] = int_stack + 167514;
 Libr12->gvrr_classes[6][7] = int_stack + 168298;
 Libr12->gvrr_classes[6][8] = int_stack + 169306;
 Libr12->gvrr_classes[6][9] = int_stack + 170566;
 Libr12->gvrr_classes[6][10] = int_stack + 172106;
 Libr12->gvrr_classes[7][5] = int_stack + 173954;
 Libr12->gvrr_classes[7][6] = int_stack + 174710;
 Libr12->gvrr_classes[7][7] = int_stack + 175718;
 Libr12->gvrr_classes[7][8] = int_stack + 177014;
 Libr12->gvrr_classes[7][9] = int_stack + 178634;
 Libr12->gvrr_classes[7][10] = int_stack + 180614;
 Libr12->gvrr_classes[8][5] = int_stack + 182990;
 Libr12->gvrr_classes[8][6] = int_stack + 183935;
 Libr12->gvrr_classes[8][7] = int_stack + 185195;
 Libr12->gvrr_classes[8][8] = int_stack + 186815;
 Libr12->gvrr_classes[8][9] = int_stack + 188840;
 Libr12->gvrr_classes[8][10] = int_stack + 191315;
 Libr12->gvrr_classes[9][5] = int_stack + 194285;
 Libr12->gvrr_classes[9][6] = int_stack + 195440;
 Libr12->gvrr_classes[9][7] = int_stack + 196980;
 Libr12->gvrr_classes[9][8] = int_stack + 198960;
 Libr12->gvrr_classes[9][9] = int_stack + 201435;
 Libr12->gvrr_classes[9][10] = int_stack + 204460;
 memset(int_stack,0,208090*sizeof(REALTYPE));

 Libr12->r12vrr_stack = int_stack + 208090;
 for(i=0;i<num_prim_comb;i++) {
   vrr_grt_order_hghh(Libr12, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+208090, int_stack+162096, int_stack+161655, 21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+209413, int_stack+162684, int_stack+162096, 21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+211177, int_stack+209413, int_stack+208090, 21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+213823, int_stack+163440, int_stack+162684, 21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+216091, int_stack+213823, int_stack+209413, 21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+219619, int_stack+216091, int_stack+211177, 21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+224029, int_stack+164385, int_stack+163440, 21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+226864, int_stack+224029, int_stack+213823, 21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+231400, int_stack+226864, int_stack+216091, 21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+237280, int_stack+231400, int_stack+219619, 21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+243895, int_stack+167514, int_stack+166926, 28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+245659, int_stack+168298, int_stack+167514, 28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+248011, int_stack+245659, int_stack+243895, 28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+251539, int_stack+169306, int_stack+168298, 28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+254563, int_stack+251539, int_stack+245659, 28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+259267, int_stack+254563, int_stack+248011, 28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+265147, int_stack+170566, int_stack+169306, 28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+268927, int_stack+265147, int_stack+251539, 28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+274975, int_stack+268927, int_stack+254563, 28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+282815, int_stack+274975, int_stack+259267, 28);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+291635, int_stack+165540, int_stack+164385, 21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+295100, int_stack+291635, int_stack+224029, 21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+300770, int_stack+295100, int_stack+226864, 21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+308330, int_stack+300770, int_stack+231400, 21);
 /*--- compute (h0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+317150, int_stack+441, int_stack+0, int_stack+162096, int_stack+166926, int_stack+161655, 5, 0);
 /*--- compute (h0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+318473, int_stack+1029, int_stack+441, int_stack+162684, int_stack+167514, int_stack+162096, 5, 0);
 /*--- compute (h0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+320237, int_stack+318473, int_stack+317150, int_stack+209413, int_stack+243895, int_stack+208090, 5, 0);
 /*--- compute (h0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+322883, int_stack+1785, int_stack+1029, int_stack+163440, int_stack+168298, int_stack+162684, 5, 0);
 /*--- compute (h0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+325151, int_stack+322883, int_stack+318473, int_stack+213823, int_stack+245659, int_stack+209413, 5, 0);
 /*--- compute (h0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+328679, int_stack+325151, int_stack+320237, int_stack+216091, int_stack+248011, int_stack+211177, 5, 0);
 /*--- compute (h0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+208090, int_stack+2730, int_stack+1785, int_stack+164385, int_stack+169306, int_stack+163440, 5, 0);
 /*--- compute (h0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+317150, int_stack+208090, int_stack+322883, int_stack+224029, int_stack+251539, int_stack+213823, 5, 0);
 /*--- compute (h0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+333089, int_stack+317150, int_stack+325151, int_stack+226864, int_stack+254563, int_stack+216091, 5, 0);
 /*--- compute (h0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+210925, int_stack+333089, int_stack+328679, int_stack+231400, int_stack+259267, int_stack+219619, 5, 0);
 /*--- compute (h0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+217540, int_stack+3885, int_stack+2730, int_stack+165540, int_stack+170566, int_stack+164385, 5, 0);
 /*--- compute (h0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+321686, int_stack+217540, int_stack+208090, int_stack+291635, int_stack+265147, int_stack+224029, 5, 0);
 /*--- compute (h0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+217540, int_stack+321686, int_stack+317150, int_stack+295100, int_stack+268927, int_stack+226864, 5, 0);
 /*--- compute (h0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+317150, int_stack+217540, int_stack+333089, int_stack+300770, int_stack+274975, int_stack+231400, 5, 0);
 /*--- compute (h0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+217540, int_stack+317150, int_stack+210925, int_stack+308330, int_stack+282815, int_stack+237280, 5, 0);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+317150, int_stack+174710, int_stack+173954, 36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+319418, int_stack+175718, int_stack+174710, 36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+322442, int_stack+319418, int_stack+317150, 36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+326978, int_stack+177014, int_stack+175718, 36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+330866, int_stack+326978, int_stack+319418, 36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+226801, int_stack+330866, int_stack+322442, 36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+208090, int_stack+178634, int_stack+177014, 36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+336914, int_stack+208090, int_stack+326978, 36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+344690, int_stack+336914, int_stack+330866, 36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+354770, int_stack+344690, int_stack+226801, 36);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+0, int_stack+172106, int_stack+170566, 28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+366110, int_stack+0, int_stack+265147, 28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+373670, int_stack+366110, int_stack+268927, 28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+383750, int_stack+373670, int_stack+274975, 28);
 /*--- compute (i0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+234361, int_stack+5859, int_stack+5271, int_stack+167514, int_stack+173954, int_stack+166926, 6, 0);
 /*--- compute (i0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+212950, int_stack+6643, int_stack+5859, int_stack+168298, int_stack+174710, int_stack+167514, 6, 0);
 /*--- compute (i0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+161655, int_stack+212950, int_stack+234361, int_stack+245659, int_stack+317150, int_stack+243895, 6, 0);
 /*--- compute (i0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+395510, int_stack+7651, int_stack+6643, int_stack+169306, int_stack+175718, int_stack+168298, 6, 0);
 /*--- compute (i0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+398534, int_stack+395510, int_stack+212950, int_stack+251539, int_stack+319418, int_stack+245659, 6, 0);
 /*--- compute (i0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+403238, int_stack+398534, int_stack+161655, int_stack+254563, int_stack+322442, int_stack+248011, 6, 0);
 /*--- compute (i0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+161655, int_stack+8911, int_stack+7651, int_stack+170566, int_stack+177014, int_stack+169306, 6, 0);
 /*--- compute (i0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+243895, int_stack+161655, int_stack+395510, int_stack+265147, int_stack+326978, int_stack+251539, 6, 0);
 /*--- compute (i0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+409118, int_stack+243895, int_stack+398534, int_stack+268927, int_stack+330866, int_stack+254563, 6, 0);
 /*--- compute (i0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+249943, int_stack+409118, int_stack+403238, int_stack+274975, int_stack+226801, int_stack+259267, 6, 0);
 /*--- compute (i0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+395510, int_stack+10451, int_stack+8911, int_stack+172106, int_stack+178634, int_stack+170566, 6, 0);
 /*--- compute (i0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+400130, int_stack+395510, int_stack+161655, int_stack+0, int_stack+208090, int_stack+265147, 6, 0);
 /*--- compute (i0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+258763, int_stack+400130, int_stack+243895, int_stack+366110, int_stack+336914, int_stack+268927, 6, 0);
 /*--- compute (i0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+395510, int_stack+258763, int_stack+409118, int_stack+373670, int_stack+344690, int_stack+274975, 6, 0);
 /*--- compute (i0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+258763, int_stack+395510, int_stack+249943, int_stack+383750, int_stack+354770, int_stack+282815, 6, 0);
 /*--- compute (hp|[r12,T2]|hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+395510, int_stack+258763, int_stack+217540, 441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+271111, int_stack+183935, int_stack+182990, 45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+273946, int_stack+185195, int_stack+183935, 45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+243895, int_stack+273946, int_stack+271111, 45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+277726, int_stack+186815, int_stack+185195, 45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+249565, int_stack+277726, int_stack+273946, 45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+212950, int_stack+249565, int_stack+243895, 45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+4620, int_stack+188840, int_stack+186815, 45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+423293, int_stack+4620, int_stack+277726, 45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+433013, int_stack+423293, int_stack+249565, 45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+445613, int_stack+433013, int_stack+212950, 45);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+459788, int_stack+180614, int_stack+178634, 36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+465728, int_stack+459788, int_stack+208090, 36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+475448, int_stack+465728, int_stack+336914, 36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+488408, int_stack+475448, int_stack+344690, 36);
 /*--- compute (k0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+161655, int_stack+13055, int_stack+12299, int_stack+174710, int_stack+182990, int_stack+173954, 7, 0);
 /*--- compute (k0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+222400, int_stack+14063, int_stack+13055, int_stack+175718, int_stack+183935, int_stack+174710, 7, 0);
 /*--- compute (k0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+166926, int_stack+222400, int_stack+161655, int_stack+319418, int_stack+271111, int_stack+317150, 7, 0);
 /*--- compute (k0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+503528, int_stack+15359, int_stack+14063, int_stack+177014, int_stack+185195, int_stack+175718, 7, 0);
 /*--- compute (k0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+507416, int_stack+503528, int_stack+222400, int_stack+326978, int_stack+273946, int_stack+319418, 7, 0);
 /*--- compute (k0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+513464, int_stack+507416, int_stack+166926, int_stack+330866, int_stack+243895, int_stack+322442, 7, 0);
 /*--- compute (k0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+166926, int_stack+16979, int_stack+15359, int_stack+178634, int_stack+186815, int_stack+177014, 7, 0);
 /*--- compute (k0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+317150, int_stack+166926, int_stack+503528, int_stack+208090, int_stack+277726, int_stack+326978, 7, 0);
 /*--- compute (k0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+521024, int_stack+317150, int_stack+507416, int_stack+336914, int_stack+249565, int_stack+330866, 7, 0);
 /*--- compute (k0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+324926, int_stack+521024, int_stack+513464, int_stack+344690, int_stack+212950, int_stack+226801, 7, 0);
 /*--- compute (k0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+503528, int_stack+18959, int_stack+16979, int_stack+180614, int_stack+188840, int_stack+178634, 7, 0);
 /*--- compute (k0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+509468, int_stack+503528, int_stack+166926, int_stack+459788, int_stack+4620, int_stack+208090, 7, 0);
 /*--- compute (k0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+222400, int_stack+509468, int_stack+317150, int_stack+465728, int_stack+423293, int_stack+336914, 7, 0);
 /*--- compute (k0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+503528, int_stack+222400, int_stack+521024, int_stack+475448, int_stack+433013, int_stack+344690, 7, 0);
 /*--- compute (k0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+336266, int_stack+503528, int_stack+324926, int_stack+488408, int_stack+445613, int_stack+354770, 7, 0);
 /*--- compute (ip|[r12,T2]|hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+503528, int_stack+336266, int_stack+258763, 441);
 /*--- compute (hd|[r12,T2]|hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+540572, int_stack+503528, int_stack+395510, 441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+395510, int_stack+195440, int_stack+194285, 55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+398975, int_stack+196980, int_stack+195440, 55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+403595, int_stack+398975, int_stack+395510, 55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+410525, int_stack+198960, int_stack+196980, 55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+222400, int_stack+410525, int_stack+398975, 55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+317150, int_stack+222400, int_stack+403595, 55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+328700, int_stack+201435, int_stack+198960, 55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+257125, int_stack+328700, int_stack+410525, 55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+596138, int_stack+257125, int_stack+222400, 55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+611538, int_stack+596138, int_stack+317150, 55);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+10695, int_stack+191315, int_stack+188840, 45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+628863, int_stack+10695, int_stack+4620, 45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+641013, int_stack+628863, int_stack+423293, 45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+657213, int_stack+641013, int_stack+433013, 45);
 /*--- compute (l0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+416465, int_stack+22280, int_stack+21335, int_stack+183935, int_stack+194285, int_stack+182990, 8, 0);
 /*--- compute (l0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+419300, int_stack+23540, int_stack+22280, int_stack+185195, int_stack+195440, int_stack+183935, 8, 0);
 /*--- compute (l0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+173954, int_stack+419300, int_stack+416465, int_stack+273946, int_stack+395510, int_stack+271111, 8, 0);
 /*--- compute (l0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+208090, int_stack+25160, int_stack+23540, int_stack+186815, int_stack+196980, int_stack+185195, 8, 0);
 /*--- compute (l0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+676113, int_stack+208090, int_stack+419300, int_stack+277726, int_stack+398975, int_stack+273946, 8, 0);
 /*--- compute (l0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+683673, int_stack+676113, int_stack+173954, int_stack+249565, int_stack+403595, int_stack+243895, 8, 0);
 /*--- compute (l0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+173954, int_stack+27185, int_stack+25160, int_stack+188840, int_stack+198960, int_stack+186815, 8, 0);
 /*--- compute (l0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+693123, int_stack+173954, int_stack+208090, int_stack+4620, int_stack+410525, int_stack+277726, 8, 0);
 /*--- compute (l0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+269005, int_stack+693123, int_stack+676113, int_stack+423293, int_stack+222400, int_stack+249565, 8, 0);
 /*--- compute (l0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+702843, int_stack+269005, int_stack+683673, int_stack+433013, int_stack+317150, int_stack+212950, 8, 0);
 /*--- compute (l0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+676113, int_stack+29660, int_stack+27185, int_stack+191315, int_stack+201435, int_stack+188840, 8, 0);
 /*--- compute (l0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+208090, int_stack+676113, int_stack+173954, int_stack+10695, int_stack+328700, int_stack+4620, 8, 0);
 /*--- compute (l0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+676113, int_stack+208090, int_stack+693123, int_stack+628863, int_stack+257125, int_stack+423293, 8, 0);
 /*--- compute (l0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+717018, int_stack+676113, int_stack+269005, int_stack+641013, int_stack+596138, int_stack+433013, 8, 0);
 /*--- compute (l0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+676113, int_stack+717018, int_stack+702843, int_stack+657213, int_stack+611538, int_stack+445613, 8, 0);
 /*--- compute (kp|[r12,T2]|hh) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+695958, int_stack+676113, int_stack+336266, 441);
 /*--- compute (id|[r12,T2]|hh) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+743586, int_stack+695958, int_stack+503528, 441);
 /*--- compute (hf|[r12,T2]|hh) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+817674, int_stack+743586, int_stack+540572, 441);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+503528, int_stack+35171, int_stack+32630, 66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+507686, int_stack+38559, int_stack+35171, 66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+513230, int_stack+507686, int_stack+503528, 66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+521546, int_stack+42915, int_stack+38559, 66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+528674, int_stack+521546, int_stack+507686, 66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+539762, int_stack+528674, int_stack+513230, 66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+553622, int_stack+48360, int_stack+42915, 66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+562532, int_stack+553622, int_stack+521546, 66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+576788, int_stack+562532, int_stack+528674, 66);
 /*--- compute (n0|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+416465, int_stack+576788, int_stack+539762, 66);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+269005, int_stack+204460, int_stack+201435, 55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+336125, int_stack+269005, int_stack+328700, 55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+910284, int_stack+336125, int_stack+257125, 55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+930084, int_stack+910284, int_stack+596138, 55);
 /*--- compute (m0|[r12,T2]|hp) ---*/
   t2hrr3_build_hp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+278080, int_stack+37019, int_stack+34016, int_stack+195440, int_stack+32630, int_stack+194285, 9, 0);
 /*--- compute (m0|[r12,T2]|ip) ---*/
   t2hrr3_build_ip(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+208090, int_stack+40935, int_stack+37019, int_stack+196980, int_stack+35171, int_stack+195440, 9, 0);
 /*--- compute (m0|[r12,T2]|hd) ---*/
   t2hrr3_build_hd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+212710, int_stack+208090, int_stack+278080, int_stack+398975, int_stack+503528, int_stack+395510, 9, 0);
 /*--- compute (m0|[r12,T2]|kp) ---*/
   t2hrr3_build_kp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+4620, int_stack+45885, int_stack+40935, int_stack+198960, int_stack+38559, int_stack+196980, 9, 0);
 /*--- compute (m0|[r12,T2]|id) ---*/
   t2hrr3_build_id(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+243895, int_stack+4620, int_stack+208090, int_stack+410525, int_stack+507686, int_stack+398975, 9, 0);
 /*--- compute (m0|[r12,T2]|hf) ---*/
   t2hrr3_build_hf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+18120, int_stack+243895, int_stack+212710, int_stack+222400, int_stack+513230, int_stack+403595, 9, 0);
 /*--- compute (m0|[r12,T2]|lp) ---*/
   t2hrr3_build_lp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+208090, int_stack+51990, int_stack+45885, int_stack+201435, int_stack+42915, int_stack+198960, 9, 0);
 /*--- compute (m0|[r12,T2]|kd) ---*/
   t2hrr3_build_kd(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+395510, int_stack+208090, int_stack+4620, int_stack+328700, int_stack+521546, int_stack+410525, 9, 0);
 /*--- compute (m0|[r12,T2]|if) ---*/
   t2hrr3_build_if(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+503528, int_stack+395510, int_stack+243895, int_stack+257125, int_stack+528674, int_stack+222400, 9, 0);
 /*--- compute (m0|[r12,T2]|hg) ---*/
   t2hrr3_build_hg(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+215515, int_stack+503528, int_stack+18120, int_stack+596138, int_stack+539762, int_stack+317150, 9, 0);
 /*--- compute (m0|[r12,T2]|mp) ---*/
   t2hrr3_build_mp(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+407390, int_stack+55015, int_stack+51990, int_stack+204460, int_stack+48360, int_stack+201435, 9, 0);
 /*--- compute (m0|[r12,T2]|ld) ---*/
   t2hrr3_build_ld(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+18120, int_stack+407390, int_stack+208090, int_stack+269005, int_stack+553622, int_stack+328700, 9, 0);
 /*--- compute (m0|[r12,T2]|kf) ---*/
   t2hrr3_build_kf(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+32970, int_stack+18120, int_stack+395510, int_stack+336125, int_stack+562532, int_stack+257125, 9, 0);
 /*--- compute (m0|[r12,T2]|ig) ---*/
   t2hrr3_build_ig(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+317150, int_stack+32970, int_stack+503528, int_stack+910284, int_stack+576788, int_stack+596138, 9, 0);
 /*--- compute (m0|[r12,T2]|hh) ---*/
   t2hrr3_build_hh(Libr12->ShellQuartet.CD,Libr12->ShellQuartet.AC,int_stack+503528, int_stack+317150, int_stack+215515, int_stack+930084, int_stack+416465, int_stack+611538, 9, 0);
 /*--- compute (lp|[r12,T2]|hh) ---*/
   hrr1_build_lp(Libr12->ShellQuartet.AB,int_stack+527783, int_stack+503528, int_stack+676113, 441);
 /*--- compute (kd|[r12,T2]|hh) ---*/
   hrr1_build_kd(Libr12->ShellQuartet.AB,int_stack+953184, int_stack+527783, int_stack+695958, 441);
 /*--- compute (if|[r12,T2]|hh) ---*/
   hrr1_build_if(Libr12->ShellQuartet.AB,int_stack+1048440, int_stack+953184, int_stack+743586, 441);
 /*--- compute (h0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+953184, int_stack+308330, int_stack+237280, 21);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+962445, int_stack+383750, int_stack+282815, 28);
 /*--- compute (hp|hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+974793, int_stack+962445, int_stack+953184, 441);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1002576, int_stack+488408, int_stack+354770, 36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+676113, int_stack+1002576, int_stack+962445, 441);
 /*--- compute (hd|hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+713157, int_stack+676113, int_stack+974793, 441);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1018452, int_stack+657213, int_stack+445613, 45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+768723, int_stack+1018452, int_stack+1002576, 441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+503528, int_stack+768723, int_stack+676113, 441);
 /*--- compute (hf|hh) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+194285, int_stack+503528, int_stack+713157, 441);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+1038297, int_stack+58645, int_stack+165540, 21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+577616, int_stack+1038297, int_stack+291635, 21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+1038297, int_stack+577616, int_stack+295100, 21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+577616, int_stack+1038297, int_stack+300770, 21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+588956, int_stack+577616, int_stack+308330, 21);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+577616, int_stack+65554, int_stack+172106, 28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+1038297, int_stack+577616, int_stack+0, 28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+910284, int_stack+1038297, int_stack+366110, 28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+395510, int_stack+910284, int_stack+373670, 28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+910284, int_stack+395510, int_stack+383750, 28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+18120, int_stack+910284, int_stack+588956, 588);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+1038297, int_stack+74766, int_stack+180614, 36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+286895, int_stack+1038297, int_stack+459788, 36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+298775, int_stack+286895, int_stack+465728, 36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+314975, int_stack+298775, int_stack+475448, 36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+286895, int_stack+314975, int_stack+488408, 36);
 /*--- compute (ip|ih) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+308063, int_stack+286895, int_stack+910284, 588);
 /*--- compute (hd|ih) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+357455, int_stack+308063, int_stack+18120, 588);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libr12->ShellQuartet.CD,int_stack+431543, int_stack+86610, int_stack+191315, 45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libr12->ShellQuartet.CD,int_stack+440453, int_stack+431543, int_stack+10695, 45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libr12->ShellQuartet.CD,int_stack+455303, int_stack+440453, int_stack+628863, 45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libr12->ShellQuartet.CD,int_stack+475553, int_stack+455303, int_stack+641013, 45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libr12->ShellQuartet.CD,int_stack+628863, int_stack+475553, int_stack+657213, 45);
 /*--- compute (kp|ih) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+431543, int_stack+628863, int_stack+286895, 588);
 /*--- compute (id|ih) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+1171920, int_stack+431543, int_stack+308063, 588);
 /*--- compute (hf|ih) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+1270704, int_stack+1171920, int_stack+357455, 588);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+161655, int_stack+930084, int_stack+611538, 55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libr12->ShellQuartet.AB,int_stack+1394184, int_stack+161655, int_stack+1018452, 441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libr12->ShellQuartet.AB,int_stack+1453719, int_stack+1394184, int_stack+768723, 441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libr12->ShellQuartet.AB,int_stack+1548975, int_stack+1453719, int_stack+503528, 441);
 /*--- compute (h0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+816351, int_stack+60724, int_stack+60283, 21);
 /*--- compute (h0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+655323, int_stack+61312, int_stack+60724, 21);
 /*--- compute (h0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+657087, int_stack+655323, int_stack+816351, 21);
 /*--- compute (h0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+659733, int_stack+62068, int_stack+61312, 21);
 /*--- compute (h0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+662001, int_stack+659733, int_stack+655323, 21);
 /*--- compute (h0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+665529, int_stack+662001, int_stack+657087, 21);
 /*--- compute (h0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+655323, int_stack+63013, int_stack+62068, 21);
 /*--- compute (h0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+669939, int_stack+655323, int_stack+659733, 21);
 /*--- compute (h0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+495047, int_stack+669939, int_stack+662001, 21);
 /*--- compute (h0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+658158, int_stack+495047, int_stack+665529, 21);
 /*--- compute (h0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+664773, int_stack+64168, int_stack+63013, 21);
 /*--- compute (h0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+1038297, int_stack+664773, int_stack+655323, 21);
 /*--- compute (h0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+926748, int_stack+1038297, int_stack+669939, 21);
 /*--- compute (h0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1038297, int_stack+926748, int_stack+495047, 21);
 /*--- compute (h0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+926748, int_stack+1038297, int_stack+658158, 21);
 /*--- compute (i0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1038297, int_stack+68326, int_stack+67738, 28);
 /*--- compute (i0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1040061, int_stack+69110, int_stack+68326, 28);
 /*--- compute (i0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1042413, int_stack+1040061, int_stack+1038297, 28);
 /*--- compute (i0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+495047, int_stack+70118, int_stack+69110, 28);
 /*--- compute (i0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+498071, int_stack+495047, int_stack+1040061, 28);
 /*--- compute (i0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+936009, int_stack+498071, int_stack+1042413, 28);
 /*--- compute (i0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1038297, int_stack+71378, int_stack+70118, 28);
 /*--- compute (i0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1042077, int_stack+1038297, int_stack+495047, 28);
 /*--- compute (i0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+941889, int_stack+1042077, int_stack+498071, 28);
 /*--- compute (i0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+655323, int_stack+941889, int_stack+936009, 28);
 /*--- compute (i0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+936009, int_stack+72918, int_stack+71378, 28);
 /*--- compute (i0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+495047, int_stack+936009, int_stack+1038297, 28);
 /*--- compute (i0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+664143, int_stack+495047, int_stack+1042077, 28);
 /*--- compute (i0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+0, int_stack+664143, int_stack+941889, 28);
 /*--- compute (i0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+936009, int_stack+0, int_stack+655323, 28);
 /*--- compute (hp|[r12,T1]|hh) ---*/
   t1hrr1_build_hp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1672455, int_stack+936009, int_stack+926748, int_stack+962445, int_stack+588956, int_stack+953184, 5, 5);
 /*--- compute (k0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+926748, int_stack+78330, int_stack+77574, 36);
 /*--- compute (k0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+929016, int_stack+79338, int_stack+78330, 36);
 /*--- compute (k0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+655323, int_stack+929016, int_stack+926748, 36);
 /*--- compute (k0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+932040, int_stack+80634, int_stack+79338, 36);
 /*--- compute (k0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+659859, int_stack+932040, int_stack+929016, 36);
 /*--- compute (k0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+665907, int_stack+659859, int_stack+655323, 36);
 /*--- compute (k0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+926748, int_stack+82254, int_stack+80634, 36);
 /*--- compute (k0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+0, int_stack+926748, int_stack+932040, 36);
 /*--- compute (k0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+7776, int_stack+0, int_stack+659859, 36);
 /*--- compute (k0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+948357, int_stack+7776, int_stack+665907, 36);
 /*--- compute (k0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+655323, int_stack+84234, int_stack+82254, 36);
 /*--- compute (k0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+661263, int_stack+655323, int_stack+926748, 36);
 /*--- compute (k0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+577616, int_stack+661263, int_stack+0, 36);
 /*--- compute (k0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+655323, int_stack+577616, int_stack+7776, 36);
 /*--- compute (k0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+577616, int_stack+655323, int_stack+948357, 36);
 /*--- compute (ip|[r12,T1]|hh) ---*/
   t1hrr1_build_ip(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1700238, int_stack+577616, int_stack+936009, int_stack+1002576, int_stack+910284, int_stack+962445, 5, 5);
 /*--- compute (hd|[r12,T1]|hh) ---*/
   t1hrr1_build_hd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+910284, int_stack+1700238, int_stack+1672455, int_stack+676113, int_stack+18120, int_stack+974793, 5, 5);
 /*--- compute (l0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1672455, int_stack+91065, int_stack+90120, 45);
 /*--- compute (l0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1675290, int_stack+92325, int_stack+91065, 45);
 /*--- compute (l0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1679070, int_stack+1675290, int_stack+1672455, 45);
 /*--- compute (l0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1684740, int_stack+93945, int_stack+92325, 45);
 /*--- compute (l0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1689600, int_stack+1684740, int_stack+1675290, 45);
 /*--- compute (l0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+965850, int_stack+1689600, int_stack+1679070, 45);
 /*--- compute (l0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1672455, int_stack+95970, int_stack+93945, 45);
 /*--- compute (l0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+975300, int_stack+1672455, int_stack+1684740, 45);
 /*--- compute (l0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+985020, int_stack+975300, int_stack+1689600, 45);
 /*--- compute (l0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1678530, int_stack+985020, int_stack+965850, 45);
 /*--- compute (l0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+965850, int_stack+98445, int_stack+95970, 45);
 /*--- compute (l0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+655323, int_stack+965850, int_stack+1672455, 45);
 /*--- compute (l0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+593492, int_stack+655323, int_stack+975300, 45);
 /*--- compute (l0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+655323, int_stack+593492, int_stack+985020, 45);
 /*--- compute (l0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+593492, int_stack+655323, int_stack+1678530, 45);
 /*--- compute (kp|[r12,T1]|hh) ---*/
   t1hrr1_build_kp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+0, int_stack+593492, int_stack+577616, int_stack+1018452, int_stack+286895, int_stack+1002576, 5, 5);
 /*--- compute (id|[r12,T1]|hh) ---*/
   t1hrr1_build_id(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1737282, int_stack+0, int_stack+1700238, int_stack+768723, int_stack+308063, int_stack+676113, 5, 5);
 /*--- compute (hf|[r12,T1]|hh) ---*/
   t1hrr1_build_hf(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1811370, int_stack+1737282, int_stack+910284, int_stack+503528, int_stack+357455, int_stack+713157, 5, 5);
 /*--- compute (m0|[r12,T1]|hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+910284, int_stack+102570, int_stack+101415, 55);
 /*--- compute (m0|[r12,T1]|ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+913749, int_stack+104110, int_stack+102570, 55);
 /*--- compute (m0|[r12,T1]|hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+918369, int_stack+913749, int_stack+910284, 55);
 /*--- compute (m0|[r12,T1]|kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+925299, int_stack+106090, int_stack+104110, 55);
 /*--- compute (m0|[r12,T1]|id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+931239, int_stack+925299, int_stack+913749, 55);
 /*--- compute (m0|[r12,T1]|hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+940479, int_stack+931239, int_stack+918369, 55);
 /*--- compute (m0|[r12,T1]|lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+910284, int_stack+108565, int_stack+106090, 55);
 /*--- compute (m0|[r12,T1]|kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+952029, int_stack+910284, int_stack+925299, 55);
 /*--- compute (m0|[r12,T1]|if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+963909, int_stack+952029, int_stack+931239, 55);
 /*--- compute (m0|[r12,T1]|hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+917709, int_stack+963909, int_stack+940479, 55);
 /*--- compute (m0|[r12,T1]|mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+935034, int_stack+111590, int_stack+108565, 55);
 /*--- compute (m0|[r12,T1]|ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+979309, int_stack+935034, int_stack+910284, 55);
 /*--- compute (m0|[r12,T1]|kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+994159, int_stack+979309, int_stack+952029, 55);
 /*--- compute (m0|[r12,T1]|ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+935034, int_stack+994159, int_stack+963909, 55);
 /*--- compute (m0|[r12,T1]|hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+958134, int_stack+935034, int_stack+917709, 55);
 /*--- compute (lp|[r12,T1]|hh) ---*/
   t1hrr1_build_lp(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+286895, int_stack+958134, int_stack+593492, int_stack+161655, int_stack+628863, int_stack+1018452, 5, 5);
 /*--- compute (kd|[r12,T1]|hh) ---*/
   t1hrr1_build_kd(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+910284, int_stack+286895, int_stack+0, int_stack+1394184, int_stack+431543, int_stack+768723, 5, 5);
 /*--- compute (if|[r12,T1]|hh) ---*/
   t1hrr1_build_if(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+286895, int_stack+910284, int_stack+1737282, int_stack+1453719, int_stack+1171920, int_stack+503528, 5, 5);
 /*--- compute (h0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1171920, int_stack+115661, int_stack+115220, 21);
 /*--- compute (h0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1173243, int_stack+116249, int_stack+115661, 21);
 /*--- compute (h0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1175007, int_stack+1173243, int_stack+1171920, 21);
 /*--- compute (h0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1177653, int_stack+117005, int_stack+116249, 21);
 /*--- compute (h0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1179921, int_stack+1177653, int_stack+1173243, 21);
 /*--- compute (h0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1183449, int_stack+1179921, int_stack+1175007, 21);
 /*--- compute (h0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1171920, int_stack+117950, int_stack+117005, 21);
 /*--- compute (h0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1187859, int_stack+1171920, int_stack+1177653, 21);
 /*--- compute (h0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+1192395, int_stack+1187859, int_stack+1179921, 21);
 /*--- compute (h0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1174755, int_stack+1192395, int_stack+1183449, 21);
 /*--- compute (h0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1181370, int_stack+119105, int_stack+117950, 21);
 /*--- compute (h0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+1198275, int_stack+1181370, int_stack+1171920, 21);
 /*--- compute (h0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+1203945, int_stack+1198275, int_stack+1187859, 21);
 /*--- compute (h0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1181370, int_stack+1203945, int_stack+1192395, 21);
 /*--- compute (h0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1190190, int_stack+1181370, int_stack+1174755, 21);
 /*--- compute (i0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1171920, int_stack+121079, int_stack+120491, 28);
 /*--- compute (i0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1173684, int_stack+121863, int_stack+121079, 28);
 /*--- compute (i0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1176036, int_stack+1173684, int_stack+1171920, 28);
 /*--- compute (i0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1179564, int_stack+122871, int_stack+121863, 28);
 /*--- compute (i0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1182588, int_stack+1179564, int_stack+1173684, 28);
 /*--- compute (i0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1199451, int_stack+1182588, int_stack+1176036, 28);
 /*--- compute (i0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1171920, int_stack+124131, int_stack+122871, 28);
 /*--- compute (i0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1205331, int_stack+1171920, int_stack+1179564, 28);
 /*--- compute (i0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+1211379, int_stack+1205331, int_stack+1182588, 28);
 /*--- compute (i0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1175700, int_stack+1211379, int_stack+1199451, 28);
 /*--- compute (i0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1199451, int_stack+125671, int_stack+124131, 28);
 /*--- compute (i0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+1219219, int_stack+1199451, int_stack+1171920, 28);
 /*--- compute (i0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+1226779, int_stack+1219219, int_stack+1205331, 28);
 /*--- compute (i0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1199451, int_stack+1226779, int_stack+1211379, 28);
 /*--- compute (i0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1211211, int_stack+1199451, int_stack+1175700, 28);
 /*--- compute (hp||hh) ---*/
   hrr1_build_hp(Libr12->ShellQuartet.AB,int_stack+1223559, int_stack+1211211, int_stack+1190190, 441);
 /*--- compute (k0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1171920, int_stack+128275, int_stack+127519, 36);
 /*--- compute (k0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1174188, int_stack+129283, int_stack+128275, 36);
 /*--- compute (k0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1177212, int_stack+1174188, int_stack+1171920, 36);
 /*--- compute (k0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1181748, int_stack+130579, int_stack+129283, 36);
 /*--- compute (k0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1185636, int_stack+1181748, int_stack+1174188, 36);
 /*--- compute (k0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1191684, int_stack+1185636, int_stack+1177212, 36);
 /*--- compute (k0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1171920, int_stack+132199, int_stack+130579, 36);
 /*--- compute (k0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1199244, int_stack+1171920, int_stack+1181748, 36);
 /*--- compute (k0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+1251342, int_stack+1199244, int_stack+1185636, 36);
 /*--- compute (k0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1176780, int_stack+1251342, int_stack+1191684, 36);
 /*--- compute (k0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1188120, int_stack+134179, int_stack+132199, 36);
 /*--- compute (k0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+910284, int_stack+1188120, int_stack+1171920, 36);
 /*--- compute (k0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+920004, int_stack+910284, int_stack+1199244, 36);
 /*--- compute (k0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1188120, int_stack+920004, int_stack+1251342, 36);
 /*--- compute (k0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1251342, int_stack+1188120, int_stack+1176780, 36);
 /*--- compute (ip||hh) ---*/
   hrr1_build_ip(Libr12->ShellQuartet.AB,int_stack+910284, int_stack+1251342, int_stack+1211211, 441);
 /*--- compute (hd||hh) ---*/
   hrr1_build_hd(Libr12->ShellQuartet.AB,int_stack+947328, int_stack+910284, int_stack+1223559, 441);
 /*--- compute (l0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+1267218, int_stack+137500, int_stack+136555, 45);
 /*--- compute (l0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+1002894, int_stack+138760, int_stack+137500, 45);
 /*--- compute (l0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+1006674, int_stack+1002894, int_stack+1267218, 45);
 /*--- compute (l0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+1012344, int_stack+140380, int_stack+138760, 45);
 /*--- compute (l0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+1017204, int_stack+1012344, int_stack+1002894, 45);
 /*--- compute (l0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+1024764, int_stack+1017204, int_stack+1006674, 45);
 /*--- compute (l0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+1002894, int_stack+142405, int_stack+140380, 45);
 /*--- compute (l0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+1034214, int_stack+1002894, int_stack+1012344, 45);
 /*--- compute (l0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+1171920, int_stack+1034214, int_stack+1017204, 45);
 /*--- compute (l0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+1008969, int_stack+1171920, int_stack+1024764, 45);
 /*--- compute (l0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+1023144, int_stack+144880, int_stack+142405, 45);
 /*--- compute (l0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+1184520, int_stack+1023144, int_stack+1002894, 45);
 /*--- compute (l0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+1196670, int_stack+1184520, int_stack+1034214, 45);
 /*--- compute (l0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+1023144, int_stack+1196670, int_stack+1171920, 45);
 /*--- compute (l0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+1171920, int_stack+1023144, int_stack+1008969, 45);
 /*--- compute (kp||hh) ---*/
   hrr1_build_kp(Libr12->ShellQuartet.AB,int_stack+1191765, int_stack+1171920, int_stack+1251342, 441);
 /*--- compute (id||hh) ---*/
   hrr1_build_id(Libr12->ShellQuartet.AB,int_stack+1394184, int_stack+1191765, int_stack+910284, 441);
 /*--- compute (hf||hh) ---*/
   hrr1_build_hf(Libr12->ShellQuartet.AB,int_stack+0, int_stack+1394184, int_stack+947328, 441);
 /*--- compute (m0||hp) ---*/
   hrr3_build_hp(Libr12->ShellQuartet.CD,int_stack+910284, int_stack+149005, int_stack+147850, 55);
 /*--- compute (m0||ip) ---*/
   hrr3_build_ip(Libr12->ShellQuartet.CD,int_stack+913749, int_stack+150545, int_stack+149005, 55);
 /*--- compute (m0||hd) ---*/
   hrr3_build_hd(Libr12->ShellQuartet.CD,int_stack+918369, int_stack+913749, int_stack+910284, 55);
 /*--- compute (m0||kp) ---*/
   hrr3_build_kp(Libr12->ShellQuartet.CD,int_stack+925299, int_stack+152525, int_stack+150545, 55);
 /*--- compute (m0||id) ---*/
   hrr3_build_id(Libr12->ShellQuartet.CD,int_stack+931239, int_stack+925299, int_stack+913749, 55);
 /*--- compute (m0||hf) ---*/
   hrr3_build_hf(Libr12->ShellQuartet.CD,int_stack+940479, int_stack+931239, int_stack+918369, 55);
 /*--- compute (m0||lp) ---*/
   hrr3_build_lp(Libr12->ShellQuartet.CD,int_stack+910284, int_stack+155000, int_stack+152525, 55);
 /*--- compute (m0||kd) ---*/
   hrr3_build_kd(Libr12->ShellQuartet.CD,int_stack+952029, int_stack+910284, int_stack+925299, 55);
 /*--- compute (m0||if) ---*/
   hrr3_build_if(Libr12->ShellQuartet.CD,int_stack+963909, int_stack+952029, int_stack+931239, 55);
 /*--- compute (m0||hg) ---*/
   hrr3_build_hg(Libr12->ShellQuartet.CD,int_stack+917709, int_stack+963909, int_stack+940479, 55);
 /*--- compute (m0||mp) ---*/
   hrr3_build_mp(Libr12->ShellQuartet.CD,int_stack+935034, int_stack+158025, int_stack+155000, 55);
 /*--- compute (m0||ld) ---*/
   hrr3_build_ld(Libr12->ShellQuartet.CD,int_stack+979309, int_stack+935034, int_stack+910284, 55);
 /*--- compute (m0||kf) ---*/
   hrr3_build_kf(Libr12->ShellQuartet.CD,int_stack+994159, int_stack+979309, int_stack+952029, 55);
 /*--- compute (m0||ig) ---*/
   hrr3_build_ig(Libr12->ShellQuartet.CD,int_stack+935034, int_stack+994159, int_stack+963909, 55);
 /*--- compute (m0||hh) ---*/
   hrr3_build_hh(Libr12->ShellQuartet.CD,int_stack+958134, int_stack+935034, int_stack+917709, 55);
 /*--- compute (lp||hh) ---*/
   hrr1_build_lp(Libr12->ShellQuartet.AB,int_stack+982389, int_stack+958134, int_stack+1171920, 441);
 /*--- compute (kd||hh) ---*/
   hrr1_build_kd(Libr12->ShellQuartet.AB,int_stack+92610, int_stack+982389, int_stack+1191765, 441);
 /*--- compute (if||hh) ---*/
   hrr1_build_if(Libr12->ShellQuartet.AB,int_stack+910284, int_stack+92610, int_stack+1394184, 441);
 /*--- compute (hg|[r12,T2]|hh) ---*/
   hrr1_build_hg(Libr12->ShellQuartet.AB,int_stack+1672455, int_stack+1048440, int_stack+817674, 441);
     Libr12->te_ptr[3] = int_stack + 1672455;
 /*--- compute (hg|[r12,T1]|hh) ---*/
   t1hrr1_build_hg(Libr12->ShellQuartet.AB,Libr12->ShellQuartet.AC,int_stack+1394184, int_stack+286895, int_stack+1811370, int_stack+1548975, int_stack+1270704, int_stack+194285, 5, 5);
     Libr12->te_ptr[2] = int_stack + 1394184;
 /*--- compute (hg||hh) ---*/
   hrr1_build_hg(Libr12->ShellQuartet.AB,int_stack+286895, int_stack+910284, int_stack+0, 441);
     Libr12->te_ptr[1] = int_stack + 286895;
 /*--- compute (hg|hh) ---*/
   hrr1_build_hg(Libr12->ShellQuartet.AB,int_stack+0, int_stack+1548975, int_stack+194285, 441);
     Libr12->te_ptr[0] = int_stack + 0;

}
