#include <stdio.h>
#include <libint/libint.h>
#include "libr12.h"
#include <libint/vrr_header.h>
#include "r12_vrr_header.h"

void vrr_grt_order_ffff(Libr12_t *Libr12, prim_data *Data)
{
 REALTYPE *r12vrr_stack = Libr12->r12vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];

 /*--- compute (p0|00)^2 ---*/
 _BUILD_p000(Data,r12vrr_stack+0, Data->F+2, Data->F+3, NULL, NULL, NULL);

 /*--- compute (00|p0)^2 ---*/
 _BUILD_00p0(Data,r12vrr_stack+3, Data->F+2, Data->F+3, NULL, NULL, NULL);

 /*--- compute (00|p0)^1 ---*/
 _BUILD_00p0(Data,r12vrr_stack+6, Data->F+1, Data->F+2, NULL, NULL, NULL);

 /*--- compute (00|p0)^3 ---*/
 _BUILD_00p0(Data,r12vrr_stack+9, Data->F+3, Data->F+4, NULL, NULL, NULL);

 /*--- compute (p0|p0)^2 ---*/
 _BUILD_p0p0(Data,r12vrr_stack+12, r12vrr_stack+3, r12vrr_stack+9, NULL, NULL, Data->F+3);

 /*--- compute (p0|p0)^1 ---*/
 _BUILD_p0p0(Data,r12vrr_stack+21, r12vrr_stack+6, r12vrr_stack+3, NULL, NULL, Data->F+2);

 /*--- compute (d0|p0)^1 ---*/
 _BUILD_d0p0(Data,r12vrr_stack+30, r12vrr_stack+21, r12vrr_stack+12, r12vrr_stack+6, r12vrr_stack+3, r12vrr_stack+0);

 /*--- compute (00|d0)^2 ---*/
 _BUILD_00d0(Data,r12vrr_stack+48, r12vrr_stack+3, r12vrr_stack+9, Data->F+2, Data->F+3, NULL);

 /*--- compute (00|d0)^1 ---*/
 _BUILD_00d0(Data,r12vrr_stack+54, r12vrr_stack+6, r12vrr_stack+3, Data->F+1, Data->F+2, NULL);

 /*--- compute (p0|d0)^1 ---*/
 _BUILD_p0d0(Data,r12vrr_stack+60, r12vrr_stack+54, r12vrr_stack+48, NULL, NULL, r12vrr_stack+3);

 /*--- compute (00|p0)^0 ---*/
 _BUILD_00p0(Data,r12vrr_stack+78, Data->F+0, Data->F+1, NULL, NULL, NULL);

 /*--- compute (00|d0)^0 ---*/
 _BUILD_00d0(Data,r12vrr_stack+81, r12vrr_stack+78, r12vrr_stack+6, Data->F+0, Data->F+1, NULL);

 /*--- compute (p0|d0)^0 ---*/
 _BUILD_p0d0(Data,r12vrr_stack+87, r12vrr_stack+81, r12vrr_stack+54, NULL, NULL, r12vrr_stack+6);

 /*--- compute (00|p0)^4 ---*/
 _BUILD_00p0(Data,r12vrr_stack+105, Data->F+4, Data->F+5, NULL, NULL, NULL);

 /*--- compute (00|d0)^3 ---*/
 _BUILD_00d0(Data,r12vrr_stack+108, r12vrr_stack+9, r12vrr_stack+105, Data->F+3, Data->F+4, NULL);

 /*--- compute (p0|d0)^2 ---*/
 _BUILD_p0d0(Data,r12vrr_stack+114, r12vrr_stack+48, r12vrr_stack+108, NULL, NULL, r12vrr_stack+9);

 /*--- compute (d0|d0)^1 ---*/
 _BUILD_d0d0(Data,r12vrr_stack+132, r12vrr_stack+60, r12vrr_stack+114, r12vrr_stack+54, r12vrr_stack+48, r12vrr_stack+12);

 /*--- compute (d0|d0)^0 ---*/
 _BUILD_d0d0(Data,r12vrr_stack+168, r12vrr_stack+87, r12vrr_stack+60, r12vrr_stack+81, r12vrr_stack+54, r12vrr_stack+21);

 /*--- compute (f0|d0)^0 ---*/
 _BUILD_f0d0(Data,r12vrr_stack+204, r12vrr_stack+168, r12vrr_stack+132, r12vrr_stack+87, r12vrr_stack+60, r12vrr_stack+30);

 /*--- compute (p0|00)^3 ---*/
 _BUILD_p000(Data,r12vrr_stack+264, Data->F+3, Data->F+4, NULL, NULL, NULL);

 /*--- compute (d0|00)^2 ---*/
 _BUILD_d000(Data,r12vrr_stack+267, r12vrr_stack+0, r12vrr_stack+264, Data->F+2, Data->F+3, NULL);

 /*--- compute (p0|p0)^3 ---*/
 _BUILD_p0p0(Data,r12vrr_stack+273, r12vrr_stack+9, r12vrr_stack+105, NULL, NULL, Data->F+4);

 /*--- compute (d0|p0)^2 ---*/
 _BUILD_d0p0(Data,r12vrr_stack+282, r12vrr_stack+12, r12vrr_stack+273, r12vrr_stack+3, r12vrr_stack+9, r12vrr_stack+264);

 /*--- compute (f0|p0)^1 ---*/
 _BUILD_f0p0(Data,r12vrr_stack+300, r12vrr_stack+30, r12vrr_stack+282, r12vrr_stack+21, r12vrr_stack+12, r12vrr_stack+267);

 /*--- compute (00|p0)^5 ---*/
 _BUILD_00p0(Data,r12vrr_stack+21, Data->F+5, Data->F+6, NULL, NULL, NULL);

 /*--- compute (00|d0)^4 ---*/
 _BUILD_00d0(Data,r12vrr_stack+24, r12vrr_stack+105, r12vrr_stack+21, Data->F+4, Data->F+5, NULL);

 /*--- compute (p0|d0)^3 ---*/
 _BUILD_p0d0(Data,r12vrr_stack+330, r12vrr_stack+108, r12vrr_stack+24, NULL, NULL, r12vrr_stack+105);

 /*--- compute (d0|d0)^2 ---*/
 _BUILD_d0d0(Data,r12vrr_stack+348, r12vrr_stack+114, r12vrr_stack+330, r12vrr_stack+48, r12vrr_stack+108, r12vrr_stack+273);

 /*--- compute (f0|d0)^1 ---*/
 _BUILD_f0d0(Data,r12vrr_stack+384, r12vrr_stack+132, r12vrr_stack+348, r12vrr_stack+60, r12vrr_stack+114, r12vrr_stack+282);

 /*--- compute (g0|d0)^0 ---*/
 _BUILD_g0d0(Data,r12vrr_stack+444, r12vrr_stack+204, r12vrr_stack+384, r12vrr_stack+168, r12vrr_stack+132, r12vrr_stack+300);

 /*--- compute (00|f0)^2 ---*/
 _BUILD_00f0(Data,r12vrr_stack+534, r12vrr_stack+48, r12vrr_stack+108, r12vrr_stack+3, r12vrr_stack+9, NULL);

 /*--- compute (00|f0)^1 ---*/
 _BUILD_00f0(Data,r12vrr_stack+544, r12vrr_stack+54, r12vrr_stack+48, r12vrr_stack+6, r12vrr_stack+3, NULL);

 /*--- compute (00|f0)^3 ---*/
 _BUILD_00f0(Data,r12vrr_stack+554, r12vrr_stack+108, r12vrr_stack+24, r12vrr_stack+9, r12vrr_stack+105, NULL);

 /*--- compute (p0|f0)^2 ---*/
 _BUILD_p0f0(Data,r12vrr_stack+564, r12vrr_stack+534, r12vrr_stack+554, NULL, NULL, r12vrr_stack+108);

 /*--- compute (p0|f0)^1 ---*/
 _BUILD_p0f0(Data,r12vrr_stack+594, r12vrr_stack+544, r12vrr_stack+534, NULL, NULL, r12vrr_stack+48);

 /*--- compute (d0|f0)^1 ---*/
 _BUILD_d0f0(Data,r12vrr_stack+624, r12vrr_stack+594, r12vrr_stack+564, r12vrr_stack+544, r12vrr_stack+534, r12vrr_stack+114);

 /*--- compute (00|f0)^0 ---*/
 _BUILD_00f0(Data,r12vrr_stack+684, r12vrr_stack+81, r12vrr_stack+54, r12vrr_stack+78, r12vrr_stack+6, NULL);

 /*--- compute (p0|f0)^0 ---*/
 _BUILD_p0f0(Data,r12vrr_stack+694, r12vrr_stack+684, r12vrr_stack+544, NULL, NULL, r12vrr_stack+54);

 /*--- compute (d0|f0)^0 ---*/
 _BUILD_d0f0(Data,r12vrr_stack+724, r12vrr_stack+694, r12vrr_stack+594, r12vrr_stack+684, r12vrr_stack+544, r12vrr_stack+60);

 /*--- compute (00|p0)^6 ---*/
 _BUILD_00p0(Data,r12vrr_stack+60, Data->F+6, Data->F+7, NULL, NULL, NULL);

 /*--- compute (00|d0)^5 ---*/
 _BUILD_00d0(Data,r12vrr_stack+3, r12vrr_stack+21, r12vrr_stack+60, Data->F+5, Data->F+6, NULL);

 /*--- compute (00|f0)^4 ---*/
 _BUILD_00f0(Data,r12vrr_stack+63, r12vrr_stack+24, r12vrr_stack+3, r12vrr_stack+105, r12vrr_stack+21, NULL);

 /*--- compute (p0|f0)^3 ---*/
 _BUILD_p0f0(Data,r12vrr_stack+784, r12vrr_stack+554, r12vrr_stack+63, NULL, NULL, r12vrr_stack+24);

 /*--- compute (d0|f0)^2 ---*/
 _BUILD_d0f0(Data,r12vrr_stack+814, r12vrr_stack+564, r12vrr_stack+784, r12vrr_stack+534, r12vrr_stack+554, r12vrr_stack+330);

 /*--- compute (f0|f0)^1 ---*/
 _BUILD_f0f0(Data,r12vrr_stack+874, r12vrr_stack+624, r12vrr_stack+814, r12vrr_stack+594, r12vrr_stack+564, r12vrr_stack+348);

 /*--- compute (f0|f0)^0 ---*/
 _BUILD_f0f0(Data,r12vrr_stack+974, r12vrr_stack+724, r12vrr_stack+624, r12vrr_stack+694, r12vrr_stack+594, r12vrr_stack+132);
 tmp = r12vrr_stack + 974;
 target_ptr = Libr12->gvrr_classes[3][3];
 for(i=0;i<100;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0|f0)^0 ---*/
 _BUILD_g0f0(Data,r12vrr_stack+1074, r12vrr_stack+974, r12vrr_stack+874, r12vrr_stack+724, r12vrr_stack+624, r12vrr_stack+384);
 tmp = r12vrr_stack + 1074;
 target_ptr = Libr12->gvrr_classes[4][3];
 for(i=0;i<150;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|g0)^2 ---*/
 _BUILD_00g0(Data,r12vrr_stack+1224, r12vrr_stack+534, r12vrr_stack+554, r12vrr_stack+48, r12vrr_stack+108, NULL);

 /*--- compute (00|g0)^1 ---*/
 _BUILD_00g0(Data,r12vrr_stack+1239, r12vrr_stack+544, r12vrr_stack+534, r12vrr_stack+54, r12vrr_stack+48, NULL);

 /*--- compute (p0|g0)^1 ---*/
 _BUILD_p0g0(Data,r12vrr_stack+1254, r12vrr_stack+1239, r12vrr_stack+1224, NULL, NULL, r12vrr_stack+534);

 /*--- compute (00|g0)^0 ---*/
 _BUILD_00g0(Data,r12vrr_stack+1299, r12vrr_stack+684, r12vrr_stack+544, r12vrr_stack+81, r12vrr_stack+54, NULL);

 /*--- compute (p0|g0)^0 ---*/
 _BUILD_p0g0(Data,r12vrr_stack+1314, r12vrr_stack+1299, r12vrr_stack+1239, NULL, NULL, r12vrr_stack+544);

 /*--- compute (00|g0)^3 ---*/
 _BUILD_00g0(Data,r12vrr_stack+1359, r12vrr_stack+554, r12vrr_stack+63, r12vrr_stack+108, r12vrr_stack+24, NULL);

 /*--- compute (p0|g0)^2 ---*/
 _BUILD_p0g0(Data,r12vrr_stack+1374, r12vrr_stack+1224, r12vrr_stack+1359, NULL, NULL, r12vrr_stack+554);

 /*--- compute (d0|g0)^1 ---*/
 _BUILD_d0g0(Data,r12vrr_stack+1419, r12vrr_stack+1254, r12vrr_stack+1374, r12vrr_stack+1239, r12vrr_stack+1224, r12vrr_stack+564);

 /*--- compute (d0|g0)^0 ---*/
 _BUILD_d0g0(Data,r12vrr_stack+1509, r12vrr_stack+1314, r12vrr_stack+1254, r12vrr_stack+1299, r12vrr_stack+1239, r12vrr_stack+594);

 /*--- compute (f0|g0)^0 ---*/
 _BUILD_f0g0(Data,r12vrr_stack+1599, r12vrr_stack+1509, r12vrr_stack+1419, r12vrr_stack+1314, r12vrr_stack+1254, r12vrr_stack+624);
 tmp = r12vrr_stack + 1599;
 target_ptr = Libr12->gvrr_classes[3][4];
 for(i=0;i<150;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|p0)^7 ---*/
 _BUILD_00p0(Data,r12vrr_stack+594, Data->F+7, Data->F+8, NULL, NULL, NULL);

 /*--- compute (00|d0)^6 ---*/
 _BUILD_00d0(Data,r12vrr_stack+597, r12vrr_stack+60, r12vrr_stack+594, Data->F+6, Data->F+7, NULL);

 /*--- compute (00|f0)^5 ---*/
 _BUILD_00f0(Data,r12vrr_stack+603, r12vrr_stack+3, r12vrr_stack+597, r12vrr_stack+21, r12vrr_stack+60, NULL);

 /*--- compute (00|g0)^4 ---*/
 _BUILD_00g0(Data,r12vrr_stack+1749, r12vrr_stack+63, r12vrr_stack+603, r12vrr_stack+24, r12vrr_stack+3, NULL);

 /*--- compute (p0|g0)^3 ---*/
 _BUILD_p0g0(Data,r12vrr_stack+1764, r12vrr_stack+1359, r12vrr_stack+1749, NULL, NULL, r12vrr_stack+63);

 /*--- compute (d0|g0)^2 ---*/
 _BUILD_d0g0(Data,r12vrr_stack+1809, r12vrr_stack+1374, r12vrr_stack+1764, r12vrr_stack+1224, r12vrr_stack+1359, r12vrr_stack+784);

 /*--- compute (f0|g0)^1 ---*/
 _BUILD_f0g0(Data,r12vrr_stack+1899, r12vrr_stack+1419, r12vrr_stack+1809, r12vrr_stack+1254, r12vrr_stack+1374, r12vrr_stack+814);

 /*--- compute (g0|g0)^0 ---*/
 _BUILD_g0g0(Data,r12vrr_stack+2049, r12vrr_stack+1599, r12vrr_stack+1899, r12vrr_stack+1509, r12vrr_stack+1419, r12vrr_stack+874);
 tmp = r12vrr_stack + 2049;
 target_ptr = Libr12->gvrr_classes[4][4];
 for(i=0;i<225;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|h0)^2 ---*/
 am[0] = 0;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2274, r12vrr_stack+1224, r12vrr_stack+1359, r12vrr_stack+534, r12vrr_stack+554, NULL);

 /*--- compute (00|h0)^1 ---*/
 am[0] = 0;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2295, r12vrr_stack+1239, r12vrr_stack+1224, r12vrr_stack+544, r12vrr_stack+534, NULL);

 /*--- compute (p0|h0)^1 ---*/
 am[0] = 1;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2316, r12vrr_stack+2295, r12vrr_stack+2274, NULL, NULL, r12vrr_stack+1224);

 /*--- compute (00|h0)^0 ---*/
 am[0] = 0;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2379, r12vrr_stack+1299, r12vrr_stack+1239, r12vrr_stack+684, r12vrr_stack+544, NULL);

 /*--- compute (p0|h0)^0 ---*/
 am[0] = 1;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2400, r12vrr_stack+2379, r12vrr_stack+2295, NULL, NULL, r12vrr_stack+1239);

 /*--- compute (00|h0)^3 ---*/
 am[0] = 0;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2463, r12vrr_stack+1359, r12vrr_stack+1749, r12vrr_stack+554, r12vrr_stack+63, NULL);

 /*--- compute (p0|h0)^2 ---*/
 am[0] = 1;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2484, r12vrr_stack+2274, r12vrr_stack+2463, NULL, NULL, r12vrr_stack+1359);

 /*--- compute (d0|h0)^1 ---*/
 am[0] = 2;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2547, r12vrr_stack+2316, r12vrr_stack+2484, r12vrr_stack+2295, r12vrr_stack+2274, r12vrr_stack+1374);

 /*--- compute (d0|h0)^0 ---*/
 am[0] = 2;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2673, r12vrr_stack+2400, r12vrr_stack+2316, r12vrr_stack+2379, r12vrr_stack+2295, r12vrr_stack+1254);

 /*--- compute (f0|h0)^0 ---*/
 am[0] = 3;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2799, r12vrr_stack+2673, r12vrr_stack+2547, r12vrr_stack+2400, r12vrr_stack+2316, r12vrr_stack+1419);
 tmp = r12vrr_stack + 2799;
 target_ptr = Libr12->gvrr_classes[3][5];
 for(i=0;i<210;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|p0)^8 ---*/
 _BUILD_00p0(Data,r12vrr_stack+1254, Data->F+8, Data->F+9, NULL, NULL, NULL);

 /*--- compute (00|d0)^7 ---*/
 _BUILD_00d0(Data,r12vrr_stack+1257, r12vrr_stack+594, r12vrr_stack+1254, Data->F+7, Data->F+8, NULL);

 /*--- compute (00|f0)^6 ---*/
 _BUILD_00f0(Data,r12vrr_stack+1263, r12vrr_stack+597, r12vrr_stack+1257, r12vrr_stack+60, r12vrr_stack+594, NULL);

 /*--- compute (00|g0)^5 ---*/
 _BUILD_00g0(Data,r12vrr_stack+1273, r12vrr_stack+603, r12vrr_stack+1263, r12vrr_stack+3, r12vrr_stack+597, NULL);

 /*--- compute (00|h0)^4 ---*/
 am[0] = 0;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+3009, r12vrr_stack+1749, r12vrr_stack+1273, r12vrr_stack+63, r12vrr_stack+603, NULL);

 /*--- compute (p0|h0)^3 ---*/
 am[0] = 1;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+3030, r12vrr_stack+2463, r12vrr_stack+3009, NULL, NULL, r12vrr_stack+1749);

 /*--- compute (d0|h0)^2 ---*/
 am[0] = 2;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+3093, r12vrr_stack+2484, r12vrr_stack+3030, r12vrr_stack+2274, r12vrr_stack+2463, r12vrr_stack+1764);

 /*--- compute (f0|h0)^1 ---*/
 am[0] = 3;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+3219, r12vrr_stack+2547, r12vrr_stack+3093, r12vrr_stack+2316, r12vrr_stack+2484, r12vrr_stack+1809);

 /*--- compute (g0|h0)^0 ---*/
 am[0] = 4;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+3429, r12vrr_stack+2799, r12vrr_stack+3219, r12vrr_stack+2673, r12vrr_stack+2547, r12vrr_stack+1899);
 tmp = r12vrr_stack + 3429;
 target_ptr = Libr12->gvrr_classes[4][5];
 for(i=0;i<315;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|i0)^2 ---*/
 am[0] = 0;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+3744, r12vrr_stack+2274, r12vrr_stack+2463, r12vrr_stack+1224, r12vrr_stack+1359, NULL);

 /*--- compute (00|i0)^1 ---*/
 am[0] = 0;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+3772, r12vrr_stack+2295, r12vrr_stack+2274, r12vrr_stack+1239, r12vrr_stack+1224, NULL);

 /*--- compute (p0|i0)^1 ---*/
 am[0] = 1;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+3800, r12vrr_stack+3772, r12vrr_stack+3744, NULL, NULL, r12vrr_stack+2274);

 /*--- compute (00|i0)^0 ---*/
 am[0] = 0;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+3884, r12vrr_stack+2379, r12vrr_stack+2295, r12vrr_stack+1299, r12vrr_stack+1239, NULL);

 /*--- compute (p0|i0)^0 ---*/
 am[0] = 1;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+3912, r12vrr_stack+3884, r12vrr_stack+3772, NULL, NULL, r12vrr_stack+2295);

 /*--- compute (00|i0)^3 ---*/
 am[0] = 0;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+1224, r12vrr_stack+2463, r12vrr_stack+3009, r12vrr_stack+1359, r12vrr_stack+1749, NULL);

 /*--- compute (p0|i0)^2 ---*/
 am[0] = 1;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+3996, r12vrr_stack+3744, r12vrr_stack+1224, NULL, NULL, r12vrr_stack+2463);

 /*--- compute (d0|i0)^1 ---*/
 am[0] = 2;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+4080, r12vrr_stack+3800, r12vrr_stack+3996, r12vrr_stack+3772, r12vrr_stack+3744, r12vrr_stack+2484);

 /*--- compute (d0|i0)^0 ---*/
 am[0] = 2;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+4248, r12vrr_stack+3912, r12vrr_stack+3800, r12vrr_stack+3884, r12vrr_stack+3772, r12vrr_stack+2316);

 /*--- compute (f0|i0)^0 ---*/
 am[0] = 3;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+4416, r12vrr_stack+4248, r12vrr_stack+4080, r12vrr_stack+3912, r12vrr_stack+3800, r12vrr_stack+2547);
 tmp = r12vrr_stack + 4416;
 target_ptr = Libr12->gvrr_classes[3][6];
 for(i=0;i<280;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|p0)^9 ---*/
 _BUILD_00p0(Data,r12vrr_stack+2316, Data->F+9, Data->F+10, NULL, NULL, NULL);

 /*--- compute (00|d0)^8 ---*/
 _BUILD_00d0(Data,r12vrr_stack+2319, r12vrr_stack+1254, r12vrr_stack+2316, Data->F+8, Data->F+9, NULL);

 /*--- compute (00|f0)^7 ---*/
 _BUILD_00f0(Data,r12vrr_stack+2325, r12vrr_stack+1257, r12vrr_stack+2319, r12vrr_stack+594, r12vrr_stack+1254, NULL);

 /*--- compute (00|g0)^6 ---*/
 _BUILD_00g0(Data,r12vrr_stack+2335, r12vrr_stack+1263, r12vrr_stack+2325, r12vrr_stack+597, r12vrr_stack+1257, NULL);

 /*--- compute (00|h0)^5 ---*/
 am[0] = 0;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2350, r12vrr_stack+1273, r12vrr_stack+2335, r12vrr_stack+603, r12vrr_stack+1263, NULL);

 /*--- compute (00|i0)^4 ---*/
 am[0] = 0;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+4696, r12vrr_stack+3009, r12vrr_stack+2350, r12vrr_stack+1749, r12vrr_stack+1273, NULL);

 /*--- compute (p0|i0)^3 ---*/
 am[0] = 1;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+4724, r12vrr_stack+1224, r12vrr_stack+4696, NULL, NULL, r12vrr_stack+3009);

 /*--- compute (d0|i0)^2 ---*/
 am[0] = 2;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+4808, r12vrr_stack+3996, r12vrr_stack+4724, r12vrr_stack+3744, r12vrr_stack+1224, r12vrr_stack+3030);

 /*--- compute (f0|i0)^1 ---*/
 am[0] = 3;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+4976, r12vrr_stack+4080, r12vrr_stack+4808, r12vrr_stack+3800, r12vrr_stack+3996, r12vrr_stack+3093);

 /*--- compute (g0|i0)^0 ---*/
 am[0] = 4;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+5256, r12vrr_stack+4416, r12vrr_stack+4976, r12vrr_stack+4248, r12vrr_stack+4080, r12vrr_stack+3219);
 tmp = r12vrr_stack + 5256;
 target_ptr = Libr12->gvrr_classes[4][6];
 for(i=0;i<420;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|k0)^2 ---*/
 am[0] = 0;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+5676, r12vrr_stack+3744, r12vrr_stack+1224, r12vrr_stack+2274, r12vrr_stack+2463, NULL);

 /*--- compute (00|k0)^1 ---*/
 am[0] = 0;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+5712, r12vrr_stack+3772, r12vrr_stack+3744, r12vrr_stack+2295, r12vrr_stack+2274, NULL);

 /*--- compute (p0|k0)^1 ---*/
 am[0] = 1;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+5748, r12vrr_stack+5712, r12vrr_stack+5676, NULL, NULL, r12vrr_stack+3744);

 /*--- compute (00|k0)^0 ---*/
 am[0] = 0;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+5856, r12vrr_stack+3884, r12vrr_stack+3772, r12vrr_stack+2379, r12vrr_stack+2295, NULL);

 /*--- compute (p0|k0)^0 ---*/
 am[0] = 1;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+5892, r12vrr_stack+5856, r12vrr_stack+5712, NULL, NULL, r12vrr_stack+3772);

 /*--- compute (00|k0)^3 ---*/
 am[0] = 0;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+3744, r12vrr_stack+1224, r12vrr_stack+4696, r12vrr_stack+2463, r12vrr_stack+3009, NULL);

 /*--- compute (p0|k0)^2 ---*/
 am[0] = 1;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+6000, r12vrr_stack+5676, r12vrr_stack+3744, NULL, NULL, r12vrr_stack+1224);

 /*--- compute (d0|k0)^1 ---*/
 am[0] = 2;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+6108, r12vrr_stack+5748, r12vrr_stack+6000, r12vrr_stack+5712, r12vrr_stack+5676, r12vrr_stack+3996);

 /*--- compute (d0|k0)^0 ---*/
 am[0] = 2;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+6324, r12vrr_stack+5892, r12vrr_stack+5748, r12vrr_stack+5856, r12vrr_stack+5712, r12vrr_stack+3800);

 /*--- compute (f0|k0)^0 ---*/
 am[0] = 3;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+6540, r12vrr_stack+6324, r12vrr_stack+6108, r12vrr_stack+5892, r12vrr_stack+5748, r12vrr_stack+4080);
 tmp = r12vrr_stack + 6540;
 target_ptr = Libr12->gvrr_classes[3][7];
 for(i=0;i<360;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (p0|00)^4 ---*/
 _BUILD_p000(Data,r12vrr_stack+5712, Data->F+4, Data->F+5, NULL, NULL, NULL);

 /*--- compute (d0|00)^3 ---*/
 _BUILD_d000(Data,r12vrr_stack+5715, r12vrr_stack+264, r12vrr_stack+5712, Data->F+3, Data->F+4, NULL);

 /*--- compute (f0|00)^2 ---*/
 _BUILD_f000(Data,r12vrr_stack+5721, r12vrr_stack+267, r12vrr_stack+5715, r12vrr_stack+0, r12vrr_stack+264, NULL);

 /*--- compute (p0|p0)^4 ---*/
 _BUILD_p0p0(Data,r12vrr_stack+5731, r12vrr_stack+105, r12vrr_stack+21, NULL, NULL, Data->F+5);

 /*--- compute (d0|p0)^3 ---*/
 _BUILD_d0p0(Data,r12vrr_stack+5856, r12vrr_stack+273, r12vrr_stack+5731, r12vrr_stack+9, r12vrr_stack+105, r12vrr_stack+5712);

 /*--- compute (f0|p0)^2 ---*/
 _BUILD_f0p0(Data,r12vrr_stack+5874, r12vrr_stack+282, r12vrr_stack+5856, r12vrr_stack+12, r12vrr_stack+273, r12vrr_stack+5715);

 /*--- compute (g0|p0)^1 ---*/
 _BUILD_g0p0(Data,r12vrr_stack+5904, r12vrr_stack+300, r12vrr_stack+5874, r12vrr_stack+30, r12vrr_stack+282, r12vrr_stack+5721);

 /*--- compute (p0|d0)^4 ---*/
 _BUILD_p0d0(Data,r12vrr_stack+30, r12vrr_stack+24, r12vrr_stack+3, NULL, NULL, r12vrr_stack+21);

 /*--- compute (d0|d0)^3 ---*/
 _BUILD_d0d0(Data,r12vrr_stack+5949, r12vrr_stack+330, r12vrr_stack+30, r12vrr_stack+108, r12vrr_stack+24, r12vrr_stack+5731);

 /*--- compute (f0|d0)^2 ---*/
 _BUILD_f0d0(Data,r12vrr_stack+3780, r12vrr_stack+348, r12vrr_stack+5949, r12vrr_stack+114, r12vrr_stack+330, r12vrr_stack+5856);

 /*--- compute (g0|d0)^1 ---*/
 _BUILD_g0d0(Data,r12vrr_stack+6900, r12vrr_stack+384, r12vrr_stack+3780, r12vrr_stack+132, r12vrr_stack+348, r12vrr_stack+5874);

 /*--- compute (h0|d0)^0 ---*/
 am[0] = 5;  am[1] = 2;
 vrr_build_xxxx(am,Data,r12vrr_stack+6990, r12vrr_stack+444, r12vrr_stack+6900, r12vrr_stack+204, r12vrr_stack+384, r12vrr_stack+5904);

 /*--- compute (p0|f0)^4 ---*/
 _BUILD_p0f0(Data,r12vrr_stack+108, r12vrr_stack+63, r12vrr_stack+603, NULL, NULL, r12vrr_stack+3);

 /*--- compute (d0|f0)^3 ---*/
 _BUILD_d0f0(Data,r12vrr_stack+7116, r12vrr_stack+784, r12vrr_stack+108, r12vrr_stack+554, r12vrr_stack+63, r12vrr_stack+30);

 /*--- compute (f0|f0)^2 ---*/
 _BUILD_f0f0(Data,r12vrr_stack+7176, r12vrr_stack+814, r12vrr_stack+7116, r12vrr_stack+564, r12vrr_stack+784, r12vrr_stack+5949);

 /*--- compute (g0|f0)^1 ---*/
 _BUILD_g0f0(Data,r12vrr_stack+7276, r12vrr_stack+874, r12vrr_stack+7176, r12vrr_stack+624, r12vrr_stack+814, r12vrr_stack+3780);

 /*--- compute (h0|f0)^0 ---*/
 am[0] = 5;  am[1] = 3;
 vrr_build_xxxx(am,Data,r12vrr_stack+7426, r12vrr_stack+1074, r12vrr_stack+7276, r12vrr_stack+974, r12vrr_stack+874, r12vrr_stack+6900);
 tmp = r12vrr_stack + 7426;
 target_ptr = Libr12->gvrr_classes[5][3];
 for(i=0;i<210;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (p0|g0)^4 ---*/
 _BUILD_p0g0(Data,r12vrr_stack+534, r12vrr_stack+1749, r12vrr_stack+1273, NULL, NULL, r12vrr_stack+603);

 /*--- compute (d0|g0)^3 ---*/
 _BUILD_d0g0(Data,r12vrr_stack+7636, r12vrr_stack+1764, r12vrr_stack+534, r12vrr_stack+1359, r12vrr_stack+1749, r12vrr_stack+108);

 /*--- compute (f0|g0)^2 ---*/
 _BUILD_f0g0(Data,r12vrr_stack+7726, r12vrr_stack+1809, r12vrr_stack+7636, r12vrr_stack+1374, r12vrr_stack+1764, r12vrr_stack+7116);

 /*--- compute (g0|g0)^1 ---*/
 _BUILD_g0g0(Data,r12vrr_stack+7876, r12vrr_stack+1899, r12vrr_stack+7726, r12vrr_stack+1419, r12vrr_stack+1809, r12vrr_stack+7176);

 /*--- compute (h0|g0)^0 ---*/
 am[0] = 5;  am[1] = 4;
 vrr_build_xxxx(am,Data,r12vrr_stack+8101, r12vrr_stack+2049, r12vrr_stack+7876, r12vrr_stack+1599, r12vrr_stack+1899, r12vrr_stack+7276);
 tmp = r12vrr_stack + 8101;
 target_ptr = Libr12->gvrr_classes[5][4];
 for(i=0;i<315;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (p0|h0)^4 ---*/
 am[0] = 1;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+1359, r12vrr_stack+3009, r12vrr_stack+2350, NULL, NULL, r12vrr_stack+1273);

 /*--- compute (d0|h0)^3 ---*/
 am[0] = 2;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+8416, r12vrr_stack+3030, r12vrr_stack+1359, r12vrr_stack+2463, r12vrr_stack+3009, r12vrr_stack+534);

 /*--- compute (f0|h0)^2 ---*/
 am[0] = 3;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+8542, r12vrr_stack+3093, r12vrr_stack+8416, r12vrr_stack+2484, r12vrr_stack+3030, r12vrr_stack+7636);

 /*--- compute (g0|h0)^1 ---*/
 am[0] = 4;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+8752, r12vrr_stack+3219, r12vrr_stack+8542, r12vrr_stack+2547, r12vrr_stack+3093, r12vrr_stack+7726);

 /*--- compute (h0|h0)^0 ---*/
 am[0] = 5;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+9067, r12vrr_stack+3429, r12vrr_stack+8752, r12vrr_stack+2799, r12vrr_stack+3219, r12vrr_stack+7876);
 tmp = r12vrr_stack + 9067;
 target_ptr = Libr12->gvrr_classes[5][5];
 for(i=0;i<441;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|p0)^10 ---*/
 _BUILD_00p0(Data,r12vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);

 /*--- compute (00|d0)^9 ---*/
 _BUILD_00d0(Data,r12vrr_stack+2463, r12vrr_stack+2316, r12vrr_stack+0, Data->F+9, Data->F+10, NULL);

 /*--- compute (00|f0)^8 ---*/
 _BUILD_00f0(Data,r12vrr_stack+2469, r12vrr_stack+2319, r12vrr_stack+2463, r12vrr_stack+1254, r12vrr_stack+2316, NULL);

 /*--- compute (00|g0)^7 ---*/
 _BUILD_00g0(Data,r12vrr_stack+5985, r12vrr_stack+2325, r12vrr_stack+2469, r12vrr_stack+1257, r12vrr_stack+2319, NULL);

 /*--- compute (00|h0)^6 ---*/
 am[0] = 0;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+2479, r12vrr_stack+2335, r12vrr_stack+5985, r12vrr_stack+1263, r12vrr_stack+2325, NULL);

 /*--- compute (00|i0)^5 ---*/
 am[0] = 0;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+2500, r12vrr_stack+2350, r12vrr_stack+2479, r12vrr_stack+1273, r12vrr_stack+2335, NULL);

 /*--- compute (p0|i0)^4 ---*/
 am[0] = 1;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+2528, r12vrr_stack+4696, r12vrr_stack+2500, NULL, NULL, r12vrr_stack+2350);

 /*--- compute (d0|i0)^3 ---*/
 am[0] = 2;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+9508, r12vrr_stack+4724, r12vrr_stack+2528, r12vrr_stack+1224, r12vrr_stack+4696, r12vrr_stack+1359);

 /*--- compute (f0|i0)^2 ---*/
 am[0] = 3;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+9676, r12vrr_stack+4808, r12vrr_stack+9508, r12vrr_stack+3996, r12vrr_stack+4724, r12vrr_stack+8416);

 /*--- compute (g0|i0)^1 ---*/
 am[0] = 4;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+9956, r12vrr_stack+4976, r12vrr_stack+9676, r12vrr_stack+4080, r12vrr_stack+4808, r12vrr_stack+8542);

 /*--- compute (h0|i0)^0 ---*/
 am[0] = 5;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+10376, r12vrr_stack+5256, r12vrr_stack+9956, r12vrr_stack+4416, r12vrr_stack+4976, r12vrr_stack+8752);
 tmp = r12vrr_stack + 10376;
 target_ptr = Libr12->gvrr_classes[5][6];
 for(i=0;i<588;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|k0)^4 ---*/
 am[0] = 0;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+3996, r12vrr_stack+4696, r12vrr_stack+2500, r12vrr_stack+3009, r12vrr_stack+2350, NULL);

 /*--- compute (p0|k0)^3 ---*/
 am[0] = 1;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+4032, r12vrr_stack+3744, r12vrr_stack+3996, NULL, NULL, r12vrr_stack+4696);

 /*--- compute (d0|k0)^2 ---*/
 am[0] = 2;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+10964, r12vrr_stack+6000, r12vrr_stack+4032, r12vrr_stack+5676, r12vrr_stack+3744, r12vrr_stack+4724);

 /*--- compute (f0|k0)^1 ---*/
 am[0] = 3;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+11180, r12vrr_stack+6108, r12vrr_stack+10964, r12vrr_stack+5748, r12vrr_stack+6000, r12vrr_stack+4808);

 /*--- compute (g0|k0)^0 ---*/
 am[0] = 4;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+11540, r12vrr_stack+6540, r12vrr_stack+11180, r12vrr_stack+6324, r12vrr_stack+6108, r12vrr_stack+4976);
 tmp = r12vrr_stack + 11540;
 target_ptr = Libr12->gvrr_classes[4][7];
 for(i=0;i<540;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (p0|00)^5 ---*/
 _BUILD_p000(Data,r12vrr_stack+5676, Data->F+5, Data->F+6, NULL, NULL, NULL);

 /*--- compute (d0|00)^4 ---*/
 _BUILD_d000(Data,r12vrr_stack+5679, r12vrr_stack+5712, r12vrr_stack+5676, Data->F+4, Data->F+5, NULL);

 /*--- compute (f0|00)^3 ---*/
 _BUILD_f000(Data,r12vrr_stack+5685, r12vrr_stack+5715, r12vrr_stack+5679, r12vrr_stack+264, r12vrr_stack+5712, NULL);

 /*--- compute (g0|00)^2 ---*/
 _BUILD_g000(Data,r12vrr_stack+579, r12vrr_stack+5721, r12vrr_stack+5685, r12vrr_stack+267, r12vrr_stack+5715, NULL);

 /*--- compute (p0|p0)^5 ---*/
 _BUILD_p0p0(Data,r12vrr_stack+264, r12vrr_stack+21, r12vrr_stack+60, NULL, NULL, Data->F+6);

 /*--- compute (d0|p0)^4 ---*/
 _BUILD_d0p0(Data,r12vrr_stack+4140, r12vrr_stack+5731, r12vrr_stack+264, r12vrr_stack+105, r12vrr_stack+21, r12vrr_stack+5676);

 /*--- compute (f0|p0)^3 ---*/
 _BUILD_f0p0(Data,r12vrr_stack+138, r12vrr_stack+5856, r12vrr_stack+4140, r12vrr_stack+273, r12vrr_stack+5731, r12vrr_stack+5679);

 /*--- compute (g0|p0)^2 ---*/
 _BUILD_g0p0(Data,r12vrr_stack+4158, r12vrr_stack+5874, r12vrr_stack+138, r12vrr_stack+282, r12vrr_stack+5856, r12vrr_stack+5685);

 /*--- compute (h0|p0)^1 ---*/
 am[0] = 5;  am[1] = 1;
 vrr_build_xxxx(am,Data,r12vrr_stack+1422, r12vrr_stack+5904, r12vrr_stack+4158, r12vrr_stack+300, r12vrr_stack+5874, r12vrr_stack+579);

 /*--- compute (p0|d0)^5 ---*/
 _BUILD_p0d0(Data,r12vrr_stack+273, r12vrr_stack+3, r12vrr_stack+597, NULL, NULL, r12vrr_stack+60);

 /*--- compute (d0|d0)^4 ---*/
 _BUILD_d0d0(Data,r12vrr_stack+291, r12vrr_stack+30, r12vrr_stack+273, r12vrr_stack+24, r12vrr_stack+3, r12vrr_stack+264);

 /*--- compute (f0|d0)^3 ---*/
 _BUILD_f0d0(Data,r12vrr_stack+2612, r12vrr_stack+5949, r12vrr_stack+291, r12vrr_stack+330, r12vrr_stack+30, r12vrr_stack+4140);

 /*--- compute (g0|d0)^2 ---*/
 _BUILD_g0d0(Data,r12vrr_stack+5740, r12vrr_stack+3780, r12vrr_stack+2612, r12vrr_stack+348, r12vrr_stack+5949, r12vrr_stack+138);

 /*--- compute (h0|d0)^1 ---*/
 am[0] = 5;  am[1] = 2;
 vrr_build_xxxx(am,Data,r12vrr_stack+12080, r12vrr_stack+6900, r12vrr_stack+5740, r12vrr_stack+384, r12vrr_stack+3780, r12vrr_stack+4158);

 /*--- compute (i0|d0)^0 ---*/
 am[0] = 6;  am[1] = 2;
 vrr_build_xxxx(am,Data,r12vrr_stack+12206, r12vrr_stack+6990, r12vrr_stack+12080, r12vrr_stack+444, r12vrr_stack+6900, r12vrr_stack+1422);

 /*--- compute (p0|f0)^5 ---*/
 _BUILD_p0f0(Data,r12vrr_stack+327, r12vrr_stack+603, r12vrr_stack+1263, NULL, NULL, r12vrr_stack+597);

 /*--- compute (d0|f0)^4 ---*/
 _BUILD_d0f0(Data,r12vrr_stack+357, r12vrr_stack+108, r12vrr_stack+327, r12vrr_stack+63, r12vrr_stack+603, r12vrr_stack+273);

 /*--- compute (f0|f0)^3 ---*/
 _BUILD_f0f0(Data,r12vrr_stack+12374, r12vrr_stack+7116, r12vrr_stack+357, r12vrr_stack+784, r12vrr_stack+108, r12vrr_stack+291);

 /*--- compute (g0|f0)^2 ---*/
 _BUILD_g0f0(Data,r12vrr_stack+12474, r12vrr_stack+7176, r12vrr_stack+12374, r12vrr_stack+814, r12vrr_stack+7116, r12vrr_stack+2612);

 /*--- compute (h0|f0)^1 ---*/
 am[0] = 5;  am[1] = 3;
 vrr_build_xxxx(am,Data,r12vrr_stack+12624, r12vrr_stack+7276, r12vrr_stack+12474, r12vrr_stack+874, r12vrr_stack+7176, r12vrr_stack+5740);

 /*--- compute (i0|f0)^0 ---*/
 am[0] = 6;  am[1] = 3;
 vrr_build_xxxx(am,Data,r12vrr_stack+12834, r12vrr_stack+7426, r12vrr_stack+12624, r12vrr_stack+1074, r12vrr_stack+7276, r12vrr_stack+12080);
 tmp = r12vrr_stack + 12834;
 target_ptr = Libr12->gvrr_classes[6][3];
 for(i=0;i<280;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (p0|g0)^5 ---*/
 _BUILD_p0g0(Data,r12vrr_stack+4203, r12vrr_stack+1273, r12vrr_stack+2335, NULL, NULL, r12vrr_stack+1263);

 /*--- compute (d0|g0)^4 ---*/
 _BUILD_d0g0(Data,r12vrr_stack+784, r12vrr_stack+534, r12vrr_stack+4203, r12vrr_stack+1749, r12vrr_stack+1273, r12vrr_stack+327);

 /*--- compute (f0|g0)^3 ---*/
 _BUILD_f0g0(Data,r12vrr_stack+13114, r12vrr_stack+7636, r12vrr_stack+784, r12vrr_stack+1764, r12vrr_stack+534, r12vrr_stack+357);

 /*--- compute (g0|g0)^2 ---*/
 _BUILD_g0g0(Data,r12vrr_stack+13264, r12vrr_stack+7726, r12vrr_stack+13114, r12vrr_stack+1809, r12vrr_stack+7636, r12vrr_stack+12374);

 /*--- compute (h0|g0)^1 ---*/
 am[0] = 5;  am[1] = 4;
 vrr_build_xxxx(am,Data,r12vrr_stack+13489, r12vrr_stack+7876, r12vrr_stack+13264, r12vrr_stack+1899, r12vrr_stack+7726, r12vrr_stack+12474);

 /*--- compute (i0|g0)^0 ---*/
 am[0] = 6;  am[1] = 4;
 vrr_build_xxxx(am,Data,r12vrr_stack+13804, r12vrr_stack+8101, r12vrr_stack+13489, r12vrr_stack+2049, r12vrr_stack+7876, r12vrr_stack+12624);
 tmp = r12vrr_stack + 13804;
 target_ptr = Libr12->gvrr_classes[6][4];
 for(i=0;i<420;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (p0|h0)^5 ---*/
 am[0] = 1;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+1749, r12vrr_stack+2350, r12vrr_stack+2479, NULL, NULL, r12vrr_stack+2335);

 /*--- compute (d0|h0)^4 ---*/
 am[0] = 2;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+1812, r12vrr_stack+1359, r12vrr_stack+1749, r12vrr_stack+3009, r12vrr_stack+2350, r12vrr_stack+4203);

 /*--- compute (f0|h0)^3 ---*/
 am[0] = 3;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+14224, r12vrr_stack+8416, r12vrr_stack+1812, r12vrr_stack+3030, r12vrr_stack+1359, r12vrr_stack+784);

 /*--- compute (g0|h0)^2 ---*/
 am[0] = 4;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+14434, r12vrr_stack+8542, r12vrr_stack+14224, r12vrr_stack+3093, r12vrr_stack+8416, r12vrr_stack+13114);

 /*--- compute (h0|h0)^1 ---*/
 am[0] = 5;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+14749, r12vrr_stack+8752, r12vrr_stack+14434, r12vrr_stack+3219, r12vrr_stack+8542, r12vrr_stack+13264);

 /*--- compute (i0|h0)^0 ---*/
 am[0] = 6;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+15190, r12vrr_stack+9067, r12vrr_stack+14749, r12vrr_stack+3429, r12vrr_stack+8752, r12vrr_stack+13489);
 tmp = r12vrr_stack + 15190;
 target_ptr = Libr12->gvrr_classes[6][5];
 for(i=0;i<588;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|p0)^11 ---*/
 _BUILD_00p0(Data,r12vrr_stack+105, Data->F+11, Data->F+12, NULL, NULL, NULL);

 /*--- compute (00|d0)^10 ---*/
 _BUILD_00d0(Data,r12vrr_stack+24, r12vrr_stack+0, r12vrr_stack+105, Data->F+10, Data->F+11, NULL);

 /*--- compute (00|f0)^9 ---*/
 _BUILD_00f0(Data,r12vrr_stack+3009, r12vrr_stack+2463, r12vrr_stack+24, r12vrr_stack+2316, r12vrr_stack+0, NULL);

 /*--- compute (00|g0)^8 ---*/
 _BUILD_00g0(Data,r12vrr_stack+63, r12vrr_stack+2469, r12vrr_stack+3009, r12vrr_stack+2319, r12vrr_stack+2463, NULL);

 /*--- compute (00|h0)^7 ---*/
 am[0] = 0;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+3019, r12vrr_stack+5985, r12vrr_stack+63, r12vrr_stack+2325, r12vrr_stack+2469, NULL);

 /*--- compute (00|i0)^6 ---*/
 am[0] = 0;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+3040, r12vrr_stack+2479, r12vrr_stack+3019, r12vrr_stack+2335, r12vrr_stack+5985, NULL);

 /*--- compute (p0|i0)^5 ---*/
 am[0] = 1;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+3068, r12vrr_stack+2500, r12vrr_stack+3040, NULL, NULL, r12vrr_stack+2479);

 /*--- compute (d0|i0)^4 ---*/
 am[0] = 2;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+3152, r12vrr_stack+2528, r12vrr_stack+3068, r12vrr_stack+4696, r12vrr_stack+2500, r12vrr_stack+1749);

 /*--- compute (f0|i0)^3 ---*/
 am[0] = 3;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+15778, r12vrr_stack+9508, r12vrr_stack+3152, r12vrr_stack+4724, r12vrr_stack+2528, r12vrr_stack+1812);

 /*--- compute (g0|i0)^2 ---*/
 am[0] = 4;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+16058, r12vrr_stack+9676, r12vrr_stack+15778, r12vrr_stack+4808, r12vrr_stack+9508, r12vrr_stack+14224);

 /*--- compute (h0|i0)^1 ---*/
 am[0] = 5;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+16478, r12vrr_stack+9956, r12vrr_stack+16058, r12vrr_stack+4976, r12vrr_stack+9676, r12vrr_stack+14434);

 /*--- compute (i0|i0)^0 ---*/
 am[0] = 6;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+17066, r12vrr_stack+10376, r12vrr_stack+16478, r12vrr_stack+5256, r12vrr_stack+9956, r12vrr_stack+14749);
 tmp = r12vrr_stack + 17066;
 target_ptr = Libr12->gvrr_classes[6][6];
 for(i=0;i<784;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|k0)^5 ---*/
 am[0] = 0;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+4696, r12vrr_stack+2500, r12vrr_stack+3040, r12vrr_stack+2350, r12vrr_stack+2479, NULL);

 /*--- compute (p0|k0)^4 ---*/
 am[0] = 1;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+4732, r12vrr_stack+3996, r12vrr_stack+4696, NULL, NULL, r12vrr_stack+2500);

 /*--- compute (d0|k0)^3 ---*/
 am[0] = 2;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+4840, r12vrr_stack+4032, r12vrr_stack+4732, r12vrr_stack+3744, r12vrr_stack+3996, r12vrr_stack+2528);

 /*--- compute (f0|k0)^2 ---*/
 am[0] = 3;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+17850, r12vrr_stack+10964, r12vrr_stack+4840, r12vrr_stack+6000, r12vrr_stack+4032, r12vrr_stack+9508);

 /*--- compute (g0|k0)^1 ---*/
 am[0] = 4;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+18210, r12vrr_stack+11180, r12vrr_stack+17850, r12vrr_stack+6108, r12vrr_stack+10964, r12vrr_stack+9676);

 /*--- compute (h0|k0)^0 ---*/
 am[0] = 5;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+18750, r12vrr_stack+11540, r12vrr_stack+18210, r12vrr_stack+6540, r12vrr_stack+11180, r12vrr_stack+9956);
 tmp = r12vrr_stack + 18750;
 target_ptr = Libr12->gvrr_classes[5][7];
 for(i=0;i<756;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (p0|00)^6 ---*/
 _BUILD_p000(Data,r12vrr_stack+6000, Data->F+6, Data->F+7, NULL, NULL, NULL);

 /*--- compute (d0|00)^5 ---*/
 _BUILD_d000(Data,r12vrr_stack+6003, r12vrr_stack+5676, r12vrr_stack+6000, Data->F+5, Data->F+6, NULL);

 /*--- compute (f0|00)^4 ---*/
 _BUILD_f000(Data,r12vrr_stack+6009, r12vrr_stack+5679, r12vrr_stack+6003, r12vrr_stack+5712, r12vrr_stack+5676, NULL);

 /*--- compute (g0|00)^3 ---*/
 _BUILD_g000(Data,r12vrr_stack+6019, r12vrr_stack+5685, r12vrr_stack+6009, r12vrr_stack+5715, r12vrr_stack+5679, NULL);

 /*--- compute (h0|00)^2 ---*/
 am[0] = 5;  am[1] = 0;
 vrr_build_xxxx(am,Data,r12vrr_stack+6034, r12vrr_stack+579, r12vrr_stack+6019, r12vrr_stack+5721, r12vrr_stack+5685, NULL);

 /*--- compute (p0|p0)^6 ---*/
 _BUILD_p0p0(Data,r12vrr_stack+579, r12vrr_stack+60, r12vrr_stack+594, NULL, NULL, Data->F+7);

 /*--- compute (d0|p0)^5 ---*/
 _BUILD_d0p0(Data,r12vrr_stack+5676, r12vrr_stack+264, r12vrr_stack+579, r12vrr_stack+21, r12vrr_stack+60, r12vrr_stack+6000);

 /*--- compute (f0|p0)^4 ---*/
 _BUILD_f0p0(Data,r12vrr_stack+5694, r12vrr_stack+4140, r12vrr_stack+5676, r12vrr_stack+5731, r12vrr_stack+264, r12vrr_stack+6003);

 /*--- compute (g0|p0)^3 ---*/
 _BUILD_g0p0(Data,r12vrr_stack+6055, r12vrr_stack+138, r12vrr_stack+5694, r12vrr_stack+5856, r12vrr_stack+4140, r12vrr_stack+6009);

 /*--- compute (h0|p0)^2 ---*/
 am[0] = 5;  am[1] = 1;
 vrr_build_xxxx(am,Data,r12vrr_stack+6100, r12vrr_stack+4158, r12vrr_stack+6055, r12vrr_stack+5874, r12vrr_stack+138, r12vrr_stack+6019);

 /*--- compute (i0|p0)^1 ---*/
 am[0] = 6;  am[1] = 1;
 vrr_build_xxxx(am,Data,r12vrr_stack+6163, r12vrr_stack+1422, r12vrr_stack+6100, r12vrr_stack+5904, r12vrr_stack+4158, r12vrr_stack+6034);

 /*--- compute (p0|d0)^6 ---*/
 _BUILD_p0d0(Data,r12vrr_stack+1422, r12vrr_stack+597, r12vrr_stack+1257, NULL, NULL, r12vrr_stack+594);

 /*--- compute (d0|d0)^5 ---*/
 _BUILD_d0d0(Data,r12vrr_stack+3744, r12vrr_stack+273, r12vrr_stack+1422, r12vrr_stack+3, r12vrr_stack+597, r12vrr_stack+579);

 /*--- compute (f0|d0)^4 ---*/
 _BUILD_f0d0(Data,r12vrr_stack+1440, r12vrr_stack+291, r12vrr_stack+3744, r12vrr_stack+30, r12vrr_stack+273, r12vrr_stack+5676);

 /*--- compute (g0|d0)^3 ---*/
 _BUILD_g0d0(Data,r12vrr_stack+5056, r12vrr_stack+2612, r12vrr_stack+1440, r12vrr_stack+5949, r12vrr_stack+291, r12vrr_stack+5694);

 /*--- compute (h0|d0)^2 ---*/
 am[0] = 5;  am[1] = 2;
 vrr_build_xxxx(am,Data,r12vrr_stack+5830, r12vrr_stack+5740, r12vrr_stack+5056, r12vrr_stack+3780, r12vrr_stack+2612, r12vrr_stack+6055);

 /*--- compute (i0|d0)^1 ---*/
 am[0] = 6;  am[1] = 2;
 vrr_build_xxxx(am,Data,r12vrr_stack+19506, r12vrr_stack+12080, r12vrr_stack+5830, r12vrr_stack+6900, r12vrr_stack+5740, r12vrr_stack+6100);

 /*--- compute (k0|d0)^0 ---*/
 am[0] = 7;  am[1] = 2;
 vrr_build_xxxx(am,Data,r12vrr_stack+19674, r12vrr_stack+12206, r12vrr_stack+19506, r12vrr_stack+6990, r12vrr_stack+12080, r12vrr_stack+6163);

 /*--- compute (p0|f0)^6 ---*/
 _BUILD_p0f0(Data,r12vrr_stack+138, r12vrr_stack+1263, r12vrr_stack+2325, NULL, NULL, r12vrr_stack+1257);

 /*--- compute (d0|f0)^5 ---*/
 _BUILD_d0f0(Data,r12vrr_stack+12080, r12vrr_stack+327, r12vrr_stack+138, r12vrr_stack+603, r12vrr_stack+1263, r12vrr_stack+1422);

 /*--- compute (f0|f0)^4 ---*/
 _BUILD_f0f0(Data,r12vrr_stack+874, r12vrr_stack+357, r12vrr_stack+12080, r12vrr_stack+108, r12vrr_stack+327, r12vrr_stack+3744);

 /*--- compute (g0|f0)^3 ---*/
 _BUILD_g0f0(Data,r12vrr_stack+5676, r12vrr_stack+12374, r12vrr_stack+874, r12vrr_stack+7116, r12vrr_stack+357, r12vrr_stack+1440);

 /*--- compute (h0|f0)^2 ---*/
 am[0] = 5;  am[1] = 3;
 vrr_build_xxxx(am,Data,r12vrr_stack+6000, r12vrr_stack+12474, r12vrr_stack+5676, r12vrr_stack+7176, r12vrr_stack+12374, r12vrr_stack+5056);

 /*--- compute (i0|f0)^1 ---*/
 am[0] = 6;  am[1] = 3;
 vrr_build_xxxx(am,Data,r12vrr_stack+19890, r12vrr_stack+12624, r12vrr_stack+6000, r12vrr_stack+7276, r12vrr_stack+12474, r12vrr_stack+5830);

 /*--- compute (k0|f0)^0 ---*/
 am[0] = 7;  am[1] = 3;
 vrr_build_xxxx(am,Data,r12vrr_stack+20170, r12vrr_stack+12834, r12vrr_stack+19890, r12vrr_stack+7426, r12vrr_stack+12624, r12vrr_stack+19506);
 tmp = r12vrr_stack + 20170;
 target_ptr = Libr12->gvrr_classes[7][3];
 for(i=0;i<360;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (p0|g0)^6 ---*/
 _BUILD_p0g0(Data,r12vrr_stack+19506, r12vrr_stack+2335, r12vrr_stack+5985, NULL, NULL, r12vrr_stack+2325);

 /*--- compute (d0|g0)^5 ---*/
 _BUILD_d0g0(Data,r12vrr_stack+6900, r12vrr_stack+4203, r12vrr_stack+19506, r12vrr_stack+1273, r12vrr_stack+2335, r12vrr_stack+138);

 /*--- compute (f0|g0)^4 ---*/
 _BUILD_f0g0(Data,r12vrr_stack+5056, r12vrr_stack+784, r12vrr_stack+6900, r12vrr_stack+534, r12vrr_stack+4203, r12vrr_stack+12080);

 /*--- compute (g0|g0)^3 ---*/
 _BUILD_g0g0(Data,r12vrr_stack+12374, r12vrr_stack+13114, r12vrr_stack+5056, r12vrr_stack+7636, r12vrr_stack+784, r12vrr_stack+874);

 /*--- compute (h0|g0)^2 ---*/
 am[0] = 5;  am[1] = 4;
 vrr_build_xxxx(am,Data,r12vrr_stack+20530, r12vrr_stack+13264, r12vrr_stack+12374, r12vrr_stack+7726, r12vrr_stack+13114, r12vrr_stack+5676);

 /*--- compute (i0|g0)^1 ---*/
 am[0] = 6;  am[1] = 4;
 vrr_build_xxxx(am,Data,r12vrr_stack+20845, r12vrr_stack+13489, r12vrr_stack+20530, r12vrr_stack+7876, r12vrr_stack+13264, r12vrr_stack+6000);

 /*--- compute (k0|g0)^0 ---*/
 am[0] = 7;  am[1] = 4;
 vrr_build_xxxx(am,Data,r12vrr_stack+21265, r12vrr_stack+13804, r12vrr_stack+20845, r12vrr_stack+8101, r12vrr_stack+13489, r12vrr_stack+19890);
 tmp = r12vrr_stack + 21265;
 target_ptr = Libr12->gvrr_classes[7][4];
 for(i=0;i<540;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (p0|h0)^6 ---*/
 am[0] = 1;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+19890, r12vrr_stack+2479, r12vrr_stack+3019, NULL, NULL, r12vrr_stack+5985);

 /*--- compute (d0|h0)^5 ---*/
 am[0] = 2;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+12080, r12vrr_stack+1749, r12vrr_stack+19890, r12vrr_stack+2350, r12vrr_stack+2479, r12vrr_stack+19506);

 /*--- compute (f0|h0)^4 ---*/
 am[0] = 3;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+19953, r12vrr_stack+1812, r12vrr_stack+12080, r12vrr_stack+1359, r12vrr_stack+1749, r12vrr_stack+6900);

 /*--- compute (g0|h0)^3 ---*/
 am[0] = 4;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+6000, r12vrr_stack+14224, r12vrr_stack+19953, r12vrr_stack+8416, r12vrr_stack+1812, r12vrr_stack+5056);

 /*--- compute (h0|h0)^2 ---*/
 am[0] = 5;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+13114, r12vrr_stack+14434, r12vrr_stack+6000, r12vrr_stack+8542, r12vrr_stack+14224, r12vrr_stack+12374);

 /*--- compute (i0|h0)^1 ---*/
 am[0] = 6;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+21805, r12vrr_stack+14749, r12vrr_stack+13114, r12vrr_stack+8752, r12vrr_stack+14434, r12vrr_stack+20530);

 /*--- compute (k0|h0)^0 ---*/
 am[0] = 7;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+22393, r12vrr_stack+15190, r12vrr_stack+21805, r12vrr_stack+9067, r12vrr_stack+14749, r12vrr_stack+20845);
 tmp = r12vrr_stack + 22393;
 target_ptr = Libr12->gvrr_classes[7][5];
 for(i=0;i<756;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00|p0)^12 ---*/
 _BUILD_00p0(Data,r12vrr_stack+20530, Data->F+12, Data->F+13, NULL, NULL, NULL);

 /*--- compute (00|d0)^11 ---*/
 _BUILD_00d0(Data,r12vrr_stack+20533, r12vrr_stack+105, r12vrr_stack+20530, Data->F+11, Data->F+12, NULL);

 /*--- compute (00|f0)^10 ---*/
 _BUILD_00f0(Data,r12vrr_stack+20539, r12vrr_stack+24, r12vrr_stack+20533, r12vrr_stack+0, r12vrr_stack+105, NULL);

 /*--- compute (00|g0)^9 ---*/
 _BUILD_00g0(Data,r12vrr_stack+105, r12vrr_stack+3009, r12vrr_stack+20539, r12vrr_stack+2463, r12vrr_stack+24, NULL);

 /*--- compute (00|h0)^8 ---*/
 am[0] = 0;  am[1] = 5;
 vrr_build_xxxx(am,Data,r12vrr_stack+120, r12vrr_stack+63, r12vrr_stack+105, r12vrr_stack+2469, r12vrr_stack+3009, NULL);

 /*--- compute (00|i0)^7 ---*/
 am[0] = 0;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+0, r12vrr_stack+3019, r12vrr_stack+120, r12vrr_stack+5985, r12vrr_stack+63, NULL);

 /*--- compute (p0|i0)^6 ---*/
 am[0] = 1;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+20530, r12vrr_stack+3040, r12vrr_stack+0, NULL, NULL, r12vrr_stack+3019);

 /*--- compute (d0|i0)^5 ---*/
 am[0] = 2;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+19506, r12vrr_stack+3068, r12vrr_stack+20530, r12vrr_stack+2500, r12vrr_stack+3040, r12vrr_stack+19890);

 /*--- compute (f0|i0)^4 ---*/
 am[0] = 3;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+20530, r12vrr_stack+3152, r12vrr_stack+19506, r12vrr_stack+2528, r12vrr_stack+3068, r12vrr_stack+12080);

 /*--- compute (g0|i0)^3 ---*/
 am[0] = 4;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+20810, r12vrr_stack+15778, r12vrr_stack+20530, r12vrr_stack+9508, r12vrr_stack+3152, r12vrr_stack+19953);

 /*--- compute (h0|i0)^2 ---*/
 am[0] = 5;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+14224, r12vrr_stack+16058, r12vrr_stack+20810, r12vrr_stack+9676, r12vrr_stack+15778, r12vrr_stack+6000);

 /*--- compute (i0|i0)^1 ---*/
 am[0] = 6;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+23149, r12vrr_stack+16478, r12vrr_stack+14224, r12vrr_stack+9956, r12vrr_stack+16058, r12vrr_stack+13114);

 /*--- compute (k0|i0)^0 ---*/
 am[0] = 7;  am[1] = 6;
 vrr_build_xxxx(am,Data,r12vrr_stack+23933, r12vrr_stack+17066, r12vrr_stack+23149, r12vrr_stack+10376, r12vrr_stack+16478, r12vrr_stack+21805);

 /*--- compute (00|k0)^6 ---*/
 am[0] = 0;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+21805, r12vrr_stack+3040, r12vrr_stack+0, r12vrr_stack+2479, r12vrr_stack+3019, NULL);

 /*--- compute (p0|k0)^5 ---*/
 am[0] = 1;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+4140, r12vrr_stack+4696, r12vrr_stack+21805, NULL, NULL, r12vrr_stack+3040);

 /*--- compute (d0|k0)^4 ---*/
 am[0] = 2;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+21805, r12vrr_stack+4732, r12vrr_stack+4140, r12vrr_stack+3996, r12vrr_stack+4696, r12vrr_stack+3068);

 /*--- compute (f0|k0)^3 ---*/
 am[0] = 3;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+22021, r12vrr_stack+4840, r12vrr_stack+21805, r12vrr_stack+4032, r12vrr_stack+4732, r12vrr_stack+3152);

 /*--- compute (g0|k0)^2 ---*/
 am[0] = 4;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+23149, r12vrr_stack+17850, r12vrr_stack+22021, r12vrr_stack+10964, r12vrr_stack+4840, r12vrr_stack+15778);

 /*--- compute (h0|k0)^1 ---*/
 am[0] = 5;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+14224, r12vrr_stack+18210, r12vrr_stack+23149, r12vrr_stack+11180, r12vrr_stack+17850, r12vrr_stack+16058);

 /*--- compute (i0|k0)^0 ---*/
 am[0] = 6;  am[1] = 7;
 vrr_build_xxxx(am,Data,r12vrr_stack+24941, r12vrr_stack+18750, r12vrr_stack+14224, r12vrr_stack+11540, r12vrr_stack+18210, r12vrr_stack+16478);

 /*--- compute (00||p0)^0 ---*/
 _R_BUILD_00p0(Data,r12vrr_stack+14224, &(Data->ss_r12_ss), NULL, r12vrr_stack+78, Data->F+0, NULL, NULL);

 /*--- compute (00||d0)^0 ---*/
 _R_BUILD_00d0(Data,r12vrr_stack+14227, r12vrr_stack+14224, &(Data->ss_r12_ss), r12vrr_stack+81, r12vrr_stack+78, Data->F+0, NULL);

 /*--- compute (00||f0)^0 ---*/
 _R_BUILD_00f0(Data,r12vrr_stack+14233, r12vrr_stack+14227, r12vrr_stack+14224, r12vrr_stack+684, r12vrr_stack+81, r12vrr_stack+78, NULL);

 /*--- compute (p0||f0)^0 ---*/
 _R_BUILD_p0f0(Data,r12vrr_stack+14243, r12vrr_stack+14233, NULL, r12vrr_stack+694, r12vrr_stack+684, NULL, r12vrr_stack+81);

 /*--- compute (d0||f0)^0 ---*/
 _R_BUILD_d0f0(Data,r12vrr_stack+14273, r12vrr_stack+14243, r12vrr_stack+14233, r12vrr_stack+724, r12vrr_stack+694, r12vrr_stack+684, r12vrr_stack+87);

 /*--- compute (f0||f0)^0 ---*/
 _R_BUILD_f0f0(Data,r12vrr_stack+14333, r12vrr_stack+14273, r12vrr_stack+14243, r12vrr_stack+974, r12vrr_stack+724, r12vrr_stack+694, r12vrr_stack+168);
 tmp = r12vrr_stack + 14333;
 target_ptr = Libr12->rvrr_classes[3][3];
 for(i=0;i<100;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0||f0)^0 ---*/
 _R_BUILD_g0f0(Data,r12vrr_stack+1359, r12vrr_stack+14333, r12vrr_stack+14273, r12vrr_stack+1074, r12vrr_stack+974, r12vrr_stack+724, r12vrr_stack+204);
 tmp = r12vrr_stack + 1359;
 target_ptr = Libr12->rvrr_classes[4][3];
 for(i=0;i<150;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0||f0)^0 ---*/
 _R_BUILD_h0f0(Data,r12vrr_stack+2463, r12vrr_stack+1359, r12vrr_stack+14333, r12vrr_stack+7426, r12vrr_stack+1074, r12vrr_stack+974, r12vrr_stack+444);
 tmp = r12vrr_stack + 2463;
 target_ptr = Libr12->rvrr_classes[5][3];
 for(i=0;i<210;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00||g0)^0 ---*/
 _R_BUILD_00g0(Data,r12vrr_stack+14243, r12vrr_stack+14233, r12vrr_stack+14227, r12vrr_stack+1299, r12vrr_stack+684, r12vrr_stack+81, NULL);

 /*--- compute (p0||g0)^0 ---*/
 _R_BUILD_p0g0(Data,r12vrr_stack+14258, r12vrr_stack+14243, NULL, r12vrr_stack+1314, r12vrr_stack+1299, NULL, r12vrr_stack+684);

 /*--- compute (d0||g0)^0 ---*/
 _R_BUILD_d0g0(Data,r12vrr_stack+6900, r12vrr_stack+14258, r12vrr_stack+14243, r12vrr_stack+1509, r12vrr_stack+1314, r12vrr_stack+1299, r12vrr_stack+694);

 /*--- compute (f0||g0)^0 ---*/
 _R_BUILD_f0g0(Data,r12vrr_stack+534, r12vrr_stack+6900, r12vrr_stack+14258, r12vrr_stack+1599, r12vrr_stack+1509, r12vrr_stack+1314, r12vrr_stack+724);
 tmp = r12vrr_stack + 534;
 target_ptr = Libr12->rvrr_classes[3][4];
 for(i=0;i<150;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0||g0)^0 ---*/
 _R_BUILD_g0g0(Data,r12vrr_stack+14258, r12vrr_stack+534, r12vrr_stack+6900, r12vrr_stack+2049, r12vrr_stack+1599, r12vrr_stack+1509, r12vrr_stack+974);
 tmp = r12vrr_stack + 14258;
 target_ptr = Libr12->rvrr_classes[4][4];
 for(i=0;i<225;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0||g0)^0 ---*/
 _R_BUILD_h0g0(Data,r12vrr_stack+14483, r12vrr_stack+14258, r12vrr_stack+534, r12vrr_stack+8101, r12vrr_stack+2049, r12vrr_stack+1599, r12vrr_stack+1074);
 tmp = r12vrr_stack + 14483;
 target_ptr = Libr12->rvrr_classes[5][4];
 for(i=0;i<315;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00||h0)^0 ---*/
 _R_BUILD_00h0(Data,r12vrr_stack+534, r12vrr_stack+14243, r12vrr_stack+14233, r12vrr_stack+2379, r12vrr_stack+1299, r12vrr_stack+684, NULL);

 /*--- compute (p0||h0)^0 ---*/
 _R_BUILD_p0h0(Data,r12vrr_stack+555, r12vrr_stack+534, NULL, r12vrr_stack+2400, r12vrr_stack+2379, NULL, r12vrr_stack+1299);

 /*--- compute (d0||h0)^0 ---*/
 _R_BUILD_d0h0(Data,r12vrr_stack+12080, r12vrr_stack+555, r12vrr_stack+534, r12vrr_stack+2673, r12vrr_stack+2400, r12vrr_stack+2379, r12vrr_stack+1314);

 /*--- compute (f0||h0)^0 ---*/
 _R_BUILD_f0h0(Data,r12vrr_stack+14798, r12vrr_stack+12080, r12vrr_stack+555, r12vrr_stack+2799, r12vrr_stack+2673, r12vrr_stack+2400, r12vrr_stack+1509);
 tmp = r12vrr_stack + 14798;
 target_ptr = Libr12->rvrr_classes[3][5];
 for(i=0;i<210;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0||h0)^0 ---*/
 _R_BUILD_g0h0(Data,r12vrr_stack+17850, r12vrr_stack+14798, r12vrr_stack+12080, r12vrr_stack+3429, r12vrr_stack+2799, r12vrr_stack+2673, r12vrr_stack+1599);
 tmp = r12vrr_stack + 17850;
 target_ptr = Libr12->rvrr_classes[4][5];
 for(i=0;i<315;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0||h0)^0 ---*/
 _R_BUILD_h0h0(Data,r12vrr_stack+18165, r12vrr_stack+17850, r12vrr_stack+14798, r12vrr_stack+9067, r12vrr_stack+3429, r12vrr_stack+2799, r12vrr_stack+2049);
 tmp = r12vrr_stack + 18165;
 target_ptr = Libr12->rvrr_classes[5][5];
 for(i=0;i<441;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (00||i0)^0 ---*/
 _R_BUILD_00i0(Data,r12vrr_stack+14798, r12vrr_stack+534, r12vrr_stack+14243, r12vrr_stack+3884, r12vrr_stack+2379, r12vrr_stack+1299, NULL);

 /*--- compute (p0||i0)^0 ---*/
 _R_BUILD_p0i0(Data,r12vrr_stack+534, r12vrr_stack+14798, NULL, r12vrr_stack+3912, r12vrr_stack+3884, NULL, r12vrr_stack+2379);

 /*--- compute (d0||i0)^0 ---*/
 _R_BUILD_d0i0(Data,r12vrr_stack+19506, r12vrr_stack+534, r12vrr_stack+14798, r12vrr_stack+4248, r12vrr_stack+3912, r12vrr_stack+3884, r12vrr_stack+2400);

 /*--- compute (f0||i0)^0 ---*/
 _R_BUILD_f0i0(Data,r12vrr_stack+19890, r12vrr_stack+19506, r12vrr_stack+534, r12vrr_stack+4416, r12vrr_stack+4248, r12vrr_stack+3912, r12vrr_stack+2673);
 tmp = r12vrr_stack + 19890;
 target_ptr = Libr12->rvrr_classes[3][6];
 for(i=0;i<280;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0||i0)^0 ---*/
 _R_BUILD_g0i0(Data,r12vrr_stack+3009, r12vrr_stack+19890, r12vrr_stack+19506, r12vrr_stack+5256, r12vrr_stack+4416, r12vrr_stack+4248, r12vrr_stack+2799);
 tmp = r12vrr_stack + 3009;
 target_ptr = Libr12->rvrr_classes[4][6];
 for(i=0;i<420;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0||i0)^0 ---*/
 _R_BUILD_h0i0(Data,r12vrr_stack+21805, r12vrr_stack+3009, r12vrr_stack+19890, r12vrr_stack+10376, r12vrr_stack+5256, r12vrr_stack+4416, r12vrr_stack+3429);
 tmp = r12vrr_stack + 21805;
 target_ptr = Libr12->rvrr_classes[5][6];
 for(i=0;i<588;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (f0|[r12,T2]|f0)^0 ---*/
 _T2_BUILD_f0f0(Data,&(Libr12->ShellQuartet),r12vrr_stack+19890, r12vrr_stack+974, r12vrr_stack+1599, r12vrr_stack+1074, r12vrr_stack+444, r12vrr_stack+204);
 tmp = r12vrr_stack + 19890;
 target_ptr = Libr12->t2vrr_classes[3][3];
 for(i=0;i<100;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (f0|[r12,T2]|g0)^0 ---*/
 _T2_BUILD_f0g0(Data,&(Libr12->ShellQuartet),r12vrr_stack+19990, r12vrr_stack+1599, r12vrr_stack+2799, r12vrr_stack+2049, r12vrr_stack+1074, r12vrr_stack+974);
 tmp = r12vrr_stack + 19990;
 target_ptr = Libr12->t2vrr_classes[3][4];
 for(i=0;i<150;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (f0|[r12,T2]|h0)^0 ---*/
 _T2_BUILD_f0h0(Data,&(Libr12->ShellQuartet),r12vrr_stack+14798, r12vrr_stack+2799, r12vrr_stack+4416, r12vrr_stack+3429, r12vrr_stack+2049, r12vrr_stack+1599);
 tmp = r12vrr_stack + 14798;
 target_ptr = Libr12->t2vrr_classes[3][5];
 for(i=0;i<210;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (f0|[r12,T2]|i0)^0 ---*/
 _T2_BUILD_f0i0(Data,&(Libr12->ShellQuartet),r12vrr_stack+23149, r12vrr_stack+4416, r12vrr_stack+6540, r12vrr_stack+5256, r12vrr_stack+3429, r12vrr_stack+2799);
 tmp = r12vrr_stack + 23149;
 target_ptr = Libr12->t2vrr_classes[3][6];
 for(i=0;i<280;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0|[r12,T2]|f0)^0 ---*/
 _T2_BUILD_g0f0(Data,&(Libr12->ShellQuartet),r12vrr_stack+19506, r12vrr_stack+1074, r12vrr_stack+2049, r12vrr_stack+7426, r12vrr_stack+6990, r12vrr_stack+444);
 tmp = r12vrr_stack + 19506;
 target_ptr = Libr12->t2vrr_classes[4][3];
 for(i=0;i<150;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0|[r12,T2]|g0)^0 ---*/
 _T2_BUILD_g0g0(Data,&(Libr12->ShellQuartet),r12vrr_stack+23429, r12vrr_stack+2049, r12vrr_stack+3429, r12vrr_stack+8101, r12vrr_stack+7426, r12vrr_stack+1074);
 tmp = r12vrr_stack + 23429;
 target_ptr = Libr12->t2vrr_classes[4][4];
 for(i=0;i<225;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0|[r12,T2]|h0)^0 ---*/
 _T2_BUILD_g0h0(Data,&(Libr12->ShellQuartet),r12vrr_stack+15778, r12vrr_stack+3429, r12vrr_stack+5256, r12vrr_stack+9067, r12vrr_stack+8101, r12vrr_stack+2049);
 tmp = r12vrr_stack + 15778;
 target_ptr = Libr12->t2vrr_classes[4][5];
 for(i=0;i<315;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0|[r12,T2]|i0)^0 ---*/
 _T2_BUILD_g0i0(Data,&(Libr12->ShellQuartet),r12vrr_stack+16093, r12vrr_stack+5256, r12vrr_stack+11540, r12vrr_stack+10376, r12vrr_stack+9067, r12vrr_stack+3429);
 tmp = r12vrr_stack + 16093;
 target_ptr = Libr12->t2vrr_classes[4][6];
 for(i=0;i<420;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0|[r12,T2]|f0)^0 ---*/
 _T2_BUILD_h0f0(Data,&(Libr12->ShellQuartet),r12vrr_stack+23654, r12vrr_stack+7426, r12vrr_stack+8101, r12vrr_stack+12834, r12vrr_stack+12206, r12vrr_stack+6990);
 tmp = r12vrr_stack + 23654;
 target_ptr = Libr12->t2vrr_classes[5][3];
 for(i=0;i<210;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0|[r12,T2]|g0)^0 ---*/
 _T2_BUILD_h0g0(Data,&(Libr12->ShellQuartet),r12vrr_stack+16513, r12vrr_stack+8101, r12vrr_stack+9067, r12vrr_stack+13804, r12vrr_stack+12834, r12vrr_stack+7426);
 tmp = r12vrr_stack + 16513;
 target_ptr = Libr12->t2vrr_classes[5][4];
 for(i=0;i<315;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0|[r12,T2]|h0)^0 ---*/
 _T2_BUILD_h0h0(Data,&(Libr12->ShellQuartet),r12vrr_stack+10964, r12vrr_stack+9067, r12vrr_stack+10376, r12vrr_stack+15190, r12vrr_stack+13804, r12vrr_stack+8101);
 tmp = r12vrr_stack + 10964;
 target_ptr = Libr12->t2vrr_classes[5][5];
 for(i=0;i<441;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0|[r12,T2]|i0)^0 ---*/
 _T2_BUILD_h0i0(Data,&(Libr12->ShellQuartet),r12vrr_stack+0, r12vrr_stack+10376, r12vrr_stack+18750, r12vrr_stack+17066, r12vrr_stack+15190, r12vrr_stack+9067);
 tmp = r12vrr_stack + 0;
 target_ptr = Libr12->t2vrr_classes[5][6];
 for(i=0;i<588;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0|[r12,T2]|f0)^0 ---*/
 _T2_BUILD_i0f0(Data,&(Libr12->ShellQuartet),r12vrr_stack+4696, r12vrr_stack+12834, r12vrr_stack+13804, r12vrr_stack+20170, r12vrr_stack+19674, r12vrr_stack+12206);
 tmp = r12vrr_stack + 4696;
 target_ptr = Libr12->t2vrr_classes[6][3];
 for(i=0;i<280;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0|[r12,T2]|g0)^0 ---*/
 _T2_BUILD_i0g0(Data,&(Libr12->ShellQuartet),r12vrr_stack+12080, r12vrr_stack+13804, r12vrr_stack+15190, r12vrr_stack+21265, r12vrr_stack+20170, r12vrr_stack+12834);
 tmp = r12vrr_stack + 12080;
 target_ptr = Libr12->t2vrr_classes[6][4];
 for(i=0;i<420;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0|[r12,T2]|h0)^0 ---*/
 _T2_BUILD_i0h0(Data,&(Libr12->ShellQuartet),r12vrr_stack+13114, r12vrr_stack+15190, r12vrr_stack+17066, r12vrr_stack+22393, r12vrr_stack+21265, r12vrr_stack+13804);
 tmp = r12vrr_stack + 13114;
 target_ptr = Libr12->t2vrr_classes[6][5];
 for(i=0;i<588;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0|[r12,T2]|i0)^0 ---*/
 _T2_BUILD_i0i0(Data,&(Libr12->ShellQuartet),r12vrr_stack+9508, r12vrr_stack+17066, r12vrr_stack+24941, r12vrr_stack+23933, r12vrr_stack+22393, r12vrr_stack+15190);
 tmp = r12vrr_stack + 9508;
 target_ptr = Libr12->t2vrr_classes[6][6];
 for(i=0;i<784;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (f0|[r12,T1]|f0)^0 ---*/
 _T1_BUILD_f0f0(Data,&(Libr12->ShellQuartet),r12vrr_stack+19656, r12vrr_stack+974, r12vrr_stack+1074, r12vrr_stack+1599, r12vrr_stack+1509, r12vrr_stack+724);
 tmp = r12vrr_stack + 19656;
 target_ptr = Libr12->t1vrr_classes[3][3];
 for(i=0;i<100;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (f0|[r12,T1]|g0)^0 ---*/
 _T1_BUILD_f0g0(Data,&(Libr12->ShellQuartet),r12vrr_stack+15008, r12vrr_stack+1599, r12vrr_stack+2049, r12vrr_stack+2799, r12vrr_stack+2673, r12vrr_stack+1509);
 tmp = r12vrr_stack + 15008;
 target_ptr = Libr12->t1vrr_classes[3][4];
 for(i=0;i<150;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (f0|[r12,T1]|h0)^0 ---*/
 _T1_BUILD_f0h0(Data,&(Libr12->ShellQuartet),r12vrr_stack+12500, r12vrr_stack+2799, r12vrr_stack+3429, r12vrr_stack+4416, r12vrr_stack+4248, r12vrr_stack+2673);
 tmp = r12vrr_stack + 12500;
 target_ptr = Libr12->t1vrr_classes[3][5];
 for(i=0;i<210;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (f0|[r12,T1]|i0)^0 ---*/
 _T1_BUILD_f0i0(Data,&(Libr12->ShellQuartet),r12vrr_stack+4976, r12vrr_stack+4416, r12vrr_stack+5256, r12vrr_stack+6540, r12vrr_stack+6324, r12vrr_stack+4248);
 tmp = r12vrr_stack + 4976;
 target_ptr = Libr12->t1vrr_classes[3][6];
 for(i=0;i<280;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0|[r12,T1]|f0)^0 ---*/
 _T1_BUILD_g0f0(Data,&(Libr12->ShellQuartet),r12vrr_stack+16828, r12vrr_stack+1074, r12vrr_stack+7426, r12vrr_stack+2049, r12vrr_stack+1599, r12vrr_stack+974);
 tmp = r12vrr_stack + 16828;
 target_ptr = Libr12->t1vrr_classes[4][3];
 for(i=0;i<150;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0|[r12,T1]|g0)^0 ---*/
 _T1_BUILD_g0g0(Data,&(Libr12->ShellQuartet),r12vrr_stack+588, r12vrr_stack+2049, r12vrr_stack+8101, r12vrr_stack+3429, r12vrr_stack+2799, r12vrr_stack+1599);
 tmp = r12vrr_stack + 588;
 target_ptr = Libr12->t1vrr_classes[4][4];
 for(i=0;i<225;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0|[r12,T1]|h0)^0 ---*/
 _T1_BUILD_g0h0(Data,&(Libr12->ShellQuartet),r12vrr_stack+1509, r12vrr_stack+3429, r12vrr_stack+9067, r12vrr_stack+5256, r12vrr_stack+4416, r12vrr_stack+2799);
 tmp = r12vrr_stack + 1509;
 target_ptr = Libr12->t1vrr_classes[4][5];
 for(i=0;i<315;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (g0|[r12,T1]|i0)^0 ---*/
 _T1_BUILD_g0i0(Data,&(Libr12->ShellQuartet),r12vrr_stack+20530, r12vrr_stack+5256, r12vrr_stack+10376, r12vrr_stack+11540, r12vrr_stack+6540, r12vrr_stack+4416);
 tmp = r12vrr_stack + 20530;
 target_ptr = Libr12->t1vrr_classes[4][6];
 for(i=0;i<420;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0|[r12,T1]|f0)^0 ---*/
 _T1_BUILD_h0f0(Data,&(Libr12->ShellQuartet),r12vrr_stack+2673, r12vrr_stack+7426, r12vrr_stack+12834, r12vrr_stack+8101, r12vrr_stack+2049, r12vrr_stack+1074);
 tmp = r12vrr_stack + 2673;
 target_ptr = Libr12->t1vrr_classes[5][3];
 for(i=0;i<210;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0|[r12,T1]|g0)^0 ---*/
 _T1_BUILD_h0g0(Data,&(Libr12->ShellQuartet),r12vrr_stack+20950, r12vrr_stack+8101, r12vrr_stack+13804, r12vrr_stack+9067, r12vrr_stack+3429, r12vrr_stack+2049);
 tmp = r12vrr_stack + 20950;
 target_ptr = Libr12->t1vrr_classes[5][4];
 for(i=0;i<315;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0|[r12,T1]|h0)^0 ---*/
 _T1_BUILD_h0h0(Data,&(Libr12->ShellQuartet),r12vrr_stack+8416, r12vrr_stack+9067, r12vrr_stack+15190, r12vrr_stack+10376, r12vrr_stack+5256, r12vrr_stack+3429);
 tmp = r12vrr_stack + 8416;
 target_ptr = Libr12->t1vrr_classes[5][5];
 for(i=0;i<441;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (h0|[r12,T1]|i0)^0 ---*/
 _T1_BUILD_h0i0(Data,&(Libr12->ShellQuartet),r12vrr_stack+5676, r12vrr_stack+10376, r12vrr_stack+17066, r12vrr_stack+18750, r12vrr_stack+11540, r12vrr_stack+5256);
 tmp = r12vrr_stack + 5676;
 target_ptr = Libr12->t1vrr_classes[5][6];
 for(i=0;i<588;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0|[r12,T1]|f0)^0 ---*/
 _T1_BUILD_i0f0(Data,&(Libr12->ShellQuartet),r12vrr_stack+11405, r12vrr_stack+12834, r12vrr_stack+20170, r12vrr_stack+13804, r12vrr_stack+8101, r12vrr_stack+7426);
 tmp = r12vrr_stack + 11405;
 target_ptr = Libr12->t1vrr_classes[6][3];
 for(i=0;i<280;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0|[r12,T1]|g0)^0 ---*/
 _T1_BUILD_i0g0(Data,&(Libr12->ShellQuartet),r12vrr_stack+6264, r12vrr_stack+13804, r12vrr_stack+21265, r12vrr_stack+15190, r12vrr_stack+9067, r12vrr_stack+8101);
 tmp = r12vrr_stack + 6264;
 target_ptr = Libr12->t1vrr_classes[6][4];
 for(i=0;i<420;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0|[r12,T1]|h0)^0 ---*/
 _T1_BUILD_i0h0(Data,&(Libr12->ShellQuartet),r12vrr_stack+3744, r12vrr_stack+15190, r12vrr_stack+22393, r12vrr_stack+17066, r12vrr_stack+10376, r12vrr_stack+9067);
 tmp = r12vrr_stack + 3744;
 target_ptr = Libr12->t1vrr_classes[6][5];
 for(i=0;i<588;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0|[r12,T1]|i0)^0 ---*/
 _T1_BUILD_i0i0(Data,&(Libr12->ShellQuartet),r12vrr_stack+25949, r12vrr_stack+17066, r12vrr_stack+23933, r12vrr_stack+24941, r12vrr_stack+18750, r12vrr_stack+10376);
 tmp = r12vrr_stack + 25949;
 target_ptr = Libr12->t1vrr_classes[6][6];
 for(i=0;i<784;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0||f0)^0 ---*/
 _R_BUILD_i0f0(Data,r12vrr_stack+22393, r12vrr_stack+2463, r12vrr_stack+1359, r12vrr_stack+12834, r12vrr_stack+7426, r12vrr_stack+1074, r12vrr_stack+6990);
 tmp = r12vrr_stack + 22393;
 target_ptr = Libr12->rvrr_classes[6][3];
 for(i=0;i<280;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0||g0)^0 ---*/
 _R_BUILD_i0g0(Data,r12vrr_stack+22673, r12vrr_stack+14483, r12vrr_stack+14258, r12vrr_stack+13804, r12vrr_stack+8101, r12vrr_stack+2049, r12vrr_stack+7426);
 tmp = r12vrr_stack + 22673;
 target_ptr = Libr12->rvrr_classes[6][4];
 for(i=0;i<420;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0||h0)^0 ---*/
 _R_BUILD_i0h0(Data,r12vrr_stack+1824, r12vrr_stack+18165, r12vrr_stack+17850, r12vrr_stack+15190, r12vrr_stack+9067, r12vrr_stack+3429, r12vrr_stack+8101);
 tmp = r12vrr_stack + 1824;
 target_ptr = Libr12->rvrr_classes[6][5];
 for(i=0;i<588;i++)
   target_ptr[i] += tmp[i];

 /*--- compute (i0||i0)^0 ---*/
 _R_BUILD_i0i0(Data,r12vrr_stack+17850, r12vrr_stack+21805, r12vrr_stack+3009, r12vrr_stack+17066, r12vrr_stack+10376, r12vrr_stack+5256, r12vrr_stack+9067);
 tmp = r12vrr_stack + 17850;
 target_ptr = Libr12->rvrr_classes[6][6];
 for(i=0;i<784;i++)
   target_ptr[i] += tmp[i];


}

